Sundials.jl
===========

[![Join the chat at https://gitter.im/JuliaDiffEq/Lobby](https://badges.gitter.im/JuliaDiffEq/Lobby.svg)](https://gitter.im/JuliaDiffEq/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![Tests](https://github.com/SciML/Sundials.jl/actions/workflows/Tests.yml/badge.svg)](https://github.com/SciML/Sundials.jl/actions/workflows/Tests.yml)
[![codecov](https://codecov.io/gh/SciML/Sundials.jl/graph/badge.svg?token=6YBolQDTjf)](https://codecov.io/gh/SciML/Sundials.jl)

Introduction
------------

Sundials.jl is a Julia package that interfaces to the
[Sundials](https://computing.llnl.gov/projects/sundials)
library (see [source](https://github.com/LLNL/sundials)).
Sundials (the C library and this package) provides the
following:

* *CVODES* - for integration and sensitivity analysis of ODEs.
          CVODES treats stiff and nonstiff ODE systems of the form
          `y' = f(t,y,p), y(t0) = y0(p)`,
          where `p` is a set of parameters.
* *ARKStep* - for integration of non-stiff, stiff, and mixed mode
          ODEs via split, linearly-implicit form, implicit, and IMEX Runge-Kutta
          methods on ODEs of the form `My' = f_E(t,y,p) + f_i(t,y,p), y(t0) = y0(p)`
          for a set of parameters `p`.
* *ERKStep* - for integration of non-stiff, stiff, and mixed mode
          ODEs via split, linearly-implicit form, implicit, and IMEX Runge-Kutta
          methods on ODEs of the form `y' = f(t,y,p), y(t0) = y0(p)`
          for a set of parameters `p`.
* *IDAS*   - for integration and sensitivity analysis of DAEs.
          IDAS treats DAE systems of the form
          `F(t,y,y',p) = 0, y(t0) = y0(p), y'(t0) = y0'(p)`
* *KINSOL* - for solution of nonlinear algebraic systems.
          KINSOL treats nonlinear systems of the form
          `F(u) = 0`

Note that *CVODES* and *IDAS* contain all functions provided by *CVODE* and *IDA* (for integration
without sensitivity analysis). If you need to use the latter, you can set `enable_sensitivities=false`
in `deps/build.jl` and (re)build the package.

Installation
---

Within Julia, use the package manager:
```julia
using Pkg
Pkg.add("Sundials")
```

To test the installation use
```julia
using Pkg
Pkg.test("Sundials")
```

Common Interface API
--------------------

This package is part of the JuliaDiffEq common interface. This is documented in [the DifferentialEquations.jl documentation](http://diffeq.sciml.ai/latest/index.html). Thus [the ODE tutorial](http://diffeq.sciml.ai/latest/tutorials/ode_example.html) applies. For example, the Lorenz attractor can be solved with `CVODE_Adams` as follows:

```julia
using Sundials
function lorenz(du,u,p,t)
 du[1] = 10.0(u[2]-u[1])
 du[2] = u[1]*(28.0-u[3]) - u[2]
 du[3] = u[1]*u[2] - (8/3)*u[3]
end
u0 = [1.0;0.0;0.0]
tspan = (0.0,100.0)
prob = ODEProblem(lorenz,u0,tspan)
sol = solve(prob,CVODE_Adams())
using Plots; plot(sol,vars=(1,2,3))
```

Sundials.jl exports the `CVODE_BDF`, `CVODE_Adams`, and `ARKODE` methods for
ODEs which are documented
[in the ODE Solvers page](https://diffeq.sciml.ai/latest/solvers/ode_solve/#ode_solve_sundials-1), and `IDA` which is documented
[in the DAE solvers page](https://diffeq.sciml.ai/latest/solvers/dae_solve/#Sundials.jl-1).
Additionally, the `ARKODE` method can be used
[on `SplitODEProblem`s](https://diffeq.sciml.ai/latest/solvers/split_ode_solve/)
to solve ODEs in IMEX form.

KINSOL High Level API
------------------------

Along with the ODE solvers, Sundials contains the KINSOL nonlinear solver.
It's called via:

```julia
kinsol(f, y0::Vector{Float64};
                userdata::Any = nothing,
                linear_solver=:Dense, jac_upper=0, jac_lower=0)
```

where `f(res,y)` is an in-place function that computes the residual `f(y)-res=0`,
and KINSOL attempts to find `y` such that `res=0`. This method is generally
quite fast and the choice `linear_solver=:Band` is well-suited for problems
with a banded Jacobian (you must specify the upper and lower band sizes). However,
this is not as robust as many other techniques like trust-region methods, and
thus we recommend [NLsolve.jl](https://github.com/JuliaNLSolvers/NLsolve.jl) for
more general nonlinear solving.

Direct API
---

This package closely follows the Sundials C API. At a slightly higher
level, many (but not all) Sundials.jl functions support passing Julia
objects (like `Array`s) instead of Sundials objects (like `N_Vector`s).
The Julia package [Clang.jl](https://github.com/ihnorton/Clang.jl) was
used to wrap Sundials. This directly uses Sundials' headers sort-of
like SWIG. Thus the general
[C documentation](https://sundials.readthedocs.io/en/latest/)
is the documentation for the direct API. See the
[test directory](https://github.com/JuliaLang/Sundials.jl/blob/master/test) for usage examples
of the direct interface.

For the wrapping
code, see
[src/wrap_sundials.jl](https://github.com/JuliaLang/Sundials.jl/blob/master/src/wrap_sundials.jl).
Because of Clang.jl, Sundials.jl provides almost full coverage of the Sundials library
(the serial version). A few things to note:

* Macros like `DENSE_ELEM` are not available.
* Nothing is exported from the module. You need to put `Sundials.`
  in front of everything.
* The parallel versions of Sundials which require different `N_Vector`
  types have not been wrapped.

Citing
------

If you use this library, please cite both Sundials and the JuliaDiffEq project.

```
@article{rackauckas2017differentialequations,
  title={Differentialequations. jl--a performant and feature-rich ecosystem for solving differential equations in julia},
  author={Rackauckas, Christopher and Nie, Qing},
  journal={Journal of Open Research Software},
  volume={5},
  number={1},
  year={2017},
  publisher={Ubiquity Press}
}

@article{gardner2022sundials,
  title={Enabling new flexibility in the {SUNDIALS} suite of nonlinear and differential/algebraic equation solvers},
  author={Gardner, David J and Reynolds, Daniel R and Woodward, Carol S and Balos, Cody J},
  journal={ACM Transactions on Mathematical Software (TOMS)},
  publisher={ACM},
  year={2022},
  doi={10.1145/3539801}
}

@article{hindmarsh2005sundials,
  title={{SUNDIALS}: Suite of nonlinear and differential/algebraic equation solvers},
  author={Hindmarsh, Alan C and Brown, Peter N and Grant, Keith E and Lee, Steven L and Serban, Radu and Shumaker, Dan E and Woodward, Carol S},
  journal={ACM Transactions on Mathematical Software (TOMS)},
  volume={31},
  number={3},
  pages={363--396},
  year={2005},
  publisher={ACM}
}
```

using Sundials
using SafeTestsets
using Test

@testset "Generator" begin
    include("generator.jl")
end

@testset "CVODE" begin
    @safetestset "Roberts CVODE Simplified" begin
        include("cvode_Roberts_simplified.jl")
    end
    @safetestset "Roberts CVODE Direct" begin
        include("cvode_Roberts_dns.jl")
    end
    @safetestset "CVODES Direct" begin
        include("cvodes_dns.jl")
    end
    @safetestset "CVODES Adjoint" begin
        include("cvodes_adjoint.jl")
    end
end

@testset "IDA" begin
    @safetestset "Roberts IDA Simplified" begin
        include("ida_Roberts_simplified.jl")
    end
    @safetestset "Roberts IDA Direct" begin
        include("ida_Roberts_dns.jl")
    end
    @safetestset "Heat IDA Direct" begin
        include("ida_Heat2D.jl")
    end
    @safetestset "IDAS Forward" begin
        include("idas_forward.jl")
    end
    @safetestset "IDAS Adjoint" begin
        include("idas_adjoint.jl")
    end
    # Commented out because still uses the syntax from Grid which is a deprecated package
    #@testset "Cable IDA Direct" begin include("ida_Cable.jl") end
end

@testset "ARK" begin
    @safetestset "Roberts ARKStep Direct" begin
        include("arkstep_Roberts_dns.jl")
    end
    @safetestset "NonLinear ERKStep Direct" begin
        include("erkstep_nonlin.jl")
    end
    #@testset "MRI two way couple" begin include("mri_twowaycouple.jl") end
end

@testset "Kinsol" begin
    @safetestset "Kinsol Simplified" begin
        include("kinsol_mkin_simplified.jl")
    end
    @safetestset "Kinsol MKin" begin
        include("kinsol_mkinTest.jl")
    end
    @safetestset "Kinsol Banded" begin
        include("kinsol_banded.jl")
    end
    @safetestset "Kinsol NonlinearSolve" begin
        include("kinsol_nonlinear_solve.jl")
    end
end

@testset "Handle Tests" begin
    include("handle_tests.jl")
end

@testset "Common Interface" begin
    @safetestset "CVODE" begin
        include("common_interface/cvode.jl")
    end
    @safetestset "ARKODE" begin
        include("common_interface/arkode.jl")
    end
    @safetestset "IDA" begin
        include("common_interface/ida.jl")
    end
    @safetestset "Jacobians" begin
        include("common_interface/jacobians.jl")
    end
    @safetestset "Callbacks" begin
        include("common_interface/callbacks.jl")
    end
    @safetestset "Iterator" begin
        include("common_interface/iterators.jl")
    end
    @safetestset "Errors" begin
        include("common_interface/errors.jl")
    end
    @safetestset "Mass Matrix" begin
        include("common_interface/mass_matrix.jl")
    end
    @safetestset "Preconditioners" begin
        include("common_interface/precs.jl")
    end
    @safetestset "Initialization" begin
        include("common_interface/initialization.jl")
    end
    @safetestset "Verbosity" begin
        include("common_interface/verbosity.jl")
    end
end

@testset "Interpolation" begin
    include("interpolation.jl")
end

# __precompile__()

module Sundials

import Reexport
Reexport.@reexport using SciMLBase
using DiffEqBase: DiffEqBase, NonlinearFunction, ODEFunction, add_saveat!,
    add_tstop!, change_t_via_interpolation!, check_error,
    check_keywords, get_du, get_du!, get_tmp_cache, get_tstops,
    get_tstops_array, initialize!, isinplace,
    reeval_internals_due_to_modification!, reinit!, savevalues!,
    set_proposed_dt!, solve, solve!, step!, terminate!,
    update_coefficients!, warn_compat, DefaultInit, BrownFullBasicInit,
    ShampineCollocationInit, DEVerbosity
using SciMLLogging: SciMLLogging, Standard, @SciMLMessage
using SciMLBase: AbstractSciMLOperator, DAEProblem, ODEProblem, ReturnCode,
    SciMLBase, SplitODEProblem, VectorContinuousCallback
import Accessors: @reset
import ArrayInterface
import SymbolicIndexingInterface as SII
import SymbolicIndexingInterface: ParameterIndexingProxy
using DataStructures: DataStructures
using Logging: Logging
using SparseArrays: SparseArrays
using LinearAlgebra: LinearAlgebra


import NonlinearSolveBase # Required for KINSOL definition to NonlinearSolve
import LinearSolve # Required for initialization

using Libdl: Libdl
using CEnum: CEnum, @cenum

const warnkeywords = (
    :isoutofdomain,
    :unstable_check,
    :calck,
    :internalnorm,
    :gamma,
    :beta1,
    :beta2,
    :qmax,
    :qmin,
    :qoldinit,
)

warnlist = Set(warnkeywords)
warnida = union(warnlist, Set((:dtmin,)))

using Sundials_jll: Sundials_jll, libsundials_core,
    libsundials_arkode, libsundials_cvodes,
    libsundials_idas, libsundials_kinsol, libsundials_nvecserial,
    libsundials_sunlinsolband, libsundials_sunlinsoldense,
    libsundials_sunlinsolklu, libsundials_sunlinsollapackband,
    libsundials_sunlinsollapackdense, libsundials_sunlinsolpcg,
    libsundials_sunlinsolspbcgs, libsundials_sunlinsolspfgmr,
    libsundials_sunlinsolspgmr, libsundials_sunlinsolsptfqmr,
    libsundials_sunmatrixband, libsundials_sunmatrixdense,
    libsundials_sunmatrixsparse, libsundials_sunnonlinsolfixedpoint,
    libsundials_sunnonlinsolnewton

export solve,
    SundialsODEAlgorithm, SundialsDAEAlgorithm, ARKODE, CVODE_BDF, CVODE_Adams, IDA,
    KINSOL, DefaultInit, BrownFullBasicInit, ShampineCollocationInit

# some definitions from the system C headers wrapped into the types_and_consts.jl
const DBL_MAX = prevfloat(Inf)
const DBL_MIN = nextfloat(-Inf)
const DBL_EPSILON = eps(Cdouble)
const int64_t = Int64
const MPI_DOUBLE = nothing
const MPI_INT64_T = nothing
macro SUNDIALS_F77_FUNC(name, NAME)
    return Symbol(string(name) * "_64_")
end

const SPARSE_SOLVERS = (:KLU,)

include("../lib/libsundials_common.jl")
include("types_and_consts_additions.jl")

include("handle.jl")
include("nvector_wrapper.jl")

include("../lib/libsundials_api.jl")

for ff in names(@__MODULE__; all = true)
    fname = string(ff)
    if occursin("SetLinearSolver", fname) &&
            !occursin("#", fname) && # filter out compiler generated names
            !occursin("Dls", fname) && !occursin("Spils", fname) # filter out old names
        @eval function $ff(mem, LS::SUNLinearSolver, A::Ptr, args...)
            return $ff(
                mem, LS,
                convert(SUNMatrix, A),
                args...
            )
        end
    end
end

include("simple.jl")
include("common_interface/function_types.jl")
include("common_interface/verbosity.jl")
include("common_interface/algorithms.jl")
include("common_interface/integrator_types.jl")
include("common_interface/integrator_utils.jl")
include("common_interface/initialize.jl")
include("common_interface/solve.jl")

import PrecompileTools

PrecompileTools.@compile_workload begin
    function lorenz(du, u, p, t)
        du[1] = 10.0(u[2] - u[1])
        du[2] = u[1] * (28.0 - u[3]) - u[2]
        du[3] = u[1] * u[2] - (8 / 3) * u[3]
    end

    function lorenz_oop(u, p, t)
        [10.0(u[2] - u[1]), u[1] * (28.0 - u[3]) - u[2], u[1] * u[2] - (8 / 3) * u[3]]
    end

    solver_list = [
        ARKODE(), CVODE_Adams(), CVODE_BDF(),
    ]

    prob_list = [
        ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0)),
        ODEProblem(lorenz, [1.0; 0.0; 0.0], (0.0, 1.0), Float64[]),
    ]

    for prob in prob_list, solver in solver_list

        solve(prob, solver)(0.5)
    end

    prob_list = nothing

    function f(out, du, u, p, t)
        out[1] = -0.04u[1] + 1.0e4 * u[2] * u[3] - du[1]
        out[2] = +0.04u[1] - 3.0e7 * u[2]^2 - 1.0e4 * u[2] * u[3] - du[2]
        out[3] = u[1] + u[2] + u[3] - 1.0
    end
    u₀ = [1.0, 0, 0]
    du₀ = [-0.04, 0.04, 0.0]
    tspan = (0.0, 100000.0)
    differential_vars = [true, true, false]
    prob = DAEProblem(f, du₀, u₀, tspan, differential_vars = differential_vars)
    sol = solve(prob, IDA())

    prob = nothing
end

##################################################################
# Deprecations
##################################################################

end # module

using Sundials, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

prob = prob_ode_2Dlinear
integrator = init(prob, CVODE_BDF())
step!(integrator)
integrator(integrator.t, Val{1})

for i in integrator
    @info i.t
end

integrator.t == 1.0
step!(integrator)
integrator.t > 1.0

reinit!(integrator)
solve!(integrator)
u1 = copy(integrator.u)
reinit!(integrator)
solve!(integrator)
u2 = copy(integrator.u)
@test u1 != vec(prob.u0)
@test u1 == u2

f_terminate(u, p, t) = [2 * u[1]]
u_positive(u, t, integrator) = u[1] > 0
terminate_if_u_pos = DiscreteCallback(u_positive, terminate!)

prob = ODEProblem(f_terminate, [1.0], (0.0, 1.0)) # positive initial condition > positive u > Terminated
integrator = init(prob, CVODE_BDF(); callback = terminate_if_u_pos)
sol1 = solve!(integrator)
@test sol1.retcode == ReturnCode.Terminated

reinit!(integrator, [-1.0]) # negative initial condition > negative u > Success!
sol2 = solve!(integrator)
@test sol2.retcode == ReturnCode.Success

prob = ODEProblem(f_terminate, [-1.0], (0.0, 1.0)) # negative initial condition > negative u > Success!
integrator = init(prob, CVODE_BDF(); callback = terminate_if_u_pos)
sol3 = solve!(integrator)
@test sol3.retcode == ReturnCode.Success

# These are the additions to the types_and_consts.jl file not from clang.jl

function Base.convert(::Type{Matrix}, J::DlsMat)
    _dlsmat = unsafe_load(J)
    # own is false as memory is allocated by sundials
    return unsafe_wrap(Array, _dlsmat.data, (_dlsmat.M, _dlsmat.N); own = false)
end

function Base.convert(::Type{Matrix}, J::SUNMatrix)
    _sunmat = unsafe_load(J)
    _mat = convert(SUNMatrixContent_Dense, _sunmat.content)
    mat = unsafe_load(_mat)
    # own is false as memory is allocated by sundials
    return unsafe_wrap(Array, mat.data, (mat.M, mat.N); own = false)
end

# sparse SUNMatrix uses zero-offset indices, so provide copyto!, not convert
function Base.copyto!(Asun::SUNMatrix, Acsc::SparseArrays.SparseMatrixCSC{Float64, Int64})
    _sunmat = unsafe_load(Asun)
    _mat = convert(SUNMatrixContent_Sparse, _sunmat.content)
    mat = unsafe_load(_mat)
    # own is false as memory is allocated by sundials
    indexvals = unsafe_wrap(Vector{Int}, mat.indexvals, (mat.NNZ); own = false)
    indexptrs = unsafe_wrap(Vector{Int}, mat.indexptrs, (mat.NP + 1); own = false)
    data = unsafe_wrap(Vector{Float64}, mat.data, (mat.NNZ); own = false)

    if size(indexvals) != size(Acsc.rowval) || size(indexptrs) != size(Acsc.colptr)
        error("Sparsity Pattern in receiving SUNMatrix doesn't match sending SparseMatrix")
    end

    @. indexvals = Acsc.rowval - 1
    @. indexptrs = Acsc.colptr - 1
    data .= Acsc.nzval

    return nothing
end

abstract type SundialsMatrix end
struct DenseMatrix <: SundialsMatrix end
struct BandMatrix <: SundialsMatrix end
struct SparseMatrix <: SundialsMatrix end

abstract type SundialsLinearSolver end
struct Dense <: SundialsLinearSolver end
struct Band <: SundialsLinearSolver end
struct SPGMR <: SundialsLinearSolver end
struct SPFGMR <: SundialsLinearSolver end
struct SPBCGS <: SundialsLinearSolver end
struct PCG <: SundialsLinearSolver end
struct PTFQMR <: SundialsLinearSolver end
struct KLU <: SundialsLinearSolver end
struct LapackBand <: SundialsLinearSolver end
struct LapackDense <: SundialsLinearSolver end

abstract type SundialsNonLinearSolver end
struct Newton <: SundialsNonLinearSolver end
struct FixedPoint <: SundialsNonLinearSolver end

abstract type StiffnessChoice end
struct Explicit <: StiffnessChoice end
struct Implicit <: StiffnessChoice end

using Sundials, SciMLLogging, Test
import ODEProblemLibrary: prob_ode_linear

prob = prob_ode_linear

# Default (Standard preset) — should work without warnings
sol = solve(prob, CVODE_BDF())
@test sol.retcode == ReturnCode.Success

# Explicit Standard preset
sol = solve(prob, CVODE_BDF(), verbose = SciMLLogging.Standard())
@test sol.retcode == ReturnCode.Success

# Explicit None preset — no output
sol = solve(prob, CVODE_BDF(), verbose = SciMLLogging.None())
@test sol.retcode == ReturnCode.Success

# Bool true — maps to DEVerbosity(Standard)
sol = solve(prob, CVODE_BDF(), verbose = true)
@test sol.retcode == ReturnCode.Success

# Bool false — maps to DEVerbosity(None)
sol = solve(prob, CVODE_BDF(), verbose = false)
@test sol.retcode == ReturnCode.Success

# ARKODE
sol = solve(prob, ARKODE(), verbose = false)
@test sol.retcode == ReturnCode.Success

# IDA
function robertson(out, du, u, _, _)
    out[1] = -0.04u[1] + 1.0e4 * u[2] * u[3] - du[1]
    out[2] = +0.04u[1] - 3.0e7 * u[2]^2 - 1.0e4 * u[2] * u[3] - du[2]
    return out[3] = u[1] + u[2] + u[3] - 1.0
end
dae_prob = DAEProblem(
    robertson, [-0.04, 0.04, 0.0], [1.0, 0.0, 0.0], (0.0, 1.0e5),
    differential_vars = [true, true, false]
)
sol = solve(dae_prob, IDA(), verbose = false)
@test sol.retcode == ReturnCode.Success

"""
   Wrapper for Sundials `N_Vector` that
   uses Julia `Vector{realtype}` as the data container.

   Implements `DenseVector` interface and
   manages automatic destruction of the referenced `N_Vector` when it is
   no longer in use.

   NB: can be supplied to ccall when an N_Vector is required
   (ie implements cconvert / unsafe_convert).
"""
mutable struct NVector <: DenseVector{realtype}
    n_v::N_Vector           # reference (C pointer) to N_Vector
    v::Vector{realtype}     # array that is referenced by N_Vector
    ctx::SUNContext         # SUNContext for this NVector

    function NVector(v::Vector{realtype}, ctx::SUNContext)
        # note that N_VMake_Serial() creates N_Vector doesn't own the data,
        # so calling N_VDestroy_Serial() would not deallocate v
        nv = new(N_VMake_Serial(length(v), v, ctx), v, ctx)
        finalizer(release_handle, nv)
        return nv
    end

    function NVector(n_v::N_Vector, ctx::SUNContext = C_NULL)
        # wrap N_Vector into NVector and get non-owning access to `nv` data
        # via `v`, but don't register finalizer for `nv`
        # ctx is C_NULL for wrapped N_Vectors that don't own their context
        return new(n_v, asarray(n_v), ctx)
    end
end

function release_handle(nv::NVector)
    return N_VDestroy_Serial(nv.n_v)
    # Don't free context here - it will be freed by the integrator
end

Base.size(nv::NVector, d...) = size(nv.v, d...)
Base.stride(nv::NVector, d::Integer) = stride(nv.v, d)

Base.getindex(nv::NVector, i::Real) = getindex(nv.v, i)
Base.getindex(nv::NVector, i::AbstractArray) = getindex(nv.v, i)
Base.getindex(nv::NVector, inds...) = getindex(nv.v, inds...)

Base.setindex!(nv::NVector, X, i::Real) = setindex!(nv.v, X, i)
Base.setindex!(nv::NVector, X, i::AbstractArray) = setindex!(nv.v, X, i)
Base.setindex!(nv::NVector, X, inds...) = setindex!(nv.v, X, inds...)

Base.pointer(nv::NVector) = Sundials.N_VGetArrayPointer_Serial(nv.n_v)

##################################################################
#
# Methods to convert between Julia Vectors and Sundials N_Vectors.
# NB uses:
# - convert to convert to NVector
# - cconvert / unsafe_convert to convert to N_Vector (for use within a ccall only)
##################################################################

# Conversion from vectors to NVector requires context
function Base.convert(::Type{NVector}, v::Vector{realtype})
    error("Cannot convert Vector to NVector without context. Use NVector(v, ctx) instead.")
end
function Base.convert(::Type{NVector}, v::Vector{T}) where {T <: Real}
    error("Cannot convert Vector to NVector without context. Use NVector(v, ctx) instead.")
end
function Base.convert(::Type{NVector}, v::AbstractVector)
    error("Cannot convert AbstractVector to NVector without context. Use NVector(v, ctx) instead.")
end
Base.convert(::Type{NVector}, nv::NVector) = nv
Base.convert(::Type{NVector}, v::Vector{realtype}, ctx::SUNContext) = NVector(v, ctx)
Base.convert(::Type{Vector{realtype}}, nv::NVector) = nv.v
Base.convert(::Type{Vector}, nv::NVector) = nv.v

""" 
    Base.cconvert(::Type{N_Vector}, v::Vector{realtype}) -> NVector
    Base.unsafe_convert(::Type{N_Vector}, nv::NVector) -> N_Vector

Convert v to N_Vector, for use by ccall

(NB: actually implemented to convert any Julia Vector v, although only v::NVector is needed?)

Conversion happens in two steps within ccall:
 - cconvert to convert to temporary NVector, which is preserved (by ccall) from garbage collection
 - unsafe_convert to get the N_Vector pointer from the temporary NVector
"""
Base.cconvert(::Type{N_Vector}, nv::NVector) = nv
Base.unsafe_convert(::Type{N_Vector}, nv::NVector) = nv.n_v

"""
    NVectorArray(nvectors)

Keep a vector of `NVector`s and the corresponding `N_Vector*` pointer array
alive together for SUNDIALS APIs that take arrays of `N_Vector`.
"""
struct NVectorArray <: AbstractVector{N_Vector}
    nvectors::Vector{NVector}
    ptrs::Vector{N_Vector}
end

function NVectorArray(nvectors::AbstractVector{<:NVector})
    owned_nvectors = collect(nvectors)
    return NVectorArray(
        owned_nvectors,
        N_Vector[Base.unsafe_convert(N_Vector, nv) for nv in owned_nvectors],
    )
end

Base.size(nva::NVectorArray) = size(nva.ptrs)
Base.IndexStyle(::Type{<:NVectorArray}) = IndexLinear()
Base.getindex(nva::NVectorArray, i::Int) = getindex(nva.ptrs, i)
Base.pointer(nva::NVectorArray) = pointer(nva.ptrs)
Base.cconvert(::Type{Ptr{N_Vector}}, nva::NVectorArray) = nva
Base.unsafe_convert(::Type{Ptr{N_Vector}}, nva::NVectorArray) = pointer(nva)

Base.similar(nv::NVector) = NVector(similar(nv.v), nv.ctx)

nvlength(x::N_Vector) = unsafe_load(unsafe_load(convert(Ptr{Ptr{Clong}}, x)))
# asarray() creates an array pointing to N_Vector data, but does not take the ownership
@inline function asarray(x::N_Vector)
    return unsafe_wrap(
        Array, N_VGetArrayPointer_Serial(x),
        (nvlength(x),); own = false
    )
end
@inline function asarray(x::N_Vector, dims::Tuple)
    return unsafe_wrap(
        Array, N_VGetArrayPointer_Serial(x),
        dims; own = false
    )
end
asarray(x::Vector{realtype}) = x
asarray(x::Ptr{realtype}, dims::Tuple) = unsafe_wrap(Array, x, dims; own = false)
@inline Base.convert(::Type{Vector{realtype}}, x::N_Vector) = asarray(x)
@inline Base.convert(::Type{Vector}, x::N_Vector) = asarray(x)

## This uses the simplified kinsol interface.
## Results should match that in kinsol_kminTest.jl.

using Sundials

function sysfn(fy, y)
    fy[1] = y[1]^2 + y[2]^2 - 1.0
    return fy[2] = y[2] - y[1]^2
end

res = Sundials.kinsol(sysfn, ones(2))

using Sundials, Test, LinearAlgebra

# create mass matrix problems
function make_mm_probs(mm_A, ::Type{Val{iip}}) where {iip}
    # iip
    mm_b = vec(sum(mm_A; dims = 2))
    function mm_f(du, u, p, t)
        LinearAlgebra.mul!(du, mm_A, u)
        du .+= t * mm_b
        return nothing
    end
    mm_g(du, u, p, t) = (@. du = u + t; nothing)

    # oop
    mm_f(u, p, t) = mm_A * u .+ t * mm_b
    mm_g(u, p, t) = u .+ t

    mm_analytic(u0, p, t) = @. 2 * u0 * exp(t) - t - 1

    u0 = ones(3)
    tspan = (0.0, 1.0)

    prob = ODEProblem(
        ODEFunction{iip, true}(
            mm_f; analytic = mm_analytic,
            mass_matrix = mm_A
        ),
        u0,
        tspan
    )
    prob2 = ODEProblem(ODEFunction{iip, true}(mm_g; analytic = mm_analytic), u0, tspan)

    return prob, prob2
end

mm_A = Float64[-2 1 4; 4 -2 1; 2 1 3]
prob, prob2 = make_mm_probs(mm_A, Val{true})

sol = solve(prob, ARKODE(); abstol = 1.0e-8, reltol = 1.0e-8)
sol2 = solve(prob2, ARKODE(); abstol = 1.0e-8, reltol = 1.0e-8)

# Compare solutions at common time points since they may have different internal timesteps
# The adaptive timestepping may choose different points internally
t_common = range(0.0, 1.0, length = 100)
max_diff = maximum(norm(sol(t) - sol2(t)) for t in t_common)
@test max_diff < 1.0e-7

# SUNContext support for SUNDIALS 6.0+
const SUNContext = Ptr{Cvoid}

# SUNContext functions
function SUNContext_Create(comm::Ptr{Cvoid}, ctx::Ptr{SUNContext})
    return ccall(
        (:SUNContext_Create, libsundials_core), Cint,
        (Ptr{Cvoid}, Ptr{SUNContext}), comm, ctx
    )
end

function SUNContext_Free(ctx::SUNContext)
    ctx_ptr = Ref(ctx)
    return ccall((:SUNContext_Free, libsundials_core), Cint, (Ptr{SUNContext},), ctx_ptr)
end

struct klu_l_symbolic
    symmetry::Cdouble
    est_flops::Cdouble
    lnz::Cdouble
    unz::Cdouble
    Lnz::Ptr{Cdouble}
    n::Clong
    nz::Clong
    P::Ptr{Clong}
    Q::Ptr{Clong}
    R::Ptr{Clong}
    nzoff::Clong
    nblocks::Clong
    maxblock::Clong
    ordering::Clong
    do_btf::Clong
    structural_rank::Clong
end

struct klu_l_numeric
    n::Clong
    nblocks::Clong
    lnz::Clong
    unz::Clong
    max_lnz_block::Clong
    max_unz_block::Clong
    Pnum::Ptr{Clong}
    Pinv::Ptr{Clong}
    Lip::Ptr{Clong}
    Uip::Ptr{Clong}
    Llen::Ptr{Clong}
    Ulen::Ptr{Clong}
    LUbx::Ptr{Ptr{Cvoid}}
    LUsize::Ptr{Csize_t}
    Udiag::Ptr{Cvoid}
    Rs::Ptr{Cdouble}
    worksize::Csize_t
    Work::Ptr{Cvoid}
    Xwork::Ptr{Cvoid}
    Iwork::Ptr{Clong}
    Offp::Ptr{Clong}
    Offi::Ptr{Clong}
    Offx::Ptr{Cvoid}
    nzoff::Clong
end

struct klu_l_common_struct
    tol::Cdouble
    memgrow::Cdouble
    initmem_amd::Cdouble
    initmem::Cdouble
    maxwork::Cdouble
    btf::Clong
    ordering::Clong
    scale::Clong
    user_order::Ptr{Cvoid}
    user_data::Ptr{Cvoid}
    halt_if_singular::Clong
    status::Clong
    nrealloc::Clong
    structural_rank::Clong
    numerical_rank::Clong
    singular_col::Clong
    noffdiag::Clong
    flops::Cdouble
    rcond::Cdouble
    condest::Cdouble
    rgrowth::Cdouble
    work::Cdouble
    memusage::Csize_t
    mempeak::Csize_t
end

const klu_l_common = klu_l_common_struct

# typedef int ( * ARKRhsFn ) ( realtype t , N_Vector y , N_Vector ydot , void * user_data )
const ARKRhsFn = Ptr{Cvoid}

# typedef int ( * ARKRootFn ) ( realtype t , N_Vector y , realtype * gout , void * user_data )
const ARKRootFn = Ptr{Cvoid}

# typedef int ( * ARKEwtFn ) ( N_Vector y , N_Vector ewt , void * user_data )
const ARKEwtFn = Ptr{Cvoid}

# typedef int ( * ARKRwtFn ) ( N_Vector y , N_Vector rwt , void * user_data )
const ARKRwtFn = Ptr{Cvoid}

# typedef void ( * ARKErrHandlerFn ) ( int error_code , const char * module , const char * function , char * msg , void * user_data )
const ARKErrHandlerFn = Ptr{Cvoid}

# typedef int ( * ARKAdaptFn ) ( N_Vector y , realtype t , realtype h1 , realtype h2 , realtype h3 , realtype e1 , realtype e2 , realtype e3 , int q , int p , realtype * hnew , void * user_data )
const ARKAdaptFn = Ptr{Cvoid}

# typedef int ( * ARKExpStabFn ) ( N_Vector y , realtype t , realtype * hstab , void * user_data )
const ARKExpStabFn = Ptr{Cvoid}

# typedef int ( * ARKVecResizeFn ) ( N_Vector y , N_Vector ytemplate , void * user_data )
const ARKVecResizeFn = Ptr{Cvoid}

# typedef int ( * ARKPostProcessFn ) ( realtype t , N_Vector y , void * user_data )
const ARKPostProcessFn = Ptr{Cvoid}

# typedef int ( * ARKPostProcessStepFn ) ( realtype t , N_Vector y , void * user_data )
const ARKPostProcessStepFn = Ptr{Cvoid}

# typedef int ( * ARKStepStagePredictFn ) ( realtype t , N_Vector zpred , void * user_data )
const ARKStepStagePredictFn = Ptr{Cvoid}

const realtype = Cdouble

struct _generic_N_Vector_Ops
    nvgetvectorid::Ptr{Cvoid}
    nvclone::Ptr{Cvoid}
    nvcloneempty::Ptr{Cvoid}
    nvdestroy::Ptr{Cvoid}
    nvspace::Ptr{Cvoid}
    nvgetarraypointer::Ptr{Cvoid}
    nvsetarraypointer::Ptr{Cvoid}
    nvgetcommunicator::Ptr{Cvoid}
    nvgetlength::Ptr{Cvoid}
    nvlinearsum::Ptr{Cvoid}
    nvconst::Ptr{Cvoid}
    nvprod::Ptr{Cvoid}
    nvdiv::Ptr{Cvoid}
    nvscale::Ptr{Cvoid}
    nvabs::Ptr{Cvoid}
    nvinv::Ptr{Cvoid}
    nvaddconst::Ptr{Cvoid}
    nvdotprod::Ptr{Cvoid}
    nvmaxnorm::Ptr{Cvoid}
    nvwrmsnorm::Ptr{Cvoid}
    nvwrmsnormmask::Ptr{Cvoid}
    nvmin::Ptr{Cvoid}
    nvwl2norm::Ptr{Cvoid}
    nvl1norm::Ptr{Cvoid}
    nvcompare::Ptr{Cvoid}
    nvinvtest::Ptr{Cvoid}
    nvconstrmask::Ptr{Cvoid}
    nvminquotient::Ptr{Cvoid}
    nvlinearcombination::Ptr{Cvoid}
    nvscaleaddmulti::Ptr{Cvoid}
    nvdotprodmulti::Ptr{Cvoid}
    nvlinearsumvectorarray::Ptr{Cvoid}
    nvscalevectorarray::Ptr{Cvoid}
    nvconstvectorarray::Ptr{Cvoid}
    nvwrmsnormvectorarray::Ptr{Cvoid}
    nvwrmsnormmaskvectorarray::Ptr{Cvoid}
    nvscaleaddmultivectorarray::Ptr{Cvoid}
    nvlinearcombinationvectorarray::Ptr{Cvoid}
    nvdotprodlocal::Ptr{Cvoid}
    nvmaxnormlocal::Ptr{Cvoid}
    nvminlocal::Ptr{Cvoid}
    nvl1normlocal::Ptr{Cvoid}
    nvinvtestlocal::Ptr{Cvoid}
    nvconstrmasklocal::Ptr{Cvoid}
    nvminquotientlocal::Ptr{Cvoid}
    nvwsqrsumlocal::Ptr{Cvoid}
    nvwsqrsummasklocal::Ptr{Cvoid}
end

const N_Vector_Ops = Ptr{_generic_N_Vector_Ops}

struct _generic_N_Vector
    content::Ptr{Cvoid}
    ops::N_Vector_Ops
end

const N_Vector = Ptr{_generic_N_Vector}

struct _generic_SUNLinearSolver_Ops
    gettype::Ptr{Cvoid}
    getid::Ptr{Cvoid}
    setatimes::Ptr{Cvoid}
    setpreconditioner::Ptr{Cvoid}
    setscalingvectors::Ptr{Cvoid}
    initialize::Ptr{Cvoid}
    setup::Ptr{Cvoid}
    solve::Ptr{Cvoid}
    numiters::Ptr{Cvoid}
    resnorm::Ptr{Cvoid}
    lastflag::Ptr{Cvoid}
    space::Ptr{Cvoid}
    resid::Ptr{Cvoid}
    free::Ptr{Cvoid}
end

const SUNLinearSolver_Ops = Ptr{_generic_SUNLinearSolver_Ops}

struct _generic_SUNLinearSolver
    content::Ptr{Cvoid}
    ops::SUNLinearSolver_Ops
end

const SUNLinearSolver = Ptr{_generic_SUNLinearSolver}

struct _generic_SUNMatrix_Ops
    getid::Ptr{Cvoid}
    clone::Ptr{Cvoid}
    destroy::Ptr{Cvoid}
    zero::Ptr{Cvoid}
    copy::Ptr{Cvoid}
    scaleadd::Ptr{Cvoid}
    scaleaddi::Ptr{Cvoid}
    matvecsetup::Ptr{Cvoid}
    matvec::Ptr{Cvoid}
    space::Ptr{Cvoid}
end

const SUNMatrix_Ops = Ptr{_generic_SUNMatrix_Ops}

struct _generic_SUNMatrix
    content::Ptr{Cvoid}
    ops::SUNMatrix_Ops
end

const SUNMatrix = Ptr{_generic_SUNMatrix}

struct _generic_SUNNonlinearSolver_Ops
    gettype::Ptr{Cvoid}
    initialize::Ptr{Cvoid}
    setup::Ptr{Cvoid}
    solve::Ptr{Cvoid}
    free::Ptr{Cvoid}
    setsysfn::Ptr{Cvoid}
    setlsetupfn::Ptr{Cvoid}
    setlsolvefn::Ptr{Cvoid}
    setctestfn::Ptr{Cvoid}
    setmaxiters::Ptr{Cvoid}
    getnumiters::Ptr{Cvoid}
    getcuriter::Ptr{Cvoid}
    getnumconvfails::Ptr{Cvoid}
end

const SUNNonlinearSolver_Ops = Ptr{_generic_SUNNonlinearSolver_Ops}

struct _generic_SUNNonlinearSolver
    content::Ptr{Cvoid}
    ops::SUNNonlinearSolver_Ops
end

const SUNNonlinearSolver = Ptr{_generic_SUNNonlinearSolver}

struct ARKodeButcherTableMem
    q::Cint
    p::Cint
    stages::Cint
    A::Ptr{Ptr{realtype}}
    c::Ptr{realtype}
    b::Ptr{realtype}
    d::Ptr{realtype}
end

const ARKodeButcherTable = Ptr{ARKodeButcherTableMem}

# typedef int ( * ARKLsJacFn ) ( realtype t , N_Vector y , N_Vector fy , SUNMatrix Jac , void * user_data , N_Vector tmp1 , N_Vector tmp2 , N_Vector tmp3 )
const ARKLsJacFn = Ptr{Cvoid}

# typedef int ( * ARKLsMassFn ) ( realtype t , SUNMatrix M , void * user_data , N_Vector tmp1 , N_Vector tmp2 , N_Vector tmp3 )
const ARKLsMassFn = Ptr{Cvoid}

# typedef int ( * ARKLsPrecSetupFn ) ( realtype t , N_Vector y , N_Vector fy , booleantype jok , booleantype * jcurPtr , realtype gamma , void * user_data )
const ARKLsPrecSetupFn = Ptr{Cvoid}

# typedef int ( * ARKLsPrecSolveFn ) ( realtype t , N_Vector y , N_Vector fy , N_Vector r , N_Vector z , realtype gamma , realtype delta , int lr , void * user_data )
const ARKLsPrecSolveFn = Ptr{Cvoid}

# typedef int ( * ARKLsMassPrecSetupFn ) ( realtype t , void * user_data )
const ARKLsMassPrecSetupFn = Ptr{Cvoid}

# typedef int ( * ARKLsMassPrecSolveFn ) ( realtype t , N_Vector r , N_Vector z , realtype delta , int lr , void * user_data )
const ARKLsMassPrecSolveFn = Ptr{Cvoid}

# typedef int ( * ARKLsJacTimesSetupFn ) ( realtype t , N_Vector y , N_Vector fy , void * user_data )
const ARKLsJacTimesSetupFn = Ptr{Cvoid}

# typedef int ( * ARKLsJacTimesVecFn ) ( N_Vector v , N_Vector Jv , realtype t , N_Vector y , N_Vector fy , void * user_data , N_Vector tmp )
const ARKLsJacTimesVecFn = Ptr{Cvoid}

# typedef int ( * ARKLsMassTimesSetupFn ) ( realtype t , void * mtimes_data )
const ARKLsMassTimesSetupFn = Ptr{Cvoid}

# typedef int ( * ARKLsMassTimesVecFn ) ( N_Vector v , N_Vector Mv , realtype t , void * mtimes_data )
const ARKLsMassTimesVecFn = Ptr{Cvoid}

# typedef int ( * ARKLsLinSysFn ) ( realtype t , N_Vector y , N_Vector fy , SUNMatrix A , SUNMatrix M , booleantype jok , booleantype * jcur , realtype gamma , void * user_data , N_Vector tmp1 , N_Vector tmp2 , N_Vector tmp3 )
const ARKLsLinSysFn = Ptr{Cvoid}

const sunindextype = Int64

# typedef int ( * ARKLocalFn ) ( sunindextype Nlocal , realtype t , N_Vector y , N_Vector g , void * user_data )
const ARKLocalFn = Ptr{Cvoid}

# typedef int ( * ARKCommFn ) ( sunindextype Nlocal , realtype t , N_Vector y , void * user_data )
const ARKCommFn = Ptr{Cvoid}

@cenum MRISTEP_ID::UInt32 begin
    MRISTEP_ARKSTEP = 0
end

# typedef int ( * MRIStepPreInnerFn ) ( realtype t , N_Vector * f , int nvecs , void * user_data )
const MRIStepPreInnerFn = Ptr{Cvoid}

# typedef int ( * MRIStepPostInnerFn ) ( realtype t , N_Vector y , void * user_data )
const MRIStepPostInnerFn = Ptr{Cvoid}

# typedef int ( * CVRhsFn ) ( realtype t , N_Vector y , N_Vector ydot , void * user_data )
const CVRhsFn = Ptr{Cvoid}

# typedef int ( * CVRootFn ) ( realtype t , N_Vector y , realtype * gout , void * user_data )
const CVRootFn = Ptr{Cvoid}

# typedef int ( * CVEwtFn ) ( N_Vector y , N_Vector ewt , void * user_data )
const CVEwtFn = Ptr{Cvoid}

# typedef void ( * CVErrHandlerFn ) ( int error_code , const char * module , const char * function , char * msg , void * user_data )
const CVErrHandlerFn = Ptr{Cvoid}

# typedef int ( * CVLocalFn ) ( sunindextype Nlocal , realtype t , N_Vector y , N_Vector g , void * user_data )
const CVLocalFn = Ptr{Cvoid}

# typedef int ( * CVCommFn ) ( sunindextype Nlocal , realtype t , N_Vector y , void * user_data )
const CVCommFn = Ptr{Cvoid}

# typedef int ( * CVLsJacFn ) ( realtype t , N_Vector y , N_Vector fy , SUNMatrix Jac , void * user_data , N_Vector tmp1 , N_Vector tmp2 , N_Vector tmp3 )
const CVLsJacFn = Ptr{Cvoid}

const CVDlsJacFn = CVLsJacFn

# typedef int ( * CVLsPrecSetupFn ) ( realtype t , N_Vector y , N_Vector fy , booleantype jok , booleantype * jcurPtr , realtype gamma , void * user_data )
const CVLsPrecSetupFn = Ptr{Cvoid}

# typedef int ( * CVLsPrecSolveFn ) ( realtype t , N_Vector y , N_Vector fy , N_Vector r , N_Vector z , realtype gamma , realtype delta , int lr , void * user_data )
const CVLsPrecSolveFn = Ptr{Cvoid}

# typedef int ( * CVLsJacTimesSetupFn ) ( realtype t , N_Vector y , N_Vector fy , void * user_data )
const CVLsJacTimesSetupFn = Ptr{Cvoid}

# typedef int ( * CVLsJacTimesVecFn ) ( N_Vector v , N_Vector Jv , realtype t , N_Vector y , N_Vector fy , void * user_data , N_Vector tmp )
const CVLsJacTimesVecFn = Ptr{Cvoid}

# typedef int ( * CVLsLinSysFn ) ( realtype t , N_Vector y , N_Vector fy , SUNMatrix A , booleantype jok , booleantype * jcur , realtype gamma , void * user_data , N_Vector tmp1 , N_Vector tmp2 , N_Vector tmp3 )
const CVLsLinSysFn = Ptr{Cvoid}

const CVSpilsPrecSetupFn = CVLsPrecSetupFn

const CVSpilsPrecSolveFn = CVLsPrecSolveFn

const CVSpilsJacTimesSetupFn = CVLsJacTimesSetupFn

const CVSpilsJacTimesVecFn = CVLsJacTimesVecFn

# typedef int ( * CVQuadRhsFn ) ( realtype t , N_Vector y , N_Vector yQdot , void * user_data )
const CVQuadRhsFn = Ptr{Cvoid}

# typedef int ( * CVSensRhsFn ) ( int Ns , realtype t , N_Vector y , N_Vector ydot , N_Vector * yS , N_Vector * ySdot , void * user_data , N_Vector tmp1 , N_Vector tmp2 )
const CVSensRhsFn = Ptr{Cvoid}

# typedef int ( * CVSensRhs1Fn ) ( int Ns , realtype t , N_Vector y , N_Vector ydot , int iS , N_Vector yS , N_Vector ySdot , void * user_data , N_Vector tmp1 , N_Vector tmp2 )
const CVSensRhs1Fn = Ptr{Cvoid}

# typedef int ( * CVQuadSensRhsFn ) ( int Ns , realtype t , N_Vector y , N_Vector * yS , N_Vector yQdot , N_Vector * yQSdot , void * user_data , N_Vector tmp , N_Vector tmpQ )
const CVQuadSensRhsFn = Ptr{Cvoid}

# typedef int ( * CVRhsFnB ) ( realtype t , N_Vector y , N_Vector yB , N_Vector yBdot , void * user_dataB )
const CVRhsFnB = Ptr{Cvoid}

# typedef int ( * CVRhsFnBS ) ( realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector yBdot , void * user_dataB )
const CVRhsFnBS = Ptr{Cvoid}

# typedef int ( * CVQuadRhsFnB ) ( realtype t , N_Vector y , N_Vector yB , N_Vector qBdot , void * user_dataB )
const CVQuadRhsFnB = Ptr{Cvoid}

# typedef int ( * CVQuadRhsFnBS ) ( realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector qBdot , void * user_dataB )
const CVQuadRhsFnBS = Ptr{Cvoid}

struct CVadjCheckPointRec
    my_addr::Ptr{Cvoid}
    next_addr::Ptr{Cvoid}
    t0::realtype
    t1::realtype
    nstep::Clong
    order::Cint
    step::realtype
end

# typedef int ( * CVLocalFnB ) ( sunindextype NlocalB , realtype t , N_Vector y , N_Vector yB , N_Vector gB , void * user_dataB )
const CVLocalFnB = Ptr{Cvoid}

# typedef int ( * CVCommFnB ) ( sunindextype NlocalB , realtype t , N_Vector y , N_Vector yB , void * user_dataB )
const CVCommFnB = Ptr{Cvoid}

# typedef int ( * CVLsJacFnB ) ( realtype t , N_Vector y , N_Vector yB , N_Vector fyB , SUNMatrix JB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B , N_Vector tmp3B )
const CVLsJacFnB = Ptr{Cvoid}

const CVDlsJacFnB = CVLsJacFnB

# typedef int ( * CVLsJacFnBS ) ( realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector fyB , SUNMatrix JB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B , N_Vector tmp3B )
const CVLsJacFnBS = Ptr{Cvoid}

const CVDlsJacFnBS = CVLsJacFnBS

# typedef int ( * CVLsPrecSetupFnB ) ( realtype t , N_Vector y , N_Vector yB , N_Vector fyB , booleantype jokB , booleantype * jcurPtrB , realtype gammaB , void * user_dataB )
const CVLsPrecSetupFnB = Ptr{Cvoid}

# typedef int ( * CVLsPrecSetupFnBS ) ( realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector fyB , booleantype jokB , booleantype * jcurPtrB , realtype gammaB , void * user_dataB )
const CVLsPrecSetupFnBS = Ptr{Cvoid}

# typedef int ( * CVLsPrecSolveFnB ) ( realtype t , N_Vector y , N_Vector yB , N_Vector fyB , N_Vector rB , N_Vector zB , realtype gammaB , realtype deltaB , int lrB , void * user_dataB )
const CVLsPrecSolveFnB = Ptr{Cvoid}

# typedef int ( * CVLsPrecSolveFnBS ) ( realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector fyB , N_Vector rB , N_Vector zB , realtype gammaB , realtype deltaB , int lrB , void * user_dataB )
const CVLsPrecSolveFnBS = Ptr{Cvoid}

# typedef int ( * CVLsJacTimesSetupFnB ) ( realtype t , N_Vector y , N_Vector yB , N_Vector fyB , void * jac_dataB )
const CVLsJacTimesSetupFnB = Ptr{Cvoid}

# typedef int ( * CVLsJacTimesSetupFnBS ) ( realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector fyB , void * jac_dataB )
const CVLsJacTimesSetupFnBS = Ptr{Cvoid}

# typedef int ( * CVLsJacTimesVecFnB ) ( N_Vector vB , N_Vector JvB , realtype t , N_Vector y , N_Vector yB , N_Vector fyB , void * jac_dataB , N_Vector tmpB )
const CVLsJacTimesVecFnB = Ptr{Cvoid}

# typedef int ( * CVLsJacTimesVecFnBS ) ( N_Vector vB , N_Vector JvB , realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector fyB , void * jac_dataB , N_Vector tmpB )
const CVLsJacTimesVecFnBS = Ptr{Cvoid}

# typedef int ( * CVLsLinSysFnB ) ( realtype t , N_Vector y , N_Vector yB , N_Vector fyB , SUNMatrix AB , booleantype jokB , booleantype * jcurB , realtype gammaB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B , N_Vector tmp3B )
const CVLsLinSysFnB = Ptr{Cvoid}

# typedef int ( * CVLsLinSysFnBS ) ( realtype t , N_Vector y , N_Vector * yS , N_Vector yB , N_Vector fyB , SUNMatrix AB , booleantype jokB , booleantype * jcurB , realtype gammaB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B , N_Vector tmp3B )
const CVLsLinSysFnBS = Ptr{Cvoid}

const CVSpilsPrecSetupFnB = CVLsPrecSetupFnB

const CVSpilsPrecSetupFnBS = CVLsPrecSetupFnBS

const CVSpilsPrecSolveFnB = CVLsPrecSolveFnB

const CVSpilsPrecSolveFnBS = CVLsPrecSolveFnBS

const CVSpilsJacTimesSetupFnB = CVLsJacTimesSetupFnB

const CVSpilsJacTimesSetupFnBS = CVLsJacTimesSetupFnBS

const CVSpilsJacTimesVecFnB = CVLsJacTimesVecFnB

const CVSpilsJacTimesVecFnBS = CVLsJacTimesVecFnBS

# typedef int ( * IDAResFn ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector rr , void * user_data )
const IDAResFn = Ptr{Cvoid}

# typedef int ( * IDARootFn ) ( realtype t , N_Vector y , N_Vector yp , realtype * gout , void * user_data )
const IDARootFn = Ptr{Cvoid}

# typedef int ( * IDAEwtFn ) ( N_Vector y , N_Vector ewt , void * user_data )
const IDAEwtFn = Ptr{Cvoid}

# typedef void ( * IDAErrHandlerFn ) ( int error_code , const char * module , const char * function , char * msg , void * user_data )
const IDAErrHandlerFn = Ptr{Cvoid}

# typedef int ( * IDABBDLocalFn ) ( sunindextype Nlocal , realtype tt , N_Vector yy , N_Vector yp , N_Vector gval , void * user_data )
const IDABBDLocalFn = Ptr{Cvoid}

# typedef int ( * IDABBDCommFn ) ( sunindextype Nlocal , realtype tt , N_Vector yy , N_Vector yp , void * user_data )
const IDABBDCommFn = Ptr{Cvoid}

# typedef int ( * IDALsJacFn ) ( realtype t , realtype c_j , N_Vector y , N_Vector yp , N_Vector r , SUNMatrix Jac , void * user_data , N_Vector tmp1 , N_Vector tmp2 , N_Vector tmp3 )
const IDALsJacFn = Ptr{Cvoid}

const IDADlsJacFn = IDALsJacFn

# typedef int ( * IDALsPrecSetupFn ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector rr , realtype c_j , void * user_data )
const IDALsPrecSetupFn = Ptr{Cvoid}

# typedef int ( * IDALsPrecSolveFn ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector rr , N_Vector rvec , N_Vector zvec , realtype c_j , realtype delta , void * user_data )
const IDALsPrecSolveFn = Ptr{Cvoid}

# typedef int ( * IDALsJacTimesSetupFn ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector rr , realtype c_j , void * user_data )
const IDALsJacTimesSetupFn = Ptr{Cvoid}

# typedef int ( * IDALsJacTimesVecFn ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector rr , N_Vector v , N_Vector Jv , realtype c_j , void * user_data , N_Vector tmp1 , N_Vector tmp2 )
const IDALsJacTimesVecFn = Ptr{Cvoid}

const IDASpilsPrecSetupFn = IDALsPrecSetupFn

const IDASpilsPrecSolveFn = IDALsPrecSolveFn

const IDASpilsJacTimesSetupFn = IDALsJacTimesSetupFn

const IDASpilsJacTimesVecFn = IDALsJacTimesVecFn

# typedef int ( * IDAQuadRhsFn ) ( realtype tres , N_Vector yy , N_Vector yp , N_Vector rrQ , void * user_data )
const IDAQuadRhsFn = Ptr{Cvoid}

# typedef int ( * IDASensResFn ) ( int Ns , realtype t , N_Vector yy , N_Vector yp , N_Vector resval , N_Vector * yyS , N_Vector * ypS , N_Vector * resvalS , void * user_data , N_Vector tmp1 , N_Vector tmp2 , N_Vector tmp3 )
const IDASensResFn = Ptr{Cvoid}

# typedef int ( * IDAQuadSensRhsFn ) ( int Ns , realtype t , N_Vector yy , N_Vector yp , N_Vector * yyS , N_Vector * ypS , N_Vector rrQ , N_Vector * rhsvalQS , void * user_data , N_Vector yytmp , N_Vector yptmp , N_Vector tmpQS )
const IDAQuadSensRhsFn = Ptr{Cvoid}

# typedef int ( * IDAResFnB ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector rrB , void * user_dataB )
const IDAResFnB = Ptr{Cvoid}

# typedef int ( * IDAResFnBS ) ( realtype t , N_Vector yy , N_Vector yp , N_Vector * yyS , N_Vector * ypS , N_Vector yyB , N_Vector ypB , N_Vector rrBS , void * user_dataB )
const IDAResFnBS = Ptr{Cvoid}

# typedef int ( * IDAQuadRhsFnB ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector rhsvalBQ , void * user_dataB )
const IDAQuadRhsFnB = Ptr{Cvoid}

# typedef int ( * IDAQuadRhsFnBS ) ( realtype t , N_Vector yy , N_Vector yp , N_Vector * yyS , N_Vector * ypS , N_Vector yyB , N_Vector ypB , N_Vector rhsvalBQS , void * user_dataB )
const IDAQuadRhsFnBS = Ptr{Cvoid}

const N_Vector_S = Ptr{N_Vector}

struct IDAadjCheckPointRec
    my_addr::Ptr{Cvoid}
    next_addr::Ptr{Cvoid}
    t0::realtype
    t1::realtype
    nstep::Clong
    order::Cint
    step::realtype
end

# typedef int ( * IDABBDLocalFnB ) ( sunindextype NlocalB , realtype tt , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector gvalB , void * user_dataB )
const IDABBDLocalFnB = Ptr{Cvoid}

# typedef int ( * IDABBDCommFnB ) ( sunindextype NlocalB , realtype tt , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , void * user_dataB )
const IDABBDCommFnB = Ptr{Cvoid}

# typedef int ( * IDALsJacFnB ) ( realtype tt , realtype c_jB , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector rrB , SUNMatrix JacB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B , N_Vector tmp3B )
const IDALsJacFnB = Ptr{Cvoid}

const IDADlsJacFnB = IDALsJacFnB

# typedef int ( * IDALsJacFnBS ) ( realtype tt , realtype c_jB , N_Vector yy , N_Vector yp , N_Vector * yS , N_Vector * ypS , N_Vector yyB , N_Vector ypB , N_Vector rrB , SUNMatrix JacB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B , N_Vector tmp3B )
const IDALsJacFnBS = Ptr{Cvoid}

const IDADlsJacFnBS = IDALsJacFnBS

# typedef int ( * IDALsPrecSetupFnB ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector rrB , realtype c_jB , void * user_dataB )
const IDALsPrecSetupFnB = Ptr{Cvoid}

# typedef int ( * IDALsPrecSetupFnBS ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector * yyS , N_Vector * ypS , N_Vector yyB , N_Vector ypB , N_Vector rrB , realtype c_jB , void * user_dataB )
const IDALsPrecSetupFnBS = Ptr{Cvoid}

# typedef int ( * IDALsPrecSolveFnB ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector rrB , N_Vector rvecB , N_Vector zvecB , realtype c_jB , realtype deltaB , void * user_dataB )
const IDALsPrecSolveFnB = Ptr{Cvoid}

# typedef int ( * IDALsPrecSolveFnBS ) ( realtype tt , N_Vector yy , N_Vector yp , N_Vector * yyS , N_Vector * ypS , N_Vector yyB , N_Vector ypB , N_Vector rrB , N_Vector rvecB , N_Vector zvecB , realtype c_jB , realtype deltaB , void * user_dataB )
const IDALsPrecSolveFnBS = Ptr{Cvoid}

# typedef int ( * IDALsJacTimesSetupFnB ) ( realtype t , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector rrB , realtype c_jB , void * user_dataB )
const IDALsJacTimesSetupFnB = Ptr{Cvoid}

# typedef int ( * IDALsJacTimesSetupFnBS ) ( realtype t , N_Vector yy , N_Vector yp , N_Vector * yyS , N_Vector * ypS , N_Vector yyB , N_Vector ypB , N_Vector rrB , realtype c_jB , void * user_dataB )
const IDALsJacTimesSetupFnBS = Ptr{Cvoid}

# typedef int ( * IDALsJacTimesVecFnB ) ( realtype t , N_Vector yy , N_Vector yp , N_Vector yyB , N_Vector ypB , N_Vector rrB , N_Vector vB , N_Vector JvB , realtype c_jB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B )
const IDALsJacTimesVecFnB = Ptr{Cvoid}

# typedef int ( * IDALsJacTimesVecFnBS ) ( realtype t , N_Vector yy , N_Vector yp , N_Vector * yyS , N_Vector * ypS , N_Vector yyB , N_Vector ypB , N_Vector rrB , N_Vector vB , N_Vector JvB , realtype c_jB , void * user_dataB , N_Vector tmp1B , N_Vector tmp2B )
const IDALsJacTimesVecFnBS = Ptr{Cvoid}

const IDASpilsPrecSetupFnB = IDALsPrecSetupFnB

const IDASpilsPrecSetupFnBS = IDALsPrecSetupFnBS

const IDASpilsPrecSolveFnB = IDALsPrecSolveFnB

const IDASpilsPrecSolveFnBS = IDALsPrecSolveFnBS

const IDASpilsJacTimesSetupFnB = IDALsJacTimesSetupFnB

const IDASpilsJacTimesSetupFnBS = IDALsJacTimesSetupFnBS

const IDASpilsJacTimesVecFnB = IDALsJacTimesVecFnB

const IDASpilsJacTimesVecFnBS = IDALsJacTimesVecFnBS

# typedef int ( * KINSysFn ) ( N_Vector uu , N_Vector fval , void * user_data )
const KINSysFn = Ptr{Cvoid}

# typedef void ( * KINErrHandlerFn ) ( int error_code , const char * module , const char * function , char * msg , void * user_data )
const KINErrHandlerFn = Ptr{Cvoid}

# typedef void ( * KINInfoHandlerFn ) ( const char * module , const char * function , char * msg , void * user_data )
const KINInfoHandlerFn = Ptr{Cvoid}

# typedef int ( * KINBBDCommFn ) ( sunindextype Nlocal , N_Vector u , void * user_data )
const KINBBDCommFn = Ptr{Cvoid}

# typedef int ( * KINBBDLocalFn ) ( sunindextype Nlocal , N_Vector uu , N_Vector gval , void * user_data )
const KINBBDLocalFn = Ptr{Cvoid}

# typedef int ( * KINLsJacFn ) ( N_Vector u , N_Vector fu , SUNMatrix J , void * user_data , N_Vector tmp1 , N_Vector tmp2 )
const KINLsJacFn = Ptr{Cvoid}

const KINDlsJacFn = KINLsJacFn

# typedef int ( * KINLsPrecSetupFn ) ( N_Vector uu , N_Vector uscale , N_Vector fval , N_Vector fscale , void * user_data )
const KINLsPrecSetupFn = Ptr{Cvoid}

# typedef int ( * KINLsPrecSolveFn ) ( N_Vector uu , N_Vector uscale , N_Vector fval , N_Vector fscale , N_Vector vv , void * user_data )
const KINLsPrecSolveFn = Ptr{Cvoid}

# typedef int ( * KINLsJacTimesVecFn ) ( N_Vector v , N_Vector Jv , N_Vector uu , booleantype * new_uu , void * J_data )
const KINLsJacTimesVecFn = Ptr{Cvoid}

const KINSpilsPrecSetupFn = KINLsPrecSetupFn

const KINSpilsPrecSolveFn = KINLsPrecSolveFn

const KINSpilsJacTimesVecFn = KINLsJacTimesVecFn

struct _N_VectorContent_ManyVector
    num_subvectors::sunindextype
    global_length::sunindextype
    subvec_array::Ptr{N_Vector}
    own_data::Cint
end

const N_VectorContent_ManyVector = Ptr{_N_VectorContent_ManyVector}

@cenum N_Vector_ID::UInt32 begin
    SUNDIALS_NVEC_SERIAL = 0
    SUNDIALS_NVEC_PARALLEL = 1
    SUNDIALS_NVEC_OPENMP = 2
    SUNDIALS_NVEC_PTHREADS = 3
    SUNDIALS_NVEC_PARHYP = 4
    SUNDIALS_NVEC_PETSC = 5
    SUNDIALS_NVEC_CUDA = 6
    SUNDIALS_NVEC_RAJA = 7
    SUNDIALS_NVEC_OPENMPDEV = 8
    SUNDIALS_NVEC_TRILINOS = 9
    SUNDIALS_NVEC_MANYVECTOR = 10
    SUNDIALS_NVEC_MPIMANYVECTOR = 11
    SUNDIALS_NVEC_MPIPLUSX = 12
    SUNDIALS_NVEC_CUSTOM = 13
end

struct _N_VectorContent_Serial
    length::sunindextype
    own_data::Cint
    data::Ptr{realtype}
end

const N_VectorContent_Serial = Ptr{_N_VectorContent_Serial}

struct _DlsMat
    type::Cint
    M::sunindextype
    N::sunindextype
    ldim::sunindextype
    mu::sunindextype
    ml::sunindextype
    s_mu::sunindextype
    data::Ptr{realtype}
    ldata::sunindextype
    cols::Ptr{Ptr{realtype}}
end

const DlsMat = Ptr{_DlsMat}

@cenum __JL_Ctag_173::UInt32 begin
    PREC_NONE = 0
    PREC_LEFT = 1
    PREC_RIGHT = 2
    PREC_BOTH = 3
end

@cenum __JL_Ctag_174::UInt32 begin
    MODIFIED_GS = 1
    CLASSICAL_GS = 2
end

# typedef int ( * ATimesFn ) ( void * A_data , N_Vector v , N_Vector z )
const ATimesFn = Ptr{Cvoid}

# typedef int ( * PSetupFn ) ( void * P_data )
const PSetupFn = Ptr{Cvoid}

# typedef int ( * PSolveFn ) ( void * P_data , N_Vector r , N_Vector z , realtype tol , int lr )
const PSolveFn = Ptr{Cvoid}

@cenum SUNLinearSolver_Type::UInt32 begin
    SUNLINEARSOLVER_DIRECT = 0
    SUNLINEARSOLVER_ITERATIVE = 1
    SUNLINEARSOLVER_MATRIX_ITERATIVE = 2
end

@cenum SUNLinearSolver_ID::UInt32 begin
    SUNLINEARSOLVER_BAND = 0
    SUNLINEARSOLVER_DENSE = 1
    SUNLINEARSOLVER_KLU = 2
    SUNLINEARSOLVER_LAPACKBAND = 3
    SUNLINEARSOLVER_LAPACKDENSE = 4
    SUNLINEARSOLVER_PCG = 5
    SUNLINEARSOLVER_SPBCGS = 6
    SUNLINEARSOLVER_SPFGMR = 7
    SUNLINEARSOLVER_SPGMR = 8
    SUNLINEARSOLVER_SPTFQMR = 9
    SUNLINEARSOLVER_SUPERLUDIST = 10
    SUNLINEARSOLVER_SUPERLUMT = 11
    SUNLINEARSOLVER_CUSOLVERSP_BATCHQR = 12
    SUNLINEARSOLVER_CUSTOM = 13
end

@cenum SUNMatrix_ID::UInt32 begin
    SUNMATRIX_DENSE = 0
    SUNMATRIX_BAND = 1
    SUNMATRIX_SPARSE = 2
    SUNMATRIX_SLUNRLOC = 3
    SUNMATRIX_CUSPARSE = 4
    SUNMATRIX_CUSTOM = 5
end

# typedef int ( * SUNNonlinSolSysFn ) ( N_Vector y , N_Vector F , void * mem )
const SUNNonlinSolSysFn = Ptr{Cvoid}

# typedef int ( * SUNNonlinSolLSetupFn ) ( booleantype jbad , booleantype * jcur , void * mem )
const SUNNonlinSolLSetupFn = Ptr{Cvoid}

# typedef int ( * SUNNonlinSolLSolveFn ) ( N_Vector b , void * mem )
const SUNNonlinSolLSolveFn = Ptr{Cvoid}

# typedef int ( * SUNNonlinSolConvTestFn ) ( SUNNonlinearSolver NLS , N_Vector y , N_Vector del , realtype tol , N_Vector ewt , void * mem )
const SUNNonlinSolConvTestFn = Ptr{Cvoid}

@cenum SUNNonlinearSolver_Type::UInt32 begin
    SUNNONLINEARSOLVER_ROOTFIND = 0
    SUNNONLINEARSOLVER_FIXEDPOINT = 1
end

struct _SUNLinearSolverContent_Band
    N::sunindextype
    pivots::Ptr{sunindextype}
    last_flag::sunindextype
end

const SUNLinearSolverContent_Band = Ptr{_SUNLinearSolverContent_Band}

struct _SUNLinearSolverContent_Dense
    N::sunindextype
    pivots::Ptr{sunindextype}
    last_flag::sunindextype
end

const SUNLinearSolverContent_Dense = Ptr{_SUNLinearSolverContent_Dense}

# typedef sunindextype ( * KLUSolveFn ) ( sun_klu_symbolic * , sun_klu_numeric * , sunindextype , sunindextype , double * , sun_klu_common * )
const KLUSolveFn = Ptr{Cvoid}

struct _SUNLinearSolverContent_KLU
    last_flag::Cint
    first_factorize::Cint
    symbolic::Ptr{klu_l_symbolic}
    numeric::Ptr{klu_l_numeric}
    common::klu_l_common
    klu_solver::KLUSolveFn
end

const SUNLinearSolverContent_KLU = Ptr{_SUNLinearSolverContent_KLU}

struct _SUNLinearSolverContent_LapackBand
    N::sunindextype
    pivots::Ptr{sunindextype}
    last_flag::sunindextype
end

const SUNLinearSolverContent_LapackBand = Ptr{_SUNLinearSolverContent_LapackBand}

struct _SUNLinearSolverContent_LapackDense
    N::sunindextype
    pivots::Ptr{sunindextype}
    last_flag::sunindextype
end

const SUNLinearSolverContent_LapackDense = Ptr{_SUNLinearSolverContent_LapackDense}

struct _SUNLinearSolverContent_PCG
    maxl::Cint
    pretype::Cint
    numiters::Cint
    resnorm::realtype
    last_flag::Cint
    ATimes::ATimesFn
    ATData::Ptr{Cvoid}
    Psetup::PSetupFn
    Psolve::PSolveFn
    PData::Ptr{Cvoid}
    s::N_Vector
    r::N_Vector
    p::N_Vector
    z::N_Vector
    Ap::N_Vector
end

const SUNLinearSolverContent_PCG = Ptr{_SUNLinearSolverContent_PCG}

struct _SUNLinearSolverContent_SPBCGS
    maxl::Cint
    pretype::Cint
    numiters::Cint
    resnorm::realtype
    last_flag::Cint
    ATimes::ATimesFn
    ATData::Ptr{Cvoid}
    Psetup::PSetupFn
    Psolve::PSolveFn
    PData::Ptr{Cvoid}
    s1::N_Vector
    s2::N_Vector
    r::N_Vector
    r_star::N_Vector
    p::N_Vector
    q::N_Vector
    u::N_Vector
    Ap::N_Vector
    vtemp::N_Vector
end

const SUNLinearSolverContent_SPBCGS = Ptr{_SUNLinearSolverContent_SPBCGS}

struct _SUNLinearSolverContent_SPFGMR
    maxl::Cint
    pretype::Cint
    gstype::Cint
    max_restarts::Cint
    numiters::Cint
    resnorm::realtype
    last_flag::Cint
    ATimes::ATimesFn
    ATData::Ptr{Cvoid}
    Psetup::PSetupFn
    Psolve::PSolveFn
    PData::Ptr{Cvoid}
    s1::N_Vector
    s2::N_Vector
    V::Ptr{N_Vector}
    Z::Ptr{N_Vector}
    Hes::Ptr{Ptr{realtype}}
    givens::Ptr{realtype}
    xcor::N_Vector
    yg::Ptr{realtype}
    vtemp::N_Vector
    cv::Ptr{realtype}
    Xv::Ptr{N_Vector}
end

const SUNLinearSolverContent_SPFGMR = Ptr{_SUNLinearSolverContent_SPFGMR}

struct _SUNLinearSolverContent_SPGMR
    maxl::Cint
    pretype::Cint
    gstype::Cint
    max_restarts::Cint
    numiters::Cint
    resnorm::realtype
    last_flag::Cint
    ATimes::ATimesFn
    ATData::Ptr{Cvoid}
    Psetup::PSetupFn
    Psolve::PSolveFn
    PData::Ptr{Cvoid}
    s1::N_Vector
    s2::N_Vector
    V::Ptr{N_Vector}
    Hes::Ptr{Ptr{realtype}}
    givens::Ptr{realtype}
    xcor::N_Vector
    yg::Ptr{realtype}
    vtemp::N_Vector
    cv::Ptr{realtype}
    Xv::Ptr{N_Vector}
end

const SUNLinearSolverContent_SPGMR = Ptr{_SUNLinearSolverContent_SPGMR}

struct _SUNLinearSolverContent_SPTFQMR
    maxl::Cint
    pretype::Cint
    numiters::Cint
    resnorm::realtype
    last_flag::Cint
    ATimes::ATimesFn
    ATData::Ptr{Cvoid}
    Psetup::PSetupFn
    Psolve::PSolveFn
    PData::Ptr{Cvoid}
    s1::N_Vector
    s2::N_Vector
    r_star::N_Vector
    q::N_Vector
    d::N_Vector
    v::N_Vector
    p::N_Vector
    r::Ptr{N_Vector}
    u::N_Vector
    vtemp1::N_Vector
    vtemp2::N_Vector
    vtemp3::N_Vector
end

const SUNLinearSolverContent_SPTFQMR = Ptr{_SUNLinearSolverContent_SPTFQMR}

struct _SUNMatrixContent_Band
    M::sunindextype
    N::sunindextype
    ldim::sunindextype
    mu::sunindextype
    ml::sunindextype
    s_mu::sunindextype
    data::Ptr{realtype}
    ldata::sunindextype
    cols::Ptr{Ptr{realtype}}
end

const SUNMatrixContent_Band = Ptr{_SUNMatrixContent_Band}

struct _SUNMatrixContent_Dense
    M::sunindextype
    N::sunindextype
    data::Ptr{realtype}
    ldata::sunindextype
    cols::Ptr{Ptr{realtype}}
end

const SUNMatrixContent_Dense = Ptr{_SUNMatrixContent_Dense}

struct _SUNMatrixContent_Sparse
    M::sunindextype
    N::sunindextype
    NNZ::sunindextype
    NP::sunindextype
    data::Ptr{realtype}
    sparsetype::Cint
    indexvals::Ptr{sunindextype}
    indexptrs::Ptr{sunindextype}
    rowvals::Ptr{Ptr{sunindextype}}
    colptrs::Ptr{Ptr{sunindextype}}
    colvals::Ptr{Ptr{sunindextype}}
    rowptrs::Ptr{Ptr{sunindextype}}
end

const SUNMatrixContent_Sparse = Ptr{_SUNMatrixContent_Sparse}

struct _SUNNonlinearSolverContent_FixedPoint
    Sys::SUNNonlinSolSysFn
    CTest::SUNNonlinSolConvTestFn
    m::Cint
    imap::Ptr{Cint}
    damping::Cint
    beta::realtype
    R::Ptr{realtype}
    gamma::Ptr{realtype}
    cvals::Ptr{realtype}
    df::Ptr{N_Vector}
    dg::Ptr{N_Vector}
    q::Ptr{N_Vector}
    Xvecs::Ptr{N_Vector}
    yprev::N_Vector
    gy::N_Vector
    fold::N_Vector
    gold::N_Vector
    delta::N_Vector
    curiter::Cint
    maxiters::Cint
    niters::Clong
    nconvfails::Clong
    ctest_data::Ptr{Cvoid}
end

const SUNNonlinearSolverContent_FixedPoint = Ptr{_SUNNonlinearSolverContent_FixedPoint}

struct _SUNNonlinearSolverContent_Newton
    Sys::SUNNonlinSolSysFn
    LSetup::SUNNonlinSolLSetupFn
    LSolve::SUNNonlinSolLSolveFn
    CTest::SUNNonlinSolConvTestFn
    delta::N_Vector
    jcur::Cint
    curiter::Cint
    maxiters::Cint
    niters::Clong
    nconvfails::Clong
    ctest_data::Ptr{Cvoid}
end

const SUNNonlinearSolverContent_Newton = Ptr{_SUNNonlinearSolverContent_Newton}

const ARK_NORMAL = Cint(1)

const ARK_ONE_STEP = Cint(2)

const ARK_INTERP_MAX_DEGREE = Cint(7)

const ARK_INTERP_HERMITE = Cint(4)

const ARK_INTERP_LAGRANGE = Cint(1)

const ARK_SUCCESS = Cint(0)

const ARK_TSTOP_RETURN = Cint(1)

const ARK_ROOT_RETURN = Cint(2)

const ARK_WARNING = Cint(99)

const ARK_TOO_MUCH_WORK = -1

const ARK_TOO_MUCH_ACC = -2

const ARK_ERR_FAILURE = -3

const ARK_CONV_FAILURE = -4

const ARK_LINIT_FAIL = -5

const ARK_LSETUP_FAIL = -6

const ARK_LSOLVE_FAIL = -7

const ARK_RHSFUNC_FAIL = -8

const ARK_FIRST_RHSFUNC_ERR = -9

const ARK_REPTD_RHSFUNC_ERR = -10

const ARK_UNREC_RHSFUNC_ERR = -11

const ARK_RTFUNC_FAIL = -12

const ARK_LFREE_FAIL = -13

const ARK_MASSINIT_FAIL = -14

const ARK_MASSSETUP_FAIL = -15

const ARK_MASSSOLVE_FAIL = -16

const ARK_MASSFREE_FAIL = -17

const ARK_MASSMULT_FAIL = -18

const ARK_CONSTR_FAIL = -19

const ARK_MEM_FAIL = -20

const ARK_MEM_NULL = -21

const ARK_ILL_INPUT = -22

const ARK_NO_MALLOC = -23

const ARK_BAD_K = -24

const ARK_BAD_T = -25

const ARK_BAD_DKY = -26

const ARK_TOO_CLOSE = -27

const ARK_VECTOROP_ERR = -28

const ARK_NLS_INIT_FAIL = -29

const ARK_NLS_SETUP_FAIL = -30

const ARK_NLS_SETUP_RECVR = -31

const ARK_NLS_OP_ERR = -32

const ARK_INNERSTEP_ATTACH_ERR = -33

const ARK_INNERSTEP_FAIL = -34

const ARK_OUTERTOINNER_FAIL = -35

const ARK_INNERTOOUTER_FAIL = -36

const ARK_POSTPROCESS_FAIL = -37

const ARK_POSTPROCESS_STEP_FAIL = -37

const ARK_POSTPROCESS_STAGE_FAIL = -38

const ARK_USER_PREDICT_FAIL = -39

const ARK_INTERP_FAIL = -40

const ARK_UNRECOGNIZED_ERROR = -99

const HEUN_EULER_2_1_2 = Cint(0)

const DEFAULT_ERK_2 = HEUN_EULER_2_1_2

const BOGACKI_SHAMPINE_4_2_3 = Cint(1)

const DEFAULT_ERK_3 = BOGACKI_SHAMPINE_4_2_3

const ZONNEVELD_5_3_4 = Cint(3)

const DEFAULT_ERK_4 = ZONNEVELD_5_3_4

const CASH_KARP_6_4_5 = Cint(6)

const DEFAULT_ERK_5 = CASH_KARP_6_4_5

const VERNER_8_5_6 = Cint(10)

const DEFAULT_ERK_6 = VERNER_8_5_6

const FEHLBERG_13_7_8 = Cint(11)

const DEFAULT_ERK_8 = FEHLBERG_13_7_8

const SDIRK_2_1_2 = Cint(100)

const DEFAULT_DIRK_2 = SDIRK_2_1_2

const ARK324L2SA_DIRK_4_2_3 = Cint(104)

const DEFAULT_DIRK_3 = ARK324L2SA_DIRK_4_2_3

const SDIRK_5_3_4 = Cint(107)

const DEFAULT_DIRK_4 = SDIRK_5_3_4

const ARK548L2SA_DIRK_8_4_5 = Cint(111)

const DEFAULT_DIRK_5 = ARK548L2SA_DIRK_8_4_5

const ARK324L2SA_ERK_4_2_3 = Cint(2)

const DEFAULT_ARK_ETABLE_3 = ARK324L2SA_ERK_4_2_3

const ARK436L2SA_ERK_6_3_4 = Cint(4)

const DEFAULT_ARK_ETABLE_4 = ARK436L2SA_ERK_6_3_4

const ARK548L2SA_ERK_8_4_5 = Cint(9)

const DEFAULT_ARK_ETABLE_5 = ARK548L2SA_ERK_8_4_5

const DEFAULT_ARK_ITABLE_3 = ARK324L2SA_DIRK_4_2_3

const ARK436L2SA_DIRK_6_3_4 = Cint(109)

const DEFAULT_ARK_ITABLE_4 = ARK436L2SA_DIRK_6_3_4

const DEFAULT_ARK_ITABLE_5 = ARK548L2SA_DIRK_8_4_5

const BILLINGTON_3_3_2 = Cint(101)

const TRBDF2_3_3_2 = Cint(102)

const KVAERNO_4_2_3 = Cint(103)

const CASH_5_2_4 = Cint(105)

const CASH_5_3_4 = Cint(106)

const KVAERNO_5_3_4 = Cint(108)

const KVAERNO_7_4_5 = Cint(110)

const ARK437L2SA_DIRK_7_3_4 = Cint(112)

const ARK548L2SAb_DIRK_8_4_5 = Cint(113)

const MIN_DIRK_NUM = Cint(100)

const MAX_DIRK_NUM = Cint(113)

const SAYFY_ABURUB_6_3_4 = Cint(5)

const FEHLBERG_6_4_5 = Cint(7)

const DORMAND_PRINCE_7_4_5 = Cint(8)

const KNOTH_WOLKE_3_3 = Cint(12)

const ARK437L2SA_ERK_7_3_4 = Cint(13)

const ARK548L2SAb_ERK_8_4_5 = Cint(14)

const MIN_ERK_NUM = Cint(0)

const MAX_ERK_NUM = Cint(14)

const ARKLS_SUCCESS = Cint(0)

const ARKLS_MEM_NULL = -1

const ARKLS_LMEM_NULL = -2

const ARKLS_ILL_INPUT = -3

const ARKLS_MEM_FAIL = -4

const ARKLS_PMEM_NULL = -5

const ARKLS_MASSMEM_NULL = -6

const ARKLS_JACFUNC_UNRECVR = -7

const ARKLS_JACFUNC_RECVR = -8

const ARKLS_MASSFUNC_UNRECVR = -9

const ARKLS_MASSFUNC_RECVR = -10

const ARKLS_SUNMAT_FAIL = -11

const ARKLS_SUNLS_FAIL = -12

const DEFAULT_MRI_TABLE_3 = KNOTH_WOLKE_3_3

const CV_ADAMS = Cint(1)

const CV_BDF = Cint(2)

const CV_NORMAL = Cint(1)

const CV_ONE_STEP = Cint(2)

const CV_SUCCESS = Cint(0)

const CV_TSTOP_RETURN = Cint(1)

const CV_ROOT_RETURN = Cint(2)

const CV_WARNING = Cint(99)

const CV_TOO_MUCH_WORK = -1

const CV_TOO_MUCH_ACC = -2

const CV_ERR_FAILURE = -3

const CV_CONV_FAILURE = -4

const CV_LINIT_FAIL = -5

const CV_LSETUP_FAIL = -6

const CV_LSOLVE_FAIL = -7

const CV_RHSFUNC_FAIL = -8

const CV_FIRST_RHSFUNC_ERR = -9

const CV_REPTD_RHSFUNC_ERR = -10

const CV_UNREC_RHSFUNC_ERR = -11

const CV_RTFUNC_FAIL = -12

const CV_NLS_INIT_FAIL = -13

const CV_NLS_SETUP_FAIL = -14

const CV_CONSTR_FAIL = -15

const CV_NLS_FAIL = -16

const CV_MEM_FAIL = -20

const CV_MEM_NULL = -21

const CV_ILL_INPUT = -22

const CV_NO_MALLOC = -23

const CV_BAD_K = -24

const CV_BAD_T = -25

const CV_BAD_DKY = -26

const CV_TOO_CLOSE = -27

const CV_VECTOROP_ERR = -28

const CV_UNRECOGNIZED_ERR = -99

const CVDIAG_SUCCESS = Cint(0)

const CVDIAG_MEM_NULL = -1

const CVDIAG_LMEM_NULL = -2

const CVDIAG_ILL_INPUT = -3

const CVDIAG_MEM_FAIL = -4

const CVDIAG_INV_FAIL = -5

const CVDIAG_RHSFUNC_UNRECVR = -6

const CVDIAG_RHSFUNC_RECVR = -7

const CVLS_SUCCESS = Cint(0)

const CVLS_MEM_NULL = -1

const CVLS_LMEM_NULL = -2

const CVLS_ILL_INPUT = -3

const CVLS_MEM_FAIL = -4

const CVLS_PMEM_NULL = -5

const CVLS_JACFUNC_UNRECVR = -6

const CVLS_JACFUNC_RECVR = -7

const CVLS_SUNMAT_FAIL = -8

const CVLS_SUNLS_FAIL = -9

const CV_SIMULTANEOUS = Cint(1)

const CV_STAGGERED = Cint(2)

const CV_STAGGERED1 = Cint(3)

const CV_CENTERED = Cint(1)

const CV_FORWARD = Cint(2)

const CV_HERMITE = Cint(1)

const CV_POLYNOMIAL = Cint(2)

const CV_NO_QUAD = -30

const CV_QRHSFUNC_FAIL = -31

const CV_FIRST_QRHSFUNC_ERR = -32

const CV_REPTD_QRHSFUNC_ERR = -33

const CV_UNREC_QRHSFUNC_ERR = -34

const CV_NO_SENS = -40

const CV_SRHSFUNC_FAIL = -41

const CV_FIRST_SRHSFUNC_ERR = -42

const CV_REPTD_SRHSFUNC_ERR = -43

const CV_UNREC_SRHSFUNC_ERR = -44

const CV_BAD_IS = -45

const CV_NO_QUADSENS = -50

const CV_QSRHSFUNC_FAIL = -51

const CV_FIRST_QSRHSFUNC_ERR = -52

const CV_REPTD_QSRHSFUNC_ERR = -53

const CV_UNREC_QSRHSFUNC_ERR = -54

const CV_NO_ADJ = -101

const CV_NO_FWD = -102

const CV_NO_BCK = -103

const CV_BAD_TB0 = -104

const CV_REIFWD_FAIL = -105

const CV_FWD_FAIL = -106

const CV_GETY_BADT = -107

const CVDIAG_NO_ADJ = -101

const CVLS_NO_ADJ = -101

const CVLS_LMEMB_NULL = -102

const IDA_NORMAL = Cint(1)

const IDA_ONE_STEP = Cint(2)

const IDA_YA_YDP_INIT = Cint(1)

const IDA_Y_INIT = Cint(2)

const IDA_SUCCESS = Cint(0)

const IDA_TSTOP_RETURN = Cint(1)

const IDA_ROOT_RETURN = Cint(2)

const IDA_WARNING = Cint(99)

const IDA_TOO_MUCH_WORK = -1

const IDA_TOO_MUCH_ACC = -2

const IDA_ERR_FAIL = -3

const IDA_CONV_FAIL = -4

const IDA_LINIT_FAIL = -5

const IDA_LSETUP_FAIL = -6

const IDA_LSOLVE_FAIL = -7

const IDA_RES_FAIL = -8

const IDA_REP_RES_ERR = -9

const IDA_RTFUNC_FAIL = -10

const IDA_CONSTR_FAIL = -11

const IDA_FIRST_RES_FAIL = -12

const IDA_LINESEARCH_FAIL = -13

const IDA_NO_RECOVERY = -14

const IDA_NLS_INIT_FAIL = -15

const IDA_NLS_SETUP_FAIL = -16

const IDA_NLS_FAIL = -17

const IDA_MEM_NULL = -20

const IDA_MEM_FAIL = -21

const IDA_ILL_INPUT = -22

const IDA_NO_MALLOC = -23

const IDA_BAD_EWT = -24

const IDA_BAD_K = -25

const IDA_BAD_T = -26

const IDA_BAD_DKY = -27

const IDA_VECTOROP_ERR = -28

const IDA_UNRECOGNIZED_ERROR = -99

const IDALS_SUCCESS = Cint(0)

const IDALS_MEM_NULL = -1

const IDALS_LMEM_NULL = -2

const IDALS_ILL_INPUT = -3

const IDALS_MEM_FAIL = -4

const IDALS_PMEM_NULL = -5

const IDALS_JACFUNC_UNRECVR = -6

const IDALS_JACFUNC_RECVR = -7

const IDALS_SUNMAT_FAIL = -8

const IDALS_SUNLS_FAIL = -9

const IDA_SIMULTANEOUS = Cint(1)

const IDA_STAGGERED = Cint(2)

const IDA_CENTERED = Cint(1)

const IDA_FORWARD = Cint(2)

const IDA_HERMITE = Cint(1)

const IDA_POLYNOMIAL = Cint(2)

const IDA_NO_QUAD = -30

const IDA_QRHS_FAIL = -31

const IDA_FIRST_QRHS_ERR = -32

const IDA_REP_QRHS_ERR = -33

const IDA_NO_SENS = -40

const IDA_SRES_FAIL = -41

const IDA_REP_SRES_ERR = -42

const IDA_BAD_IS = -43

const IDA_NO_QUADSENS = -50

const IDA_QSRHS_FAIL = -51

const IDA_FIRST_QSRHS_ERR = -52

const IDA_REP_QSRHS_ERR = -53

const IDA_NO_ADJ = -101

const IDA_NO_FWD = -102

const IDA_NO_BCK = -103

const IDA_BAD_TB0 = -104

const IDA_REIFWD_FAIL = -105

const IDA_FWD_FAIL = -106

const IDA_GETY_BADT = -107

const IDALS_NO_ADJ = -101

const IDALS_LMEMB_NULL = -102

const KIN_SUCCESS = Cint(0)

const KIN_INITIAL_GUESS_OK = Cint(1)

const KIN_STEP_LT_STPTOL = Cint(2)

const KIN_WARNING = Cint(99)

const KIN_MEM_NULL = -1

const KIN_ILL_INPUT = -2

const KIN_NO_MALLOC = -3

const KIN_MEM_FAIL = -4

const KIN_LINESEARCH_NONCONV = -5

const KIN_MAXITER_REACHED = -6

const KIN_MXNEWT_5X_EXCEEDED = -7

const KIN_LINESEARCH_BCFAIL = -8

const KIN_LINSOLV_NO_RECOVERY = -9

const KIN_LINIT_FAIL = -10

const KIN_LSETUP_FAIL = -11

const KIN_LSOLVE_FAIL = -12

const KIN_SYSFUNC_FAIL = -13

const KIN_FIRST_SYSFUNC_ERR = -14

const KIN_REPTD_SYSFUNC_ERR = -15

const KIN_VECTOROP_ERR = -16

const KIN_ETACHOICE1 = Cint(1)

const KIN_ETACHOICE2 = Cint(2)

const KIN_ETACONSTANT = Cint(3)

const KIN_NONE = Cint(0)

const KIN_LINESEARCH = Cint(1)

const KIN_PICARD = Cint(2)

const KIN_FP = Cint(3)

const KINBBDPRE_SUCCESS = Cint(0)

const KINBBDPRE_PDATA_NULL = -11

const KINBBDPRE_FUNC_UNRECVR = -12

const KINLS_SUCCESS = Cint(0)

const KINLS_MEM_NULL = -1

const KINLS_LMEM_NULL = -2

const KINLS_ILL_INPUT = -3

const KINLS_MEM_FAIL = -4

const KINLS_PMEM_NULL = -5

const KINLS_JACFUNC_ERR = -6

const KINLS_SUNMAT_FAIL = -7

const KINLS_SUNLS_FAIL = -8

const SUNDIALS_VERSION = "5.2.0"

const SUNDIALS_VERSION_MAJOR = Cint(5)

const SUNDIALS_VERSION_MINOR = Cint(2)

const SUNDIALS_VERSION_PATCH = Cint(0)

const SUNDIALS_VERSION_LABEL = ""

const SUNDIALS_DOUBLE_PRECISION = Cint(1)

const SUNDIALS_INT64_T = Cint(1)

const SUNDIALS_INDEX_TYPE = int64_t

const SUNDIALS_MPI_COMM_F2C = Cint(0)

const SUNDIALS_DENSE = Cint(1)

const SUNDIALS_BAND = Cint(2)

const FCMIX_CVODE = Cint(1)

const FCMIX_IDA = Cint(2)

const FCMIX_KINSOL = Cint(3)

const FCMIX_ARKODE = Cint(4)

const dcopy_f77 = nothing

const dscal_f77 = nothing

const dgemv_f77 = nothing

const dtrsv_f77 = nothing

const dsyrk_f77 = nothing

const dgbtrf_f77 = nothing

const dgbtrs_f77 = nothing

const dgetrf_f77 = nothing

const dgetrs_f77 = nothing

const dgeqp3_f77 = nothing

const dgeqrf_f77 = nothing

const dormqr_f77 = nothing

const dpotrf_f77 = nothing

const dpotrs_f77 = nothing

const scopy_f77 = nothing

const sscal_f77 = nothing

const sgemv_f77 = nothing

const strsv_f77 = nothing

const ssyrk_f77 = nothing

const sgbtrf_f77 = nothing

const sgbtrs_f77 = nothing

const sgetrf_f77 = nothing

const sgetrs_f77 = nothing

const sgeqp3_f77 = nothing

const sgeqrf_f77 = nothing

const sormqr_f77 = nothing

const spotrf_f77 = nothing

const spotrs_f77 = nothing

const SUNLS_SUCCESS = Cint(0)

const SUNLS_MEM_NULL = -801

const SUNLS_ILL_INPUT = -802

const SUNLS_MEM_FAIL = -803

const SUNLS_ATIMES_FAIL_UNREC = -804

const SUNLS_PSET_FAIL_UNREC = -805

const SUNLS_PSOLVE_FAIL_UNREC = -806

const SUNLS_PACKAGE_FAIL_UNREC = -807

const SUNLS_GS_FAIL = -808

const SUNLS_QRSOL_FAIL = -809

const SUNLS_VECTOROP_ERR = -810

const SUNLS_RES_REDUCED = Cint(801)

const SUNLS_CONV_FAIL = Cint(802)

const SUNLS_ATIMES_FAIL_REC = Cint(803)

const SUNLS_PSET_FAIL_REC = Cint(804)

const SUNLS_PSOLVE_FAIL_REC = Cint(805)

const SUNLS_PACKAGE_FAIL_REC = Cint(806)

const SUNLS_QRFACT_FAIL = Cint(807)

const SUNLS_LUFACT_FAIL = Cint(808)

const SUNMAT_SUCCESS = Cint(0)

const SUNMAT_ILL_INPUT = -701

const SUNMAT_MEM_FAIL = -702

const SUNMAT_OPERATION_FAIL = -703

const SUNMAT_MATVEC_SETUP_REQUIRED = -704

const MPI_SUNREALTYPE = MPI_DOUBLE

const MPI_SUNINDEXTYPE = MPI_INT64_T

const PVEC_REAL_MPI_TYPE = MPI_SUNREALTYPE

const PVEC_INTEGER_MPI_TYPE = MPI_SUNINDEXTYPE

const SUN_NLS_SUCCESS = Cint(0)

const SUN_NLS_CONTINUE = +901

const SUN_NLS_CONV_RECVR = +902

const SUN_NLS_MEM_NULL = -901

const SUN_NLS_MEM_FAIL = -902

const SUN_NLS_ILL_INPUT = -903

const SUN_NLS_VECTOROP_ERR = -904

const SUN_NLS_EXT_FAIL = -905

# Skipping MacroDefinition: _SUNDIALS_STRUCT_ struct

const BIG_REAL = DBL_MAX

const SMALL_REAL = DBL_MIN

const UNIT_ROUNDOFF = DBL_EPSILON

const booleantype = Cint

const SUNFALSE = Cint(0)

const SUNTRUE = Cint(1)

const SUNKLU_ORDERING_DEFAULT = Cint(1)

const SUNKLU_REINIT_FULL = Cint(1)

const SUNKLU_REINIT_PARTIAL = Cint(2)

const sun_klu_symbolic = nothing

const sun_klu_numeric = nothing

const sun_klu_common = nothing

const sun_klu_analyze = nothing

const sun_klu_factor = nothing

const sun_klu_refactor = nothing

const sun_klu_rcond = nothing

const sun_klu_condest = nothing

const sun_klu_defaults = nothing

const sun_klu_free_symbolic = nothing

const sun_klu_free_numeric = nothing

const xgbtrf_f77 = dgbtrf_f77

const xgbtrs_f77 = dgbtrs_f77

const xgetrf_f77 = dgetrf_f77

const xgetrs_f77 = dgetrs_f77

const SUNPCG_MAXL_DEFAULT = Cint(5)

const SUNSPBCGS_MAXL_DEFAULT = Cint(5)

const SUNSPFGMR_MAXL_DEFAULT = Cint(5)

const SUNSPFGMR_MAXRS_DEFAULT = Cint(0)

const SUNSPFGMR_GSTYPE_DEFAULT = MODIFIED_GS

const SUNSPGMR_MAXL_DEFAULT = Cint(5)

const SUNSPGMR_MAXRS_DEFAULT = Cint(0)

const SUNSPGMR_GSTYPE_DEFAULT = MODIFIED_GS

const SUNSPTFQMR_MAXL_DEFAULT = Cint(5)

const CSC_MAT = Cint(0)

const CSR_MAT = Cint(1)

using SciMLTesting, Sundials, Test
using JET

include("public_api_docs.jl")

# ExplicitImports ignore-lists below are all names owned by / non-public in OTHER
# packages that Sundials legitimately uses; they will stop being flagged once those
# upstream packages mark them public.

# SciMLBase-owned names that Sundials accesses qualified via DiffEqBase's re-export
# rather than via their owner SciMLBase. `__init`/`__solve` are pending make-public in
# SciMLBase (#1411); `postamble!` and `solution_new_retcode` are non-public SciMLBase
# solver/integrator internals that have no make-public planned.
const QUALIFIED_VIA_OWNERS_IGNORE = (
    :__init, :__solve, :postamble!, :solution_new_retcode,
)

# Names accessed qualified that are not (yet) declared public in their owning module.
# `@pure` is a Base internal; `FasterForward` is non-public in DataStructures. The
# remainder are SciMLBase-owned solver-extension hooks not yet marked public:
# interpolation/problem types and the dae/error/init/retcode helpers (now accessed via
# their owner SciMLBase, except `__init`/`__solve`/`postamble!`/`solution_new_retcode`
# which are still routed through DiffEqBase's re-export). They drop once SciMLBase
# declares them public.
const QUALIFIED_PUBLIC_IGNORE = (
    Symbol("@pure"),
    :FasterForward,
    :AbstractSteadyStateProblem, :HermiteInterpolation, :LinearInterpolation,
    :__init, :__solve, :calculate_solution_errors!, :initialize_dae!,
    :postamble!, :solution_new_retcode,
)

# Aqua + ExplicitImports via the SciMLTesting v1.7 harness. JET is handled by the
# dedicated constructor testset below (`jet = false` here): run_qa's default JET runs
# `report_package` over the whole module, which on JET 0.11 (Julia >= 1.11) reports
# conditionally-assigned locals in the solver-init paths (e.g. the SUNMatrix/
# SUNLinearSolver handles in `__init`) that are correct at runtime but that JET 0.11
# cannot prove defined. JET 0.9 (Julia LTS) does not report them, so neither
# `jet = true` (fails on Julia 1) nor `jet_broken = true` (Unexpected Pass / errors on
# LTS) is green-or-broken on both CI lanes. Tracked in SciML/Sundials.jl#541 for a
# separate solver-init fix.
run_qa(
    Sundials;
    explicit_imports = true,
    jet = false,
    aqua_kwargs = (; piracies = (; treat_as_own = [Sundials.NVector])),
    ei_kwargs = (;
        # AbstractSciMLOperator: owner SciMLOperators, imported via SciMLBase re-export.
        all_explicit_imports_via_owners = (; ignore = (:AbstractSciMLOperator,)),
        all_qualified_accesses_via_owners = (; ignore = QUALIFIED_VIA_OWNERS_IGNORE),
        all_qualified_accesses_are_public = (; ignore = QUALIFIED_PUBLIC_IGNORE),
        # AbstractSciMLOperator: owner SciMLOperators, imported via SciMLBase re-export;
        # not yet declared public in SciMLBase.
        all_explicit_imports_are_public = (; ignore = (:AbstractSciMLOperator,)),
    ),
)

@testset "JET static analysis" begin
    @testset "Algorithm constructors" begin
        for C in (
                Sundials.CVODE_BDF, Sundials.CVODE_Adams, Sundials.IDA,
                Sundials.ARKODE, Sundials.KINSOL,
            )
            rep = JET.report_call(C, ())
            @test length(JET.get_reports(rep)) == 0
        end
    end
end

using Sundials

function f!(resid, x)
    for i in eachindex(x)
        resid[i] = sin(x[i]) + x[i]^3
    end
    return
end
x = ones(5)
@test Sundials.kinsol(f!, x; linear_solver = :Band, jac_upper = 0, jac_lower = 0) ==
    Sundials.kinsol(f!, x)

@test Sundials.kinsol(f!, x; linear_solver = :LapackBand, jac_upper = 0, jac_lower = 0) ==
    Sundials.kinsol(f!, x)

function f_iip(du, u, p, t)
    return @. du = sin(u) + u^3
end
function f_iip(du, u, p)
    return @. du = sin(u) + u^3
end
function f_oop(u, p, t)
    return @. sin(u) + u^3
end
function f_oop(u, p)
    return @. sin(u) + u^3
end

#Testing KINSOL()
u0 = ones(5)
prob_iip = SteadyStateProblem(f_iip, u0)
prob_oop = SteadyStateProblem(f_oop, u0)

@test maximum(solve(prob_iip, KINSOL(); abstol = 1.0e-6).u) ≥ 1.0e-10
@test maximum(solve(prob_iip, KINSOL(); abstol = 1.0e-12).u) ≤ 1.0e-10

@test solve(prob_iip, KINSOL()) ==
    solve(prob_iip, KINSOL(; linear_solver = :Band, jac_upper = 0, jac_lower = 0))
@test solve(prob_oop, KINSOL()) ==
    solve(prob_oop, KINSOL(; linear_solver = :Band, jac_upper = 0, jac_lower = 0))
@test solve(prob_iip, KINSOL(); abstol = 1.0e-12) ==
    solve(
    prob_iip, KINSOL(; linear_solver = :Band, jac_upper = 0, jac_lower = 0);
    abstol = 1.0e-12
)
@test solve(prob_oop, KINSOL()) ==
    solve(prob_oop, KINSOL(; linear_solver = :Band, jac_upper = 0, jac_lower = 0))
prob_iip = NonlinearProblem(f_iip, u0)
prob_oop = NonlinearProblem(f_oop, u0)
@test solve(prob_iip, KINSOL()) ==
    solve(prob_iip, KINSOL(; linear_solver = :Band, jac_upper = 0, jac_lower = 0))
@test solve(prob_oop, KINSOL()) ==
    solve(prob_oop, KINSOL(; linear_solver = :Band, jac_upper = 0, jac_lower = 0))

using Documenter, Sundials

DocMeta.setdocmeta!(
    Sundials, :DocTestSetup, :(using Sundials); recursive = true
)

makedocs(
    sitename = "Sundials.jl",
    authors = "Chris Rackauckas",
    clean = true,
    doctest = false,
    format = Documenter.HTML(
        canonical = "https://docs.sciml.ai/Sundials/stable/"
    ),
    pages = [
        "Home" => "index.md",
    ]
)

deploydocs(
    repo = "github.com/SciML/Sundials.jl";
    push_preview = true
)

using Sundials, Test

callback_f = function (du, u, p, t)
    du[1] = u[2]
    return du[2] = -9.81
end

condition = function (u, t, integrator) # Event when event_f(u,t,k) == 0
    return u[1]
end

affect! = nothing
affect_neg! = function (integrator)
    return integrator.u[2] = -integrator.u[2]
end

callback = ContinuousCallback(condition, affect!, affect_neg!)

u0 = [50.0, 0.0]
tspan = (0.0, 15.0)
prob = ODEProblem(callback_f, u0, tspan)

sol = solve(prob, CVODE_Adams(); callback = callback)
@test sol(4.0)[1] > 0
sol = solve(prob, CVODE_BDF(); callback = callback)
@test sol(4.0)[1] > 0

condition = function (out, u, t, integrator)
    return out[1] = u[1]
end

# DiffEqBase v7 changed the VectorContinuousCallback dispatch: `affect_neg!` is no
# longer invoked. `affect!` now receives the full `simultaneous_events::Vector{Int8}`
# (entries `+1` upcrossing, `-1` downcrossing, `0` no event); a non-`nothing`
# `affect_neg!` is only used to gate downcrossing *detection*.
# Tracked upstream: https://github.com/SciML/OrdinaryDiffEq.jl/issues/3613
affect! = function (integrator, sims)
    return if sims[1] != 0
        integrator.u[2] = -integrator.u[2]
    end
end

callback = VectorContinuousCallback(condition, affect!, 1)
sol = solve(prob, CVODE_Adams(); callback = callback)
@test sol(4.0)[1] > 0
sol = solve(prob, CVODE_BDF(); callback = callback)
@test sol(4.0)[1] > 0

u0 = [1.0, 0.0]
function fun2(du, u, p, t)
    du[2] = -u[1]
    return du[1] = u[2]
end
tspan = (0.0, 10.0)
prob = ODEProblem(fun2, u0, tspan)

function condition2(u, t, integrator)
    return get_du(integrator)[1] > 0
end
affect2!(integrator) = terminate!(integrator)
times_finalize_called = 0
cb = DiscreteCallback(condition2, affect2!, finalize = (args...) -> global times_finalize_called += 1)
sol = solve(prob, CVODE_BDF(); callback = cb)
@test sol.t[end] < 3.5
@test times_finalize_called == 1

condition3(u, t, integrator) = u[2]
affect3!(integrator) = terminate!(integrator)
cb = ContinuousCallback(condition3, affect3!)
sol = solve(prob, CVODE_Adams(); callback = cb, abstol = 1.0e-12, reltol = 1.0e-12)
@test sol.t[end] ≈ pi

# test that a BitVector in combination with callback gets converted to a NVector correctly
fbv = function (out, du, u, p, t)
    out[1] = -p[1] * u[1] + p[3] * u[2] * u[3] - du[1]
    out[2] = +p[1] * u[1] - p[2] * u[2]^2 - p[3] * u[2] * u[3] - du[2]
    return out[3] = u[1] + u[2] + u[3] - p[4]
end
u₀ = [1.0, 0, 0]
du₀ = [0.0, 0.0, 0.0]
p = [0.04, 3.0e7, 1.0e4, 1.0]
tspan = (0.0, 100.0)
differential_vars = BitVector([true, true, false])
bvcond(u, t, integrator) = t - round(t)
bvaffect!(integrator) = integrator.p[4] = 2.0
cb = ContinuousCallback(bvcond, bvaffect!; initializealg = Sundials.BrownFullBasicInit())
prob = DAEProblem(fbv, du₀, u₀, tspan, p, differential_vars = differential_vars)
sol = solve(prob, IDA(), callback = cb, tstops = [50.0], abstol = 1.0e-12, reltol = 1.0e-12, initializealg = Sundials.BrownFullBasicInit())
@test sol.t[end] ≈ 100.0

# Test that SubArrays are not allowed as outputs to the integrator
u_out = similar(u₀)
cb = DiscreteCallback(Returns(true), integ -> integ(@view(u_out[2:2]), integ.t))
prob = DAEProblem(fbv, du₀, u₀, tspan, p, differential_vars = differential_vars)
@test_throws ArgumentError solve(prob, IDA(), initializealg = Sundials.BrownFullBasicInit(), callback = cb)

using Sundials, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

prob = prob_ode_linear
dt = 1 // 2^(4)
sol = solve(prob, ARKODE())
@test sol.errors[:l2] < 5.0e-2
sol = solve(prob, ARKODE(); abstol = [1.0e-7])

f1 = (du, u, p, t) -> du .= u
f2 = (du, u, p, t) -> du .= u

prob = prob_ode_2Dlinear
dt = 1 // 2^(4)
# Testing LapackDense solver
sol_lapack = solve(prob, ARKODE(; linear_solver = :LapackDense))
@test sol_lapack.retcode == ReturnCode.Success

prob = SplitODEProblem(
    SplitFunction(f1, f2; analytic = (u0, p, t) -> exp(2t) * u0),
    rand(4, 2),
    (0.0, 1.0)
)

sol = solve(prob, ARKODE(; linear_solver = :Dense))
@test sol.errors[:l2] < 1.0e-2

# Testing LapackBand solver
sol = solve(
    prob,
    ARKODE(; linear_solver = :LapackBand, jac_upper = 3, jac_lower = 3);
    reltol = 1.0e-12,
    abstol = 1.0e-12
)
@test sol.errors[:l2] < 1.0e-6

#
# Test for Sundials.jl issue #253
#
# ARKStepSetERKTableNum not defined
#
# COMMENTED OUT: Causes segfault in SUNDIALS 7.4 - SUNNonlinSolGetType error
# The max_nonlinear_iters parameter seems incompatible with explicit RK methods in 7.4
#
# Function
function Eq_Dif(dq, q, t)
    return dq .= 10 * q
end
# Alias
fn(dq, q, p, t) = Eq_Dif(dq, q, t)
# Time span
tspan = (0.0, 1.0)
# Initial values
q = zeros(10)
# Define problem
prob = ODEProblem(fn, q, tspan)
# Test explicit ARKODE methods with ERKStep
method = ARKODE(
    Sundials.Explicit();
    etable = Sundials.VERNER_8_5_6,
    order = 8,
    set_optimal_params = false,
    max_hnil_warns = 10,
    max_error_test_failures = 7
)
# Removed max_nonlinear_iters and max_convergence_failures as they don't apply to explicit methods
# Solve
sol = solve(prob, method)
@test sol.retcode == ReturnCode.Success

# Simpler explicit ARKODE test
method2 = ARKODE(Sundials.Explicit(); etable = Sundials.VERNER_8_5_6)
sol2 = solve(prob, method2)
@test sol2.retcode == ReturnCode.Success

# Also test default implicit ARKODE method
method = ARKODE()
sol = solve(prob, method)
@test sol.retcode == ReturnCode.Success

#test that save_start and save_end are false by default when saveat is set
sol = solve(prob, ARKODE(), saveat = [0.1, 0.2])
@test sol.t == [0.1, 0.2]

using Sundials, Test
using Sundials: N_Vector

ctx_ref = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ref))
ctx = ctx_ref[]

# Simple index-1 DAE with a known analytical solution and analytical parameter
# sensitivity, used to exercise the IDAS forward sensitivity pathway.
#
#     F1 = y1' + a*y1 = 0     (differential)
#     F2 = y2 - y1   = 0      (algebraic)
#
# with y1(0) = 1, y2(0) = 1 gives y1(t) = y2(t) = exp(-a*t).
# The sensitivity s = dy/da satisfies s1(t) = s2(t) = -t*exp(-a*t).

mutable struct IDASForwardData
    a::Float64
end

function idas_res(t::Float64, yy::N_Vector, yp::N_Vector, rr::N_Vector, data::IDASForwardData)
    yyv = convert(Vector, yy)
    ypv = convert(Vector, yp)
    rrv = convert(Vector, rr)
    rrv[1] = ypv[1] + data.a * yyv[1]
    rrv[2] = yyv[2] - yyv[1]
    return Sundials.IDA_SUCCESS
end

# Sensitivity residual (IDASensResFn) for Ns = 1 parameter (a):
#   resS1 = a*s1 + sp1 + y1     (dF1/dy·s + dF1/dy'·s' + dF1/da)
#   resS2 = s2 - s1             (dF2/dy·s)
function idas_sens_res(
        Ns::Cint, t::Float64, yy::N_Vector, yp::N_Vector, rr::N_Vector,
        yyS::Ptr{N_Vector}, ypS::Ptr{N_Vector}, rrS::Ptr{N_Vector},
        data::IDASForwardData, tmp1::N_Vector, tmp2::N_Vector, tmp3::N_Vector
    )
    yyv = convert(Vector, yy)
    s = convert(Vector, unsafe_load(yyS, 1))
    sp = convert(Vector, unsafe_load(ypS, 1))
    resS = convert(Vector, unsafe_load(rrS, 1))
    resS[1] = data.a * s[1] + sp[1] + yyv[1]
    resS[2] = s[2] - s[1]
    return Sundials.IDA_SUCCESS
end

function solve_forward(; t0 = 0.0, tf = 2.0, a = 0.3)
    data = IDASForwardData(a)
    neq = 2
    Ns = 1

    cres = @cfunction(
        idas_res, Cint,
        (Sundials.realtype, N_Vector, N_Vector, N_Vector, Ref{IDASForwardData})
    )
    csens = @cfunction(
        idas_sens_res, Cint,
        (
            Cint, Sundials.realtype, N_Vector, N_Vector, N_Vector,
            Ptr{N_Vector}, Ptr{N_Vector}, Ptr{N_Vector},
            Ref{IDASForwardData}, N_Vector, N_Vector, N_Vector,
        )
    )

    yy0 = [1.0, 1.0]
    yp0 = [-a, -a]
    yy0n = Sundials.NVector(yy0, ctx)
    yp0n = Sundials.NVector(yp0, ctx)

    mem = Sundials.Handle(Sundials.IDACreate(ctx))
    @test Sundials.IDAInit(mem, cres, t0, yy0n, yp0n) == Sundials.IDA_SUCCESS
    @test Sundials.IDASStolerances(mem, 1.0e-10, 1.0e-12) == Sundials.IDA_SUCCESS
    @test Sundials.IDASetUserData(mem, data) == Sundials.IDA_SUCCESS

    A = Sundials.SUNDenseMatrix(neq, neq, ctx)
    LS = Sundials.SUNLinSol_Dense(yy0n, A, ctx)
    @test Sundials.IDASetLinearSolver(mem, LS, A) == Sundials.IDA_SUCCESS

    # Sensitivity initial conditions: s(0) = 0, s'(0) = [-1, -1].
    yS0 = Sundials.NVectorArray([Sundials.NVector([0.0, 0.0], ctx)])
    ypS0 = Sundials.NVectorArray([Sundials.NVector([-1.0, -1.0], ctx)])
    ySout = Sundials.NVectorArray([Sundials.NVector([0.0, 0.0], ctx)])

    @test Sundials.IDASensInit(mem, Ns, Sundials.IDA_SIMULTANEOUS, csens, yS0, ypS0) ==
        Sundials.IDA_SUCCESS
    @test Sundials.IDASensEEtolerances(mem) == Sundials.IDA_SUCCESS
    pbar = [a]
    @test Sundials.IDASetSensParams(mem, C_NULL, pbar, C_NULL) == Sundials.IDA_SUCCESS

    yy = similar(yy0)
    yp = similar(yp0)
    yyn = Sundials.NVector(yy, ctx)
    ypn = Sundials.NVector(yp, ctx)
    tret = [t0]

    local yout, sout
    GC.@preserve data yy0n yp0n yS0 ypS0 ySout pbar A LS begin
        @test Sundials.IDASolve(mem, tf, tret, yyn, ypn, Sundials.IDA_NORMAL) ==
            Sundials.IDA_SUCCESS
        @test Sundials.IDAGetSens(mem, tret, ySout) == Sundials.IDA_SUCCESS
        yout = copy(convert(Vector, yyn))
        sout = copy(convert(Vector, ySout.nvectors[1]))
    end

    Sundials.SUNLinSolFree_Dense(LS)
    Sundials.SUNMatDestroy_Dense(A)
    empty!(mem)

    return yout, sout
end

yout, sout = solve_forward()

a = 0.3
tf = 2.0
@test isapprox(yout[1], exp(-a * tf); rtol = 1.0e-7)
@test isapprox(yout[2], exp(-a * tf); rtol = 1.0e-7)
@test isapprox(sout[1], -tf * exp(-a * tf); rtol = 1.0e-6)
@test isapprox(sout[2], -tf * exp(-a * tf); rtol = 1.0e-6)

Sundials.SUNContext_Free(ctx)

using Sundials, Test

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]

h1 = Sundials.Handle(Sundials.CVodeCreate(Sundials.CV_BDF, ctx))
h2 = h1

@test !isempty(h1)
@test !isempty(h2)

empty!(h1)

@test isempty(h1)
@test isempty(h2) # Check that the pointers are correct, and h1 empties h2

empty!(h1) # Make sure this does not throw

h = Sundials.Handle(h1.ptr) # Check construction with null pointers
@test isempty(h)

neq = 3
h3 = Sundials.MatrixHandle(Sundials.SUNDenseMatrix(neq, neq, ctx), Sundials.DenseMatrix())
h3 = Sundials.MatrixHandle(Sundials.SUNDenseMatrix(neq, neq, ctx), Sundials.DenseMatrix())
empty!(h3)
@test isempty(h3)
empty!(h3)
@test isempty(h3)

h3 = Sundials.MatrixHandle(Sundials.SUNBandMatrix(100, 3, 3, ctx), Sundials.BandMatrix())
h3 = Sundials.MatrixHandle(Sundials.SUNBandMatrix(100, 3, 3, ctx), Sundials.BandMatrix())
empty!(h3)
@test isempty(h3)
empty!(h3)
@test isempty(h3)

h3 = Sundials.MatrixHandle(
    Sundials.SUNSparseMatrix(neq, neq, neq, Sundials.CSC_MAT, ctx),
    Sundials.SparseMatrix()
)
h3 = Sundials.MatrixHandle(
    Sundials.SUNSparseMatrix(neq, neq, neq, Sundials.CSC_MAT, ctx),
    Sundials.SparseMatrix()
)
empty!(h3)
@test isempty(h3)
empty!(h3)
@test isempty(h3)

A = Sundials.SUNDenseMatrix(neq, neq, ctx)
u0 = rand(neq)
u0_nvec = Sundials.NVector(u0, ctx)
Sundials.SUNLinSol_Dense(u0_nvec, A, ctx)
h3 = Sundials.LinSolHandle(Sundials.SUNLinSol_Dense(u0_nvec, A, ctx), Sundials.Dense())
h3 = Sundials.LinSolHandle(Sundials.SUNLinSol_Dense(u0_nvec, A, ctx), Sundials.Dense())
empty!(h3)
@test isempty(h3)
empty!(h3)
@test isempty(h3)

# Clean up context
Sundials.SUNContext_Free(ctx)

using Sundials, Test
using Sundials: N_Vector

ctx_ref = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ref))
ctx = ctx_ref[]

# Index-1 DAE used to exercise the IDAS adjoint sensitivity pathway:
#
#     F1 = y1' + a*y1 = 0      (differential)
#     F2 = y2 - y1   = 0       (algebraic)
#
# with y1(0) = 1 gives y1(t) = y2(t) = exp(-a*t). We compute the gradient of
# the terminal functional G(a) = y2(tf) with respect to a via adjoints.
#
# The adjoint DAE (λ = (λ1, λ2)) derived for this problem is
#
#     λ1' - a*λ1 + λ2 = 0      with  λ1(tf) = 1
#     λ2            = 0
#
# and the parameter gradient is  dG/da = ∫_{t0}^{tf} -λ1*y1 dt, which IDAS
# accumulates as a backward quadrature qB with  qB' = λ1*y1,  qB(tf) = 0, so
# that qB(t0) = dG/da. Analytically λ1(t) = exp(a*(t-tf)) and y1(t) = exp(-a*t)
# give λ1(t0) = exp(-a*tf) and dG/da = -tf*exp(-a*tf).

mutable struct IDASAdjointData
    a::Float64
end

function idas_res(t::Float64, yy::N_Vector, yp::N_Vector, rr::N_Vector, data::IDASAdjointData)
    yyv = convert(Vector, yy)
    ypv = convert(Vector, yp)
    rrv = convert(Vector, rr)
    rrv[1] = ypv[1] + data.a * yyv[1]
    rrv[2] = yyv[2] - yyv[1]
    return Sundials.IDA_SUCCESS
end

function idas_resB(
        t::Float64, yy::N_Vector, yp::N_Vector, yB::N_Vector, ypB::N_Vector,
        rrB::N_Vector, data::IDASAdjointData
    )
    yBv = convert(Vector, yB)
    ypBv = convert(Vector, ypB)
    rrBv = convert(Vector, rrB)
    rrBv[1] = ypBv[1] - data.a * yBv[1] + yBv[2]
    rrBv[2] = yBv[2]
    return Sundials.IDA_SUCCESS
end

function idas_quadB(
        t::Float64, yy::N_Vector, yp::N_Vector, yB::N_Vector, ypB::N_Vector,
        qBdot::N_Vector, data::IDASAdjointData
    )
    yyv = convert(Vector, yy)
    yBv = convert(Vector, yB)
    qBdotv = convert(Vector, qBdot)
    qBdotv[1] = yBv[1] * yyv[1]
    return Sundials.IDA_SUCCESS
end

function solve_adjoint(; t0 = 0.0, tf = 2.0, a = 0.3)
    data = IDASAdjointData(a)
    neq = 2

    cres = @cfunction(
        idas_res, Cint,
        (Sundials.realtype, N_Vector, N_Vector, N_Vector, Ref{IDASAdjointData})
    )
    cresB = @cfunction(
        idas_resB, Cint,
        (
            Sundials.realtype, N_Vector, N_Vector, N_Vector, N_Vector, N_Vector,
            Ref{IDASAdjointData},
        )
    )
    cquadB = @cfunction(
        idas_quadB, Cint,
        (
            Sundials.realtype, N_Vector, N_Vector, N_Vector, N_Vector, N_Vector,
            Ref{IDASAdjointData},
        )
    )

    yy0 = [1.0, 1.0]
    yp0 = [-a, -a]
    yy0n = Sundials.NVector(yy0, ctx)
    yp0n = Sundials.NVector(yp0, ctx)

    mem = Sundials.Handle(Sundials.IDACreate(ctx))
    @test Sundials.IDAInit(mem, cres, t0, yy0n, yp0n) == Sundials.IDA_SUCCESS
    @test Sundials.IDASStolerances(mem, 1.0e-10, 1.0e-12) == Sundials.IDA_SUCCESS
    @test Sundials.IDASetUserData(mem, data) == Sundials.IDA_SUCCESS

    A = Sundials.SUNDenseMatrix(neq, neq, ctx)
    LS = Sundials.SUNLinSol_Dense(yy0n, A, ctx)
    @test Sundials.IDASetLinearSolver(mem, LS, A) == Sundials.IDA_SUCCESS

    @test Sundials.IDAAdjInit(mem, 100, Sundials.IDA_HERMITE) == Sundials.IDA_SUCCESS

    yy = similar(yy0)
    yp = similar(yp0)
    yyn = Sundials.NVector(yy, ctx)
    ypn = Sundials.NVector(yp, ctx)
    tret = [t0]
    ncheck = Ref{Cint}(0)

    @test Sundials.IDASolveF(mem, tf, tret, yyn, ypn, Sundials.IDA_NORMAL, ncheck) ==
        Sundials.IDA_SUCCESS

    which = Ref{Cint}(0)
    @test Sundials.IDACreateB(mem, which) == Sundials.IDA_SUCCESS
    w = which[]

    # Terminal conditions of the adjoint DAE: λ(tf) = [1, 0], λ'(tf) = [a, 0].
    yB0 = [1.0, 0.0]
    ypB0 = [a, 0.0]
    yB0n = Sundials.NVector(yB0, ctx)
    ypB0n = Sundials.NVector(ypB0, ctx)

    @test Sundials.IDAInitB(mem, w, cresB, tf, yB0n, ypB0n) == Sundials.IDA_SUCCESS
    @test Sundials.IDASStolerancesB(mem, w, 1.0e-10, 1.0e-12) == Sundials.IDA_SUCCESS
    @test Sundials.IDASetUserDataB(mem, w, data) == Sundials.IDA_SUCCESS

    AB = Sundials.SUNDenseMatrix(neq, neq, ctx)
    LSB = Sundials.SUNLinSol_Dense(yB0n, AB, ctx)
    @test Sundials.IDASetLinearSolverB(mem, w, LSB, AB) == Sundials.IDA_SUCCESS

    qB0 = [0.0]
    qB0n = Sundials.NVector(qB0, ctx)
    @test Sundials.IDAQuadInitB(mem, w, cquadB, qB0n) == Sundials.IDA_SUCCESS
    @test Sundials.IDAQuadSStolerancesB(mem, w, 1.0e-10, 1.0e-12) == Sundials.IDA_SUCCESS

    yBout = [0.0, 0.0]
    ypBout = [0.0, 0.0]
    qBout = [0.0]
    yBoutn = Sundials.NVector(yBout, ctx)
    ypBoutn = Sundials.NVector(ypBout, ctx)
    qBoutn = Sundials.NVector(qBout, ctx)
    tBret = [tf]

    local yf, lambda0, grad_a
    GC.@preserve data yy0n yp0n yyn ypn yB0n ypB0n qB0n yBoutn ypBoutn qBoutn A LS AB LSB begin
        @test Sundials.IDASolveB(mem, t0, Sundials.IDA_NORMAL) >= Sundials.IDA_SUCCESS
        @test Sundials.IDAGetB(mem, w, tBret, yBoutn, ypBoutn) == Sundials.IDA_SUCCESS
        @test Sundials.IDAGetQuadB(mem, w, tBret, qBoutn) == Sundials.IDA_SUCCESS
        yf = copy(convert(Vector, yyn))
        lambda0 = copy(convert(Vector, yBoutn))
        grad_a = copy(convert(Vector, qBoutn))
    end

    Sundials.SUNLinSolFree_Dense(LS)
    Sundials.SUNMatDestroy_Dense(A)
    Sundials.SUNLinSolFree_Dense(LSB)
    Sundials.SUNMatDestroy_Dense(AB)
    empty!(mem)

    return yf, lambda0[1], grad_a[1], tBret[1]
end

yf, lambda0, grad_a, tBret = solve_adjoint()

a = 0.3
tf = 2.0
@test isapprox(yf[1], exp(-a * tf); rtol = 1.0e-7)
@test isapprox(yf[2], exp(-a * tf); rtol = 1.0e-7)
@test isapprox(lambda0, exp(-a * tf); rtol = 1.0e-6)
@test isapprox(grad_a, -tf * exp(-a * tf); rtol = 1.0e-6)
@test isapprox(tBret, 0.0; atol = 1.0e-10)

Sundials.SUNContext_Free(ctx)

using Sundials

## f routine. Compute function f(t,y).

function f(t, y, ydot)
    ydot[1] = -0.04 * y[1] + 1.0e4 * y[2] * y[3]
    ydot[3] = 3.0e7 * y[2] * y[2]
    ydot[2] = -ydot[1] - ydot[3]
    return Sundials.CV_SUCCESS
end

t = [0.0; 4 * exp10.(range(-1.0; stop = 7.0, length = 9))]
y0 = [1.0, 0.0, 0.0]
res = Sundials.cvode(f, y0, t)

# DefaultInit for all Sundials integrators - handles ModelingToolkit parameter initialization
function SciMLBase.initialize_dae!(
        integrator::AbstractSundialsIntegrator,
        initializealg::DefaultInit
    )
    prob = integrator.sol.prob
    return if prob.f.initialization_data !== nothing
        SciMLBase.initialize_dae!(integrator, SciMLBase.OverrideInit())
    else
        SciMLBase.initialize_dae!(integrator, SciMLBase.CheckInit())
    end
end

function SciMLBase.initialize_dae!(
        integrator::IDAIntegrator,
        initializealg::BrownFullBasicInit
    )
    if integrator.u_modified
        IDAReinit!(integrator)
    end
    integrator.f(integrator.tmp, integrator.du, integrator.u, integrator.p, integrator.t)
    tstart, tend = integrator.sol.prob.tspan
    # Use abstol from algorithm parameter (defaults to 1e-10)
    if any(abs.(integrator.tmp) .>= initializealg.abstol)
        if integrator.sol.prob.differential_vars === nothing
            error("Must supply differential_vars argument to DAEProblem constructor to use IDA initial value solver.")
        end
        # BrownFullBasicInit only modifies algebraic variables
        init_type = IDA_YA_YDP_INIT
        # Use preallocated NVector for differential_vars
        if integrator.diff_vars_nvec !== nothing
            integrator.flag = IDASetId(integrator.mem, integrator.diff_vars_nvec)
        else
            error("differential_vars NVector not preallocated but needed for IDASetId")
        end
        dt = integrator.dt == tstart ? tend : integrator.dt
        integrator.flag = IDACalcIC(integrator.mem, init_type, dt)

        # Reflect consistent initial conditions back into the integrator's
        # shadow copy. N.B.: ({du, u}_nvec are aliased to {du, u}).
        IDAGetConsistentIC(integrator.mem, integrator.u_nvec, integrator.du_nvec)
    end
    return if integrator.t == tstart && integrator.flag < 0
        integrator.sol = SciMLBase.solution_new_retcode(
            integrator.sol,
            ReturnCode.InitialFailure
        )
    end
end

function SciMLBase.initialize_dae!(
        integrator::IDAIntegrator,
        initializealg::ShampineCollocationInit
    )
    if integrator.u_modified
        IDAReinit!(integrator)
    end
    integrator.f(integrator.tmp, integrator.du, integrator.u, integrator.p, integrator.t)
    tstart, tend = integrator.sol.prob.tspan
    if any(abs.(integrator.tmp) .>= integrator.opts.reltol)
        # ShampineCollocationInit modifies all variables
        init_type = IDA_Y_INIT
        # Use initdt from algorithm if provided, otherwise fall back to integrator.dt
        dt = if initializealg.initdt !== nothing
            initializealg.initdt
        elseif integrator.dt == tstart
            tend
        else
            integrator.dt
        end
        integrator.flag = IDACalcIC(integrator.mem, init_type, dt)

        # Reflect consistent initial conditions back into the integrator's
        # shadow copy. N.B.: ({du, u}_nvec are aliased to {du, u}).
        IDAGetConsistentIC(integrator.mem, integrator.u_nvec, integrator.du_nvec)
    end
    return if integrator.t == tstart && integrator.flag < 0
        integrator.sol = SciMLBase.solution_new_retcode(
            integrator.sol,
            ReturnCode.InitialFailure
        )
    end
end

function SciMLBase.initialize_dae!(
        integrator::AbstractSundialsIntegrator,
        initializealg::SciMLBase.CheckInit
    )
    # Not allowed to be a DAE, so no-op
end

function SciMLBase.initialize_dae!(integrator::AbstractSundialsIntegrator, initalg::SciMLBase.NoInit) end

function SciMLBase.initialize_dae!(integrator::AbstractSundialsIntegrator, initalg::SciMLBase.OverrideInit)
    prob = integrator.sol.prob
    nlsolve_alg = KINSOL()
    u0, p, success = SciMLBase.get_initial_values(prob, integrator, prob.f, initalg, Val(isinplace(prob)); nlsolve_alg, abstol = integrator.opts.abstol, reltol = integrator.opts.reltol)

    if isinplace(prob)
        integrator.u .= u0
        if length(integrator.sol.u) == 1
            integrator.sol.u[1] .= u0
        end
    else
        integrator.u = u0
        if length(integrator.sol.u) == 1
            integrator.sol.u[1] = u0
        end
    end
    integrator.p = p
    sol = integrator.sol
    @reset sol.prob.p = integrator.p
    integrator.sol = sol

    return if success
        integrator.u_modified = true
    else
        integrator.sol = SciMLBase.solution_new_retcode(integrator.sol, ReturnCode.InitialFailure)
    end
end

# Implementation of CheckInit for IDAIntegrator
function SciMLBase.initialize_dae!(
        integrator::IDAIntegrator,
        initializealg::SciMLBase.CheckInit
    )
    if integrator.u_modified
        IDAReinit!(integrator)
    end

    # Evaluate the DAE residual at the initial conditions
    integrator.f(integrator.tmp, integrator.du, integrator.u, integrator.p, integrator.t)

    # Check if residuals are within tolerance
    return if any(abs.(integrator.tmp) .>= integrator.opts.abstol)
        error(
            """
            DAE initialization failed with CheckInit: Initial conditions do not satisfy the DAE constraints.

            The residual norm is $(maximum(abs.(integrator.tmp))), which exceeds the tolerance $(integrator.opts.abstol).

            Note that the initial conditions include both `du0` (derivatives) and `u0` (states),
            and the choice of derivatives must be compatible with the states.

            To resolve this issue, you have several options:
            1. Fix your initial conditions (both `du0` and `u0`) to satisfy the DAE constraints
            2. Use Brown's full basic initialization: initializealg = DiffEqBase.BrownFullBasicInit()
               - Optional: specify tolerance with DiffEqBase.BrownFullBasicInit(abstol=1e-8)
            3. Use Shampine's collocation initialization: initializealg = DiffEqBase.ShampineCollocationInit()
               - Optional: specify initial dt with DiffEqBase.ShampineCollocationInit(0.001)
            4. If using ModelingToolkit, use: initializealg = SciMLBase.OverrideInit()

            Example for automatic initialization:
            solve(prob, IDA(); initializealg = DiffEqBase.BrownFullBasicInit())
            """
        )
    end
end

using Sundials

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]

#=
Test adapted from https://github.com/LLNL/sundials/blob/master/examples/arkode/C_serial/ark_analytic_nonlin.c
/*-----------------------------------------------------------------
 * Programmer(s): Daniel R. Reynolds @ SMU
 *---------------------------------------------------------------
 * SUNDIALS Copyright Start
 * Copyright (c) 2002-2020, Lawrence Livermore National Security
 * and Southern Methodist University.
 * All rights reserved.
 *
 * See the top-level LICENSE and NOTICE files for details.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 * SUNDIALS Copyright End
 *---------------------------------------------------------------
 * Example problem:
 *
 * The following is a simple example problem with analytical
 * solution,
 *     dy/dt = (t+1)*exp(-y)
 * for t in the interval [0.0, 10.0], with initial condition: y=0.
 * This has analytical solution
 *      y(t) = log(0.5*t^2 + t + 1)
 *
 * This program solves the problem with the ERK method.
 * Output is printed every 1.0 units of time (10 total).
 * Run statistics (optional outputs) are printed at the end.
 *-----------------------------------------------------------------*/
=#

using Sundials, Test

t0 = 0.0
tf = 10.0
dTout = 1.0
neq = 1
reltol = 1.0e-6
abstol = 1.0e-10
y0 = [0.0]

function f(t, y, ydot, user_data)
    y = convert(Vector, y)
    ydot = convert(Vector, ydot)
    ydot[1] = (t + 1.0) * exp(-1 * y[1])
    return Sundials.ARK_SUCCESS
end

f_C = @cfunction(
    f, Cint,
    (Sundials.realtype, Sundials.N_Vector, Sundials.N_Vector, Ptr{Cvoid})
)

y0_nvec = Sundials.NVector(y0, ctx)
mem_ptr = Sundials.ERKStepCreate(f_C, t0, y0_nvec, ctx)
erkStep_mem = Sundials.Handle(mem_ptr)
Sundials.@checkflag Sundials.ERKStepSStolerances(erkStep_mem, reltol, abstol)

res = [0.0]
t = [t0]
tout = t0 + dTout
while (tf - t[1] > 1.0e-15)
    y = similar(y0)
    y_nvec = Sundials.NVector(y, ctx)
    Sundials.@checkflag Sundials.ERKStepEvolve(
        erkStep_mem, tout, y_nvec, t, Sundials.ARK_NORMAL
    )
    copyto!(y, y_nvec.v)
    push!(res, y[1])
    global tout += dTout
    global tout = (tout > tf) ? tf : tout
end

t = 0.0:1:10
y_analytic = log.((0.5 * t .^ 2 .+ t .+ 1))
for i in 1:length(t)
    @test isapprox(y_analytic[1], res[1]; atol = 1.0e-3)
end
y = nothing
temp = Ref(Clong(-1))
Sundials.@checkflag Sundials.ERKStepGetNumSteps(erkStep_mem, temp)
Sundials.@checkflag Sundials.ERKStepGetNumStepAttempts(erkStep_mem, temp)
Sundials.@checkflag Sundials.ERKStepGetNumRhsEvals(erkStep_mem, temp)
Sundials.@checkflag Sundials.ERKStepGetNumErrTestFails(erkStep_mem, temp)

# Clean up context
Sundials.SUNContext_Free(ctx)

using Sundials, Test
using Sundials: N_Vector

ctx_ref = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ref))
ctx = ctx_ref[]

mutable struct CVAdjointData
    a::Float64
end

function cv_forward_rhs(t::Float64, y::N_Vector, ydot::N_Vector, data::CVAdjointData)
    ydotv = convert(Vector, ydot)
    yv = convert(Vector, y)
    ydotv[1] = data.a * yv[1]
    return Sundials.CV_SUCCESS
end

function cv_adjoint_rhs(
        t::Float64,
        y::N_Vector,
        yB::N_Vector,
        yBdot::N_Vector,
        data::CVAdjointData
    )
    yBdotv = convert(Vector, yBdot)
    yBv = convert(Vector, yB)
    yBdotv[1] = -data.a * yBv[1]
    return Sundials.CV_SUCCESS
end

function cv_adjoint_quad_rhs(
        t::Float64,
        y::N_Vector,
        yB::N_Vector,
        qBdot::N_Vector,
        data::CVAdjointData
    )
    yv = convert(Vector, y)
    yBv = convert(Vector, yB)
    qBdotv = convert(Vector, qBdot)
    qBdotv[1] = -yBv[1] * yv[1]
    return Sundials.CV_SUCCESS
end

function solve_adjoint(; t0 = 0.0, tf = 2.0, y0 = 2.0, a = 0.3)
    data = CVAdjointData(a)

    cfwd = @cfunction(
        cv_forward_rhs,
        Cint,
        (Sundials.realtype, N_Vector, N_Vector, Ref{CVAdjointData})
    )
    cadj = @cfunction(
        cv_adjoint_rhs,
        Cint,
        (Sundials.realtype, N_Vector, N_Vector, N_Vector, Ref{CVAdjointData})
    )
    cadj_quad = @cfunction(
        cv_adjoint_quad_rhs,
        Cint,
        (Sundials.realtype, N_Vector, N_Vector, N_Vector, Ref{CVAdjointData})
    )

    y0v = [y0]
    yf = similar(y0v)
    y0n = Sundials.NVector(y0v, ctx)
    yfn = Sundials.NVector(yf, ctx)
    tret = [t0]
    ncheck = Ref{Cint}(0)

    cvode_mem = Sundials.Handle(Sundials.CVodeCreate(Sundials.CV_ADAMS, ctx))
    nls = Sundials.SUNNonlinSol_FixedPoint(y0n, Cint(0), ctx)
    nls_handle = Sundials.NonLinSolHandle(nls, Sundials.FixedPoint())

    @test Sundials.CVodeInit(cvode_mem, cfwd, t0, y0n) == Sundials.CV_SUCCESS
    @test Sundials.CVodeSetUserData(cvode_mem, data) == Sundials.CV_SUCCESS
    @test Sundials.CVodeSetNonlinearSolver(cvode_mem, nls) == Sundials.CV_SUCCESS
    @test Sundials.CVodeSStolerances(cvode_mem, 1.0e-10, 1.0e-12) == Sundials.CV_SUCCESS
    @test Sundials.CVodeAdjInit(cvode_mem, 50, Sundials.CV_HERMITE) == Sundials.CV_SUCCESS

    @test Sundials.CVodeF(cvode_mem, tf, yfn, tret, Sundials.CV_NORMAL, ncheck) ==
        Sundials.CV_SUCCESS

    which = Ref{Cint}(0)
    @test Sundials.CVodeCreateB(cvode_mem, Sundials.CV_ADAMS, which) == Sundials.CV_SUCCESS

    yB0 = [1.0]
    yB0n = Sundials.NVector(yB0, ctx)
    yBout = similar(yB0)
    yBoutn = Sundials.NVector(yBout, ctx)
    qB0 = [0.0]
    qB0n = Sundials.NVector(qB0, ctx)
    qBout = similar(qB0)
    qBoutn = Sundials.NVector(qBout, ctx)
    tBret = [tf]
    nlsB = Sundials.SUNNonlinSol_FixedPoint(yB0n, Cint(0), ctx)
    nlsB_handle = Sundials.NonLinSolHandle(nlsB, Sundials.FixedPoint())

    @test Sundials.CVodeInitB(cvode_mem, which[], cadj, tf, yB0n) == Sundials.CV_SUCCESS
    @test Sundials.CVodeSetUserDataB(cvode_mem, which[], data) == Sundials.CV_SUCCESS
    @test Sundials.CVodeSetNonlinearSolverB(cvode_mem, which[], nlsB) == Sundials.CV_SUCCESS
    @test Sundials.CVodeSStolerancesB(cvode_mem, which[], 1.0e-10, 1.0e-12) ==
        Sundials.CV_SUCCESS
    @test Sundials.CVodeQuadInitB(cvode_mem, which[], cadj_quad, qB0n) ==
        Sundials.CV_SUCCESS
    @test Sundials.CVodeQuadSStolerancesB(cvode_mem, which[], 1.0e-10, 1.0e-12) ==
        Sundials.CV_SUCCESS

    GC.@preserve data y0n yfn yB0n yBoutn qB0n qBoutn nls_handle nlsB_handle begin
        @test Sundials.CVodeB(cvode_mem, t0, Sundials.CV_NORMAL) >= Sundials.CV_SUCCESS
        @test Sundials.CVodeGetB(cvode_mem, which[], tBret, yBoutn) == Sundials.CV_SUCCESS
        @test Sundials.CVodeGetQuadB(cvode_mem, which[], tBret, qBoutn) == Sundials.CV_SUCCESS
    end

    empty!(nlsB_handle)
    empty!(nls_handle)
    empty!(cvode_mem)
    Sundials.SUNContext_Free(ctx)

    return yf[1], yBout[1], qBout[1], tBret[1]
end

yf, lambda0, grad_a, tBret = solve_adjoint()

@test isapprox(yf, 2.0 * exp(0.3 * 2.0); rtol = 1.0e-8)
@test isapprox(lambda0, exp(0.3 * 2.0); rtol = 1.0e-8)
@test isapprox(grad_a, 2.0 * yf; rtol = 1.0e-8)
@test isapprox(tBret, 0.0; atol = 1.0e-12)

using Clang.Generators
using Sundials_jll
using MLStyle
using Pkg

# 1st arg name to wrapped arg type map
const arg1_name2type = Dict(
    :arkode_mem => :(ARKStepMemPtr),
    :cvode_mem => :(CVODEMemPtr),
    :cv_mem => :(CVODEMemPtr),
    :kinmem => :(KINMemPtr),
    :kinmemm => :(KINMemPtr), # Sundials typo?
    :ida_mem => :(IDAMemPtr),
    :idaa_mem => :(IDAMemPtr), # Sundials typo?
    :idaadj_mem => :(IDAMemPtr)
)

const linear_solvers_and_matrices = [
    # Linear Solvers
    "band",
    "dense",
    "klu",
    "lapackend",
    "lapackdense",
    "pcg",
    "spbcgs",
    "spfgmr",
    "spgmr",
    "sptfqmr",
    # Matrices
    "sparse",
    # Non linear solvers
    "fixedpoint",
    "newton",
]

# substitute Ptr{Void} with the typed pointer
const ctor_return_type = Dict(
    "ARKCreate" => :(ARKStepMemPtr),
    "ARKStepCreate" => :(ARKStepMemPtr),
    "ERKStepCreate" => :(ERKStepMemPtr),
    "MRIStepCreate" => :(MRIStepMemPtr),
    "CVodeCreate" => :(CVODEMemPtr),
    "IDACreate" => :(IDAMemPtr),
    "KINCreate" => :(KINMemPtr)
)
# signatures for C function pointer types
const FnTypeSignatures = Dict(
    :ARKRhsFn => (
        :Cint,
        :((realtype, N_Vector, N_Vector, Ptr{Cvoid})),
    ),
    :CVRhsFn => (
        :Cint,
        :((realtype, N_Vector, N_Vector, Ptr{Cvoid})),
    ),
    :CVRootFn => (
        :Cint,
        :(
            (
                realtype, N_Vector, Ptr{realtype},
                Ptr{Cvoid},
            )
        ),
    ),
    :IDAResFn => (
        :Cint,
        :(
            (
                realtype, N_Vector, N_Vector, N_Vector,
                Ptr{Cvoid},
            )
        ),
    ),
    :IDARootFn => (
        :Cint,
        :(
            (
                realtype, N_Vector, N_Vector, Ptr{realtype},
                Ptr{Cvoid},
            )
        ),
    ),
    :KINSysFn => (:Cint, :((N_Vector, N_Vector, Ptr{Cvoid})))
)

function wrap_sundials_api(expr::Expr)
    if expr.head == :function &&
            expr.args[1].head == :call
        func_name = string(expr.args[1].args[1])
        convert_required = false
        if occursin(r"^(ARK|ERK|MRI|CV|KIN|IDA|SUN|N_V)", func_name)
            # @show func_name
            if occursin(r"Create$", func_name) && !occursin(r"Butcher", func_name)
                # create functions return typed pointers
                @assert expr.args[2].args[1].args[3] == :(Ptr{Cvoid})
                expr.args[2].args[1].args[3] = ctor_return_type[func_name]
            elseif length(expr.args[1].args) > 1
                arg1_type = expr.args[2].args[1].args[4].args[1]
                if arg1_type == :(Ptr{Cvoid}) || arg1_type == :(Ptr{Ptr{Cvoid}})
                    arg1_name = expr.args[1].args[2]
                    arg1_newtype = arg1_name2type[arg1_name]
                    # separate ARKStepMemPtr from ERK* and MRI*
                    if arg1_newtype == :ARKStepMemPtr
                        arg1_newtype = Symbol(func_name[1:3] * "StepMemPtr")
                    end
                    if arg1_type == :(Ptr{Ptr{Cvoid}})
                        # adjust for void** type (for CVodeFree()-like funcs)
                        arg1_newtype = Expr(:curly, :Ref, arg1_newtype)
                    end
                    expr.args[2].args[1].args[4].args[1] = arg1_newtype
                    convert_required = true
                end
            end
            if occursin(r"UserDataB?$", func_name)
                # replace Ptr{Void} with Any to allow passing Julia objects through user data
                for (i, arg_expr) in enumerate(expr.args[2].args[1].args)
                    if !(arg_expr isa Symbol) &&
                            arg_expr.args[1] in values(ctor_return_type)
                        if arg_expr.args[2] == :(Ptr{Cvoid})
                            arg_expr.args[2] = Any
                        elseif arg_expr.args[3] == :(Ptr{Cvoid})
                            arg_expr.args[3] = Any
                        end
                    end
                end
            end
            if !(expr isa Symbol) && length(expr.args) > 1 &&
                    (
                    expr.args[2].args[1].args[2].args[2] == :libsundials_sunlinsol ||
                        expr.args[2].args[1].args[2].args[2] == :libsundials_sunmatrix ||
                        expr.args[2].args[1].args[2].args[2] == :libsundials_sunnonlinsol
                )
                if func_name[1:6] == "SUNMAT"
                    expr.args[2].args[1].args[2].args[2] = Symbol(
                        string(expr.args[2].args[1].args[2].args[2]) *
                            lowercase(
                            split(
                                func_name,
                                "_"
                            )[end]
                        )
                    )
                else
                    name_i = findfirst(
                        lsmn -> occursin(lsmn, lowercase(func_name)),
                        linear_solvers_and_matrices
                    )

                    @assert name_i > 0
                    name = linear_solvers_and_matrices[name_i]
                    expr.args[2].args[1].args[2].args[2] = Symbol(
                        string(expr.args[2].args[1].args[2].args[2]) *
                            name
                    )
                end
            end
            # generate a higher-level wrapper that converts 1st arg to XXXMemPtr
            # and all other args from Julia objects to low-level C wrappers (e.g. NVector to N_Vector)
            # create wrappers for all arguments that need wrapping
            args_wrap_exprs = map(Base.Iterators.drop(expr.args[1].args, 1)) do expr
                # process each argument
                # return a tuple:
                #   1) high-level wrapper arg name expr
                #   2) expr for local var definition, nothing if not required
                #   3) expr for low-level wrapper call
                # if 1)==3), then no wrapping is required
                if expr isa Symbol
                    arg_name_expr = expr
                    arg_type_expr = Any
                else
                    arg_name_expr = expr.args[1]
                    arg_type_expr = expr.args[2]
                end
                if arg_type_expr == :N_Vector
                    # TODO replace with use of cconvert / unsafe_convert
                    # The code and comment below is incorrect and leads to memory errors with Julia >= 1.8,
                    # as storing in a local variable DOES NOT protect against garbage collection.
                    # Current workaround is to edit the generated files and apply a fix.
                    #
                    # Incorrect comment: 'first convert argument to NVector() and store in local var,
                    #     this guarantees that the wrapper and associated Sundials object (e.g. N_Vector)
                    #     is not removed by GC'
                    return (
                        arg_name_expr,
                        Expr(:call, :convert, :NVector, arg_name_expr), # convert arg to NVector to store in a local var
                        Expr(
                            :call, :convert, arg_type_expr,
                            Symbol(string("__", arg_name_expr))
                        ),
                    ) # convert NVector to N_Vector
                elseif arg_type_expr == :Clong || arg_type_expr == :Cint ||
                        occursin(r"MemPtr$", string(arg_type_expr))
                    # convert(XXXMemPtr, mem), no local var required
                    return (
                        arg_name_expr, nothing,
                        Expr(:call, :convert, arg_type_expr, arg_name_expr),
                    )
                elseif isa(arg_type_expr, Expr) && arg_type_expr.head == :curly &&
                        arg_type_expr.args[1] == :Ptr && arg_type_expr.args[2] != :FILE
                    # convert julia arrays to pointer, no local var required
                    # FIXME sometimes these arguments are not really arrays, but just a pointer to a var to be assigned
                    # by the function call. Does that make sense to detect such cases and assume that input arg is a reference to Julia var?
                    return (
                        arg_name_expr, nothing,
                        Expr(:call, :pointer, arg_name_expr),
                    )
                elseif haskey(FnTypeSignatures, arg_type_expr) # wrap Julia function to C function using a defined signature
                    return (
                        arg_name_expr, nothing,
                        Expr(
                            :call, Symbol(string(arg_type_expr, "_wrapper")),
                            arg_name_expr
                        ),
                    )
                else # any other case, no argument wrapping
                    return (arg_name_expr, nothing, arg_name_expr)
                end
            end
            # check which arguments are wrapped
            if any(map(arg_exprs -> arg_exprs[1] != arg_exprs[3], args_wrap_exprs))
                # mangle the name of the low-level wrapper to avoid recursion
                lowlevel_func_name = string(func_name)
                expr.args[1].args[1] = Symbol(lowlevel_func_name)

                # higher-level wrapper function
                wrapper_func_expr = Expr(
                    :function,
                    # function declaration with argument types stripped, so it would accept any type
                    Expr(
                        :call, Symbol(func_name),
                        map(
                            arg_exprs -> arg_exprs[1],
                            args_wrap_exprs
                        )...
                    ),
                    Expr(
                        :block,
                        # local var defs
                        map(
                            filter(
                                arg_exprs -> arg_exprs[2] !==
                                    nothing,
                                args_wrap_exprs
                            )
                        ) do arg_exprs
                            Expr(
                                :(=), Symbol("__", arg_exprs[1]),
                                arg_exprs[2]
                            )
                        end...,
                        # low-level function call with Julia types converted to low-level arguments
                        Expr(
                            :call, Symbol(lowlevel_func_name),
                            map(
                                arg_exprs -> arg_exprs[3],
                                args_wrap_exprs
                            )...
                        )
                    )
                )
                # write down both low-level and higher level wrappers
                return Any[expr, wrapper_func_expr]
            else
                return Any[expr]
            end
        end
    elseif expr.head == :typealias && haskey(FnTypeSignatures, expr.args[1])
        # C functional type, generate the wrapper from Julia to C function
        # dummy wrapper that accepts pointer
        fn_typename = expr.args[1]
        fn_rettype, fn_argtypes = FnTypeSignatures[fn_typename]
        wrapper_name = Symbol(string(string(fn_typename), "_wrapper"))
        c_wrapper_def = Expr(
            :(=),
            Expr(:call, wrapper_name, Expr(:(::), :fp, fn_typename)), :fp
        )
        jl_wrapper_def = Expr(
            :(=),
            Expr(:call, wrapper_name, :f),
            # function declaration with argument types stripped
            Expr(:call, :cfunction, :f, fn_rettype, fn_argtypes)
        )
        return Any[expr, c_wrapper_def, jl_wrapper_def]
    elseif expr.head == :const && expr.args[1].head == :(=) &&
            isa(expr.args[1].args[2], Int)
        # fix integer constants should be Cint
        expr.args[1].args[2] = Expr(:call, :Cint, expr.args[1].args[2])
    end
    return Any[expr]
end

function rewrite(ex)
    ex = @match ex begin
        :(const $name = SUNDIALS_F77_FUNC($arg1, $arg2)) => :(const $name = nothing)
        # Expr(:macro, :($name()), Expr(:macrocall, Symbol("@SUNDIALS_F77_FUNC"), nothing, arg1, arg2))
        :(const $sun_name = $klu_name) &&
            if startswith(string(sun_name), "sun_klu_") &&
                startswith(string(klu_name), "klu_")
        end => :(const $sun_name = nothing) # skip
        _ => ex
    end
    return wrap_sundials_api(ex)
end

cd(@__DIR__)

include_dir = joinpath(Sundials_jll.artifact_dir, "include") |> normpath

artifact_toml = joinpath(
    dirname(pathof(Sundials_jll.SuiteSparse_jll)), "..",
    "StdlibArtifacts.toml"
)
suitespase_dir = Pkg.Artifacts.ensure_artifact_installed("SuiteSparse", artifact_toml)
suitespase_include_sir = joinpath(suitespase_dir, "include")

# wrapper generator options
options = load_options(joinpath(@__DIR__, "generate.toml"))

# add compiler flags, e.g. "-DXXXXXXXXX"
args = get_default_args()
push!(args, "-I$include_dir", "-isystem$suitespase_include_sir")

library_names = Dict(
    raw"sundials[\\/].+" => "libsundials_sundials",
    raw"sunnonlinsol[\\/].+" => "libsundials_sunnonlinsol",
    raw"sunmatrix[\\/].+" => "libsundials_sunmatrix",
    raw"kinsol[\\/].+" => "libsundials_kinsol",
    raw"ida[\\/].+" => "libsundials_idas",
    raw"cvodes[\\/].+" => "libsundials_cvodes",
    raw"sunlinsol[\\/].+$(?<!lapackband\.h)(?<!lapackdense\.h)" => "libsundials_sunlinsol",
    raw"cvode[\\/].+" => "libsundials_cvodes",
    raw"idas[\\/].+" => "libsundials_idas",
    raw"arkode[\\/].+" => "libsundials_arkode",
    raw"nvector[\\/].+" => "libsundials_nvecserial",
    raw"lapackband\.h" => "libsundials_sunlinsollapackband",
    raw"lapackdense\.h" => "libsundials_sunlinsollapackdense"
)
headers = String[]
for lib in readdir(include_dir)
    header_dir = joinpath(include_dir, lib)
    append!(
        headers,
        joinpath(header_dir, header)
            for header in readdir(header_dir) if endswith(header, ".h")
    )
end
options["general"]["library_names"] = library_names

ctx = create_context(headers, args, options)

# run generator
build!(ctx, BUILDSTAGE_NO_PRINTING)
for n in ctx.dag.nodes
    copy!(n.exprs, reduce(vcat, rewrite.(n.exprs); init = []))
end
build!(ctx, BUILDSTAGE_PRINTING_ONLY)

mutable struct DEOptions{
        SType, TstopType, SType2, TstopType2, SIX, CType, reltolType,
        abstolType,
        F5,
    }
    saveat::SType
    tstops::TstopType
    saveat_cache::SType2
    tstops_cache::TstopType2
    save_start::Bool
    save_everystep::Bool
    save_idxs::SIX
    dense::Bool
    timeseries_errors::Bool
    dense_errors::Bool
    save_on::Bool
    save_end::Bool
    callback::CType
    abstol::abstolType
    reltol::reltolType
    verbose::DEVerbosity
    advance_to_tstop::Bool
    stop_at_next_tstop::Bool
    progress::Bool
    progress_steps::Int
    progress_name::String
    progress_message::F5
    progress_id::Symbol
    maxiters::Int
end

abstract type AbstractSundialsIntegrator{algType} <:
SciMLBase.AbstractODEIntegrator{algType, true, Vector{Float64}, Float64} end

mutable struct CVODEIntegrator{
        N,
        pType,
        solType,
        algType,
        fType,
        UFType,
        JType,
        oType,
        LStype,
        Atype,
        CallbackCacheType,
        IA,
    } <: AbstractSundialsIntegrator{algType}
    u::Array{Float64, N}
    u_nvec::NVector
    p::pType
    t::Float64
    tprev::Float64
    mem::Handle{CVODEMem}
    LS::LStype
    A::Atype
    sol::solType
    alg::algType
    f::fType
    userfun::UFType
    jac::JType
    opts::oType
    tout::Vector{Float64}
    tdir::Float64
    u_modified::Bool
    tmp::Array{Float64, N}
    uprev::Array{Float64, N}
    flag::Cint
    just_hit_tstop::Bool
    event_last_time::Int
    vector_event_last_time::Int
    callback_cache::CallbackCacheType
    last_event_error::Float64
    initializealg::IA
    ctx_handle::ContextHandle
end

function (integrator::CVODEIntegrator)(
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing
    ) where {T}
    out = similar(integrator.u)
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag CVodeGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : out[idxs]
end

function (integrator::CVODEIntegrator)(
        out,
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing
    ) where {T}
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag CVodeGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : @view out[idxs]
end

mutable struct ARKODEIntegrator{
        N,
        pType,
        solType,
        algType,
        fType,
        UFType,
        JType,
        oType,
        LStype,
        Atype,
        MLStype,
        Mtype,
        CallbackCacheType,
        MemType,
        IA,
    } <: AbstractSundialsIntegrator{ARKODE}
    u::Array{Float64, N}
    u_nvec::NVector
    p::pType
    t::Float64
    tprev::Float64
    mem::Handle{MemType}
    LS::LStype
    A::Atype
    MLS::MLStype
    M::Mtype
    sol::solType
    alg::algType
    f::fType
    userfun::UFType
    jac::JType
    opts::oType
    tout::Vector{Float64}
    tdir::Float64
    u_modified::Bool
    tmp::Array{Float64, N}
    uprev::Array{Float64, N}
    flag::Cint
    just_hit_tstop::Bool
    event_last_time::Int
    vector_event_last_time::Int
    callback_cache::CallbackCacheType
    last_event_error::Float64
    initializealg::IA
    cfj1::Ptr{Cvoid}
    cfj2::Ptr{Cvoid}
    ctx_handle::ContextHandle
end

# runic: off
# Runic reformats callable struct syntax in a way that is incompatible with Julia < 1.13
function (integrator::ARKODEIntegrator{
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, ARKStepMem, IA,
    })(
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing,
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, IA, T,
    }
    out = similar(integrator.u)
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag ARKStepGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : out[idxs]
end

function (integrator::ARKODEIntegrator{
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, ERKStepMem, IA,
    })(
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing,
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, IA, T,
    }
    out = similar(integrator.u)
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag ERKStepGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : out[idxs]
end

function (integrator::ARKODEIntegrator{
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, ARKStepMem, IA,
    })(
        out,
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing,
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, IA, T,
    }
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag ARKStepGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : @view out[idxs]
end

function (integrator::ARKODEIntegrator{
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, ERKStepMem, IA,
    })(
        out,
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing,
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType, IA, T,
    }
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag ERKStepGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : @view out[idxs]
end
# runic: on

mutable struct IDAIntegrator{
        N,
        pType,
        solType,
        algType,
        fType,
        UFType,
        JType,
        oType,
        LStype,
        Atype,
        CallbackCacheType,
        IA,
    } <: AbstractSundialsIntegrator{IDA}
    u::Array{Float64, N}
    du::Array{Float64, N}
    p::pType
    t::Float64
    tprev::Float64
    mem::Handle{IDAMem}
    LS::LStype
    A::Atype
    sol::solType
    alg::algType
    f::fType
    userfun::UFType
    jac::JType
    opts::oType
    tout::Vector{Float64}
    tdir::Float64
    u_modified::Bool
    tmp::Array{Float64, N}
    uprev::Array{Float64, N}
    flag::Cint
    iter::Int
    just_hit_tstop::Bool
    event_last_time::Int
    vector_event_last_time::Int
    callback_cache::CallbackCacheType
    last_event_error::Float64
    u_nvec::NVector
    du_nvec::NVector
    diff_vars_nvec::Union{NVector, Nothing}  # Preallocated NVector for differential_vars
    initializealg::IA
    ctx_handle::ContextHandle
end

function (integrator::IDAIntegrator)(
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing
    ) where {T}
    out = similar(integrator.u)
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag IDAGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : out[idxs]
end

function (integrator::IDAIntegrator)(
        out,
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing
    ) where {T}
    out_nvec = NVector(vec(out), integrator.ctx_handle.ctx)
    integrator.flag = @checkflag IDAGetDky(integrator.mem, t, Cint(T), out_nvec) false integrator.opts.verbose
    copyto!(out, out_nvec.v)
    return idxs === nothing ? out : @view out[idxs]
end
function (integrator::IDAIntegrator)(
        out::SubArray,
        t::Number,
        deriv::Type{Val{T}} = Val{0};
        idxs = nothing
    ) where {T}
    throw(ArgumentError("Views are not supported with IDA!"))
end

###  Error check (retcode)

function DiffEqBase.check_error(integrator::AbstractSundialsIntegrator)
    return interpret_sundials_retcode(integrator.flag)
end

DiffEqBase.postamble!(integrator::AbstractSundialsIntegrator) = nothing
# No-op postamble! to make DiffEqBase.check_error! (and hence iterator interface
# implemented in DiffEqBase) work.

### Iterator interface

@inline function DiffEqBase.step!(integrator::AbstractSundialsIntegrator)
    if integrator.opts.advance_to_tstop
        # The call to first is an overload of Base.first implemented in DataStructures
        while integrator.tdir * (integrator.t - first(integrator.opts.tstops)) < -1.0e6eps()
            tstop = first(integrator.opts.tstops)
            set_stop_time(integrator, tstop)
            integrator.tprev = integrator.t
            if !(integrator.opts.callback.continuous_callbacks isa Tuple{})
                integrator.uprev .= integrator.u
            end
            solver_step(integrator, tstop)
            integrator.t = first(integrator.tout)
            SciMLBase.check_error!(integrator) != ReturnCode.Success && return
            handle_callbacks!(integrator)
            SciMLBase.check_error!(integrator) != ReturnCode.Success && return
        end
    else
        integrator.tprev = integrator.t
        if !(integrator.opts.callback.continuous_callbacks isa Tuple{})
            integrator.uprev .= integrator.u
        end
        if !isempty(integrator.opts.tstops)
            tstop = first(integrator.opts.tstops)
            set_stop_time(integrator, tstop)
            solver_step(integrator, tstop)
        else
            solver_step(integrator, 1.0) # fake tstop
        end
        integrator.t = first(integrator.tout)
        SciMLBase.check_error!(integrator) != ReturnCode.Success && return
        handle_callbacks!(integrator)
        SciMLBase.check_error!(integrator) != ReturnCode.Success && return
    end
    handle_tstop!(integrator)
    return nothing
end

##################################################################
#
# Pointers to Sundials objects
#
##################################################################

"""
    Base type for dummy placeholders that help to
    providing typed pointers for Sundials objects
    (KINSOL, CVODE, IDA).

    See `Handle`.
"""
abstract type AbstractSundialsObject end

struct CVODEMem <: AbstractSundialsObject end
const CVODEMemPtr = Ptr{CVODEMem}

struct ARKStepMem <: AbstractSundialsObject end
const ARKStepMemPtr = Ptr{ARKStepMem}

struct ERKStepMem <: AbstractSundialsObject end
const ERKStepMemPtr = Ptr{ERKStepMem}

struct MRIStepMem <: AbstractSundialsObject end
const MRIStepMemPtr = Ptr{MRIStepMem}

struct IDAMem <: AbstractSundialsObject end
const IDAMemPtr = Ptr{IDAMem}

struct KINMem <: AbstractSundialsObject end
const KINMemPtr = Ptr{KINMem}

abstract type SundialsHandle end

"""
   Handle for Sundials objects (CVODE, IDA, KIN).

   Wraps the reference to the pointer to the Sundials object.
   Manages automatic destruction of the referenced objects when it is
   no longer in use.
"""
mutable struct Handle{T <: AbstractSundialsObject} <: SundialsHandle
    ptr::Ptr{T}

    function Handle(ptr::Ptr{T}) where {T <: AbstractSundialsObject}
        h = new{T}(ptr)
        finalizer(release_handle, h)
        return h
    end
end

mutable struct MatrixHandle{T <: SundialsMatrix} <: SundialsHandle
    ptr::SUNMatrix
    destroyed::Bool
    function MatrixHandle(ptr::SUNMatrix, M::T) where {T <: SundialsMatrix}
        h = new{T}(ptr, false)
        finalizer(release_handle, h)
        return h
    end
end

mutable struct LinSolHandle{T <: SundialsLinearSolver} <: SundialsHandle
    ptr::SUNLinearSolver
    destroyed::Bool
    function LinSolHandle(ptr::SUNLinearSolver, M::T) where {T <: SundialsLinearSolver}
        h = new{T}(ptr, false)
        finalizer(release_handle, h)
        return h
    end
end

mutable struct NonLinSolHandle{T <: SundialsNonLinearSolver} <: SundialsHandle
    ptr::SUNNonlinearSolver
    destroyed::Bool
    function NonLinSolHandle(
            ptr::SUNNonlinearSolver,
            M::T
        ) where {T <: SundialsNonLinearSolver}
        h = new{T}(ptr, false)
        finalizer(release_handle, h)
        return h
    end
end

""" 
    Base.cconvert(::Type{Ptr{T}}, h::Handle{T}) -> h
    Base.unsafe_convert(::Type{Ptr{T}}, h::Handle{T}) -> Ptr{T}
    
Convert h::Handle{T} to Ptr{T}, for use by ccall

Conversion happens in two steps within ccall:
 - cconvert returns h, which is preserved (by ccall) from garbage collection
 - unsafe_convert to get the pointer from h 
"""
Base.cconvert(::Type{Ptr{T}}, h::Handle{T}) where {T} = h
Base.unsafe_convert(::Type{Ptr{T}}, h::Handle{T}) where {T} = h.ptr

# Use the supplied Sundials sun_free_func to free h.ptr
# NB: CVodeFree and similar require a C pointer-to-pointer
function _release_handle(sun_free_func, h::Handle{T}) where {T}
    if h.ptr != C_NULL
        ptr_ref = Ref(h.ptr)
        h.ptr = C_NULL
        sun_free_func(ptr_ref)
    end

    return nothing
end

release_handle(h::Handle{KINMem}) = _release_handle(KINFree, h)
release_handle(h::Handle{CVODEMem}) = _release_handle(CVodeFree, h)
release_handle(h::Handle{ARKStepMem}) = _release_handle(ARKStepFree, h)
release_handle(h::Handle{ERKStepMem}) = _release_handle(ERKStepFree, h)
release_handle(h::Handle{MRIStepMem}) = _release_handle(MRIStepFree, h)
release_handle(h::Handle{IDAMem}) = _release_handle(IDAFree, h)

function release_handle(h::MatrixHandle{DenseMatrix})
    if !isempty(h)
        Sundials.SUNMatDestroy_Dense(h.ptr)
        h.destroyed = true
    end
    return nothing
end
function release_handle(h::MatrixHandle{BandMatrix})
    if !isempty(h)
        Sundials.SUNMatDestroy_Band(h.ptr)
        h.destroyed = true
    end
    return nothing
end
function release_handle(h::MatrixHandle{SparseMatrix})
    if !isempty(h)
        Sundials.SUNMatDestroy_Sparse(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{Dense})
    if !isempty(h)
        Sundials.SUNLinSolFree_Dense(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{Band})
    if !isempty(h)
        Sundials.SUNLinSolFree_Band(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{SPGMR})
    if !isempty(h)
        Sundials.SUNLinSolFree_SPGMR(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{SPFGMR})
    if !isempty(h)
        Sundials.SUNLinSolFree_SPFGMR(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{SPBCGS})
    if !isempty(h)
        Sundials.SUNLinSolFree_SPBCGS(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{PCG})
    if !isempty(h)
        Sundials.SUNLinSolFree_PCG(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{PTFQMR})
    if !isempty(h)
        Sundials.SUNLinSolFree_SPTFQMR(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{KLU})
    if !isempty(h)
        Sundials.SUNLinSolFree_KLU(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{LapackBand})
    if !isempty(h)
        Sundials.SUNLinSolFree_LapackBand(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::LinSolHandle{LapackDense})
    if !isempty(h)
        Sundials.SUNLinSolFree_LapackDense(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::NonLinSolHandle{FixedPoint})
    if !isempty(h)
        Sundials.SUNNonlinSolFree_FixedPoint(h.ptr)
        h.destroyed = true
    end
    return nothing
end

function release_handle(h::NonLinSolHandle{Newton})
    if !isempty(h)
        Sundials.SUNNonlinSolFree_Newton(h.ptr)
        h.destroyed = true
    end
    return nothing
end

Base.empty!(h::LinSolHandle) = release_handle(h)
Base.empty!(h::NonLinSolHandle) = release_handle(h)
Base.empty!(h::MatrixHandle) = release_handle(h)
Base.empty!(h::Handle) = release_handle(h)
Base.isempty(h::Handle) = (h.ptr == C_NULL)
Base.isempty(h::MatrixHandle) = h.destroyed
Base.isempty(h::LinSolHandle) = h.destroyed
Base.isempty(h::NonLinSolHandle) = h.destroyed

##################################################################
#
# Convenience typealiases for Sundials handles
#
##################################################################

const CVODEh = Handle{CVODEMem}
const ARKSteph = Handle{ARKStepMem}
const ERKSteph = Handle{ERKStepMem}
const MRISteph = Handle{MRIStepMem}
const KINh = Handle{KINMem}
const IDAh = Handle{IDAMem}

##################################################################
#
# Handle for SUNContext with automatic cleanup
#
##################################################################

"""
   ContextHandle

   Handle for SUNContext objects that ensures proper cleanup.
   Similar to NVector, it manages automatic destruction when no longer in use.
"""
mutable struct ContextHandle <: SundialsHandle
    ctx::SUNContext

    function ContextHandle()
        ctx_ptr = Ref{SUNContext}(C_NULL)
        SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{SUNContext}, ctx_ptr))
        ctx = ctx_ptr[]
        h = new(ctx)
        finalizer(release_context, h)
        return h
    end
end

function release_context(h::ContextHandle)
    if h.ctx != C_NULL
        ctx_ptr = Ref(h.ctx)
        SUNContext_Free(ctx_ptr[])
        h.ctx = C_NULL
    end
    return nothing
end

# Allow ContextHandle to be used where SUNContext is expected
Base.cconvert(::Type{SUNContext}, h::ContextHandle) = h
Base.unsafe_convert(::Type{SUNContext}, h::ContextHandle) = h.ctx
Base.isempty(h::ContextHandle) = (h.ctx == C_NULL)

function handle_callbacks!(integrator)
    discrete_callbacks = integrator.opts.callback.discrete_callbacks
    continuous_callbacks = integrator.opts.callback.continuous_callbacks
    atleast_one_callback = false

    continuous_modified = false
    discrete_modified = false
    saved_in_cb = false
    if !(continuous_callbacks isa Tuple{})
        time, upcrossing,
            event_occurred,
            event_idx,
            idx,
            counter = DiffEqBase.find_first_continuous_callback(
            integrator,
            continuous_callbacks...
        )
        if event_occurred
            integrator.event_last_time = idx
            integrator.vector_event_last_time = event_idx
            continuous_modified,
                saved_in_cb = DiffEqBase.apply_callback!(
                integrator,
                continuous_callbacks[idx],
                time,
                upcrossing,
                event_idx
            )
        else
            integrator.event_last_time = 0
            integrator.vector_event_last_time = 1
        end
    end
    if !(discrete_callbacks isa Tuple{})
        discrete_modified,
            saved_in_cb = DiffEqBase.apply_discrete_callback!(
            integrator,
            discrete_callbacks...
        )
    end

    integrator.u_modified = continuous_modified || discrete_modified
    if integrator.u_modified
        handle_callback_modifiers!(integrator)
    end

    if !saved_in_cb
        savevalues!(integrator)
    end

    return integrator.u_modified = false
end

function DiffEqBase.savevalues!(
        integrator::AbstractSundialsIntegrator,
        force_save = false
    )::Tuple{Bool, Bool}
    saved, savedexactly = false, false
    !integrator.opts.save_on && return saved, savedexactly
    uType = typeof(integrator.sol.prob.u0)
    # The call to first is an overload of Base.first implemented in DataStructures
    while !isempty(integrator.opts.saveat) &&
            first(integrator.opts.saveat) <= integrator.tdir * integrator.t
        saved = true
        curt = integrator.tdir * pop!(integrator.opts.saveat)
        tmp = integrator(curt)
        save_value!(
            integrator.sol.u, tmp, uType,
            integrator.opts.save_idxs, false
        )
        push!(integrator.sol.t, curt)
        if integrator.opts.dense
            tmp = integrator(curt, Val{1})
            save_value!(
                integrator.sol.interp.du, tmp, uType,
                integrator.opts.save_idxs, false
            )
        end
    end

    if force_save || integrator.opts.save_everystep ||
            (
            integrator.opts.save_everystep && (
                isempty(integrator.sol.t) ||
                    (integrator.t !== integrator.sol.t[end])
            )
        )
        saved = true
        save_value!(
            integrator.sol.u, integrator.u, uType,
            integrator.opts.save_idxs
        )
        push!(integrator.sol.t, integrator.t)
        if integrator.opts.dense
            tmp = DiffEqBase.get_du(integrator)
            save_value!(
                integrator.sol.interp.du, tmp, uType,
                integrator.opts.save_idxs
            )
        end
    end
    savedexactly = !isempty(integrator.sol.t) && last(integrator.sol.t) == integrator.t
    return saved, savedexactly
end

function save_value!(save_array, val, ::Type{<:Number}, save_idxs, make_copy::Bool = true)
    return push!(save_array, first(val))
end
function save_value!(
        save_array,
        val,
        ::Type{<:AbstractArray},
        save_idxs,
        make_copy::Bool = true
    )
    save = if save_idxs !== nothing
        val[save_idxs]
    else
        make_copy ? copy(val) : val
    end
    return push!(save_array, save)
end

function handle_callback_modifiers!(integrator::CVODEIntegrator)
    return CVodeReInit(integrator.mem, integrator.t, integrator.u_nvec)
end

# Dispatch for ARKStep (implicit methods)
function handle_callback_modifiers!(
        integrator::ARKODEIntegrator{
            N,
            pType,
            solType,
            algType,
            fType,
            UFType,
            JType,
            oType,
            LStype,
            Atype,
            MLStype,
            Mtype,
            CallbackCacheType,
            ARKStepMem,
        }
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    return ARKStepReInit(
        integrator.mem, integrator.cfj2, integrator.cfj1,
        integrator.t, integrator.u
    )
end

# Dispatch for ERKStep (explicit methods)
function handle_callback_modifiers!(
        integrator::ARKODEIntegrator{
            N,
            pType,
            solType,
            algType,
            fType,
            UFType,
            JType,
            oType,
            LStype,
            Atype,
            MLStype,
            Mtype,
            CallbackCacheType,
            ERKStepMem,
        }
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    # ERKStepReInit only takes one function (explicit RHS)
    return ERKStepReInit(integrator.mem, integrator.userfun.fun, integrator.t, integrator.u)
end

"""
    IDAReinit!(integrator)

The `integrator` object keeps a shadow copy of `u`, `du` and `t`. If these are
modified, this function needs to be called in order to update the solver's
internal datastructures to re-gain consistency.
"""
function IDAReinit!(integrator::IDAIntegrator)
    IDAReInit(integrator.mem, integrator.t, integrator.u_nvec, integrator.du_nvec)
    return integrator.u_modified = false
end

function handle_callback_modifiers!(integrator::IDAIntegrator, callback_initializealg = nothing)
    # Implicitly does IDAReinit!
    # Use callback's initialization algorithm if provided, otherwise use integrator's
    initializealg = isnothing(callback_initializealg) ? integrator.initializealg : callback_initializealg
    return SciMLBase.initialize_dae!(integrator, initializealg)
end

function DiffEqBase.add_tstop!(integrator::AbstractSundialsIntegrator, t)
    integrator.tdir * (t - integrator.t) < 0 &&
        error("Tried to add a tstop that is behind the current time. This is strictly forbidden")
    return push!(integrator.opts.tstops, integrator.tdir * t)
end

function DiffEqBase.add_saveat!(integrator::AbstractSundialsIntegrator, t)
    integrator.tdir * (t - integrator.t) < 0 &&
        error("Tried to add a saveat that is behind the current time. This is strictly forbidden")
    return push!(integrator.opts.saveat, integrator.tdir * t)
end

DiffEqBase.get_tmp_cache(integrator::AbstractSundialsIntegrator) = (integrator.tmp,)

if isdefined(SciMLBase, :derivative_discontinuity!)
    @inline function SciMLBase.derivative_discontinuity!(integrator::AbstractSundialsIntegrator, bool::Bool)
        return integrator.u_modified = bool
    end
else
    @inline function DiffEqBase.u_modified!(integrator::AbstractSundialsIntegrator, bool::Bool)
        return integrator.u_modified = bool
    end
end

function DiffEqBase.terminate!(
        integrator::AbstractSundialsIntegrator,
        retcode = ReturnCode.Terminated
    )
    integrator.sol = DiffEqBase.solution_new_retcode(integrator.sol, retcode)
    return integrator.opts.tstops.valtree = typeof(integrator.opts.tstops.valtree)()
end

@inline function DiffEqBase.get_du(integrator::AbstractSundialsIntegrator)
    return integrator(integrator.t, Val{1})
end

@inline function DiffEqBase.get_du!(out, integrator::AbstractSundialsIntegrator)
    return integrator(out, integrator.t, Val{1})
end

@inline function DiffEqBase.get_du(integrator::IDAIntegrator)
    return integrator.du
end

@inline function DiffEqBase.get_du!(out, integrator::IDAIntegrator)
    return out .= integrator.du
end

function DiffEqBase.change_t_via_interpolation!(
        integrator::AbstractSundialsIntegrator, t,
        modify_save_endpoint::Type{Val{T}} = Val{false},
        reinitialize_alg = nothing
    ) where {T}
    integrator.t = t
    integrator(integrator.u, integrator.t)
    return nothing
end

@inline function Base.getproperty(integrator::AbstractSundialsIntegrator, sym::Symbol)
    if sym == :dt
        return integrator.t - integrator.tprev
    elseif sym == :ps
        return ParameterIndexingProxy(integrator)
    elseif sym == :derivative_discontinuity
        return getfield(integrator, :u_modified)
    else
        return getfield(integrator, sym)
    end
end

@inline function Base.setproperty!(integrator::AbstractSundialsIntegrator, sym::Symbol, val)
    if sym == :derivative_discontinuity
        sym = :u_modified
    end
    return setfield!(integrator, sym, convert(fieldtype(typeof(integrator), sym), val))
end

function DiffEqBase.reeval_internals_due_to_modification!(
        integrator::AbstractSundialsIntegrator,
        continuous_modification = true; callback_initializealg = nothing
    )
    integrator.userfun.p = integrator.p
    return nothing
end
function DiffEqBase.reeval_internals_due_to_modification!(
        integrator::IDAIntegrator,
        continuous_modification = true; callback_initializealg = nothing
    )
    integrator.userfun.p = integrator.p
    return handle_callback_modifiers!(integrator, callback_initializealg)
end

# Required for callbacks
DiffEqBase.set_proposed_dt!(i::AbstractSundialsIntegrator, dt) = nothing

SciMLBase.has_reinit(integrator::AbstractSundialsIntegrator) = true
function DiffEqBase.reinit!(
        integrator::AbstractSundialsIntegrator,
        u0 = integrator.sol.prob.u0;
        t0 = integrator.sol.prob.tspan[1],
        tf = integrator.sol.prob.tspan[2],
        erase_sol = true,
        tstops = integrator.opts.tstops_cache,
        saveat = integrator.opts.saveat_cache,
        reinit_callbacks = true, initialize_save = true,
        reinit_retcode = true,
        reinit_cache = true
    )
    if isinplace(integrator.sol.prob)
        copyto!(integrator.u, u0)
        copyto!(integrator.uprev, integrator.u)
    else
        integrator.u = u0
        integrator.uprev = integrator.u
    end

    integrator.t = t0
    integrator.tprev = t0

    tType = typeof(integrator.t)
    tspan = (tType(t0), tType(tf))
    tdir = sign(tspan[2] - tspan[1])

    tstops_internal,
        saveat_internal = tstop_saveat_disc_handling(
        tstops, saveat, tdir,
        tspan,
        eltype(integrator.t)
    )

    integrator.opts.tstops = tstops_internal
    integrator.opts.saveat = saveat_internal

    if erase_sol
        if integrator.opts.save_start
            resize_start = 1
        else
            resize_start = 0
        end
        resize!(integrator.sol.u, resize_start)
        resize!(integrator.sol.t, resize_start)
        if integrator.opts.save_start
            integrator.sol.t[1] = t0
            if integrator.opts.save_idxs === nothing
                integrator.sol.u[1] = u0
            else
                u_initial = u0[integrator.opts.save_idxs]
                integrator.sol.u[1] = u_initial
            end
        end
        if integrator.sol.u_analytic !== nothing
            resize!(integrator.sol.u_analytic, 0)
        end
    end

    integrator.u_modified = false
    handle_callback_modifiers!(integrator)

    if reinit_callbacks
        initialize_callbacks!(integrator, initialize_save)
    end

    if reinit_retcode
        integrator.sol = SciMLBase.solution_new_retcode(integrator.sol, ReturnCode.Default)
    end

    return nothing
end

DiffEqBase.get_tstops(integ::AbstractSundialsIntegrator) = integ.opts.tstops
DiffEqBase.get_tstops_array(integ::AbstractSundialsIntegrator) = get_tstops(integ).valtree
function DiffEqBase.get_tstops_max(integ::AbstractSundialsIntegrator)
    return maximum(get_tstops_array(integ))
end

# SII
SII.symbolic_container(integ::AbstractSundialsIntegrator) = integ.sol

using Sundials, Test

println("Test error handling")

f_error(u, p, t) = u / t
u0 = [1.0]
prob = ODEProblem(f_error, u0, (0.0, 1.0))
sol = solve(prob, CVODE_BDF())
sol = solve(prob, CVODE_BDF(); verbose = false)

f_error2(du, u, p, t) = du .= u ./ t .- 1
u0 = [1.0];
du0 = [1.0];
prob = DAEProblem(f_error2, u0, du0, (0.0, 1.0); differential_vars = [true])
sol = solve(prob, IDA(), initializealg = Sundials.BrownFullBasicInit())
sol = solve(prob, IDA(); initializealg = Sundials.BrownFullBasicInit(), verbose = false)

@test sol.retcode == ReturnCode.InitialFailure

u = zeros(Float64, 0)
du = zeros(Float64, 0)
function F(du, u, p, t) end
prob = DAEProblem{false}(
    F, du,
    u,
    (0.0, 1.0e-7);
    differential_vars = fill(true, 0)
)

using Sundials, Test
using SciMLBase: NoInit
using DAEProblemLibrary: prob_dae_resrob
using DiffEqCallbacks
using DiffEqBase

# Test DAE
mutable struct precflags
    prec_used::Bool
    psetup_used::Bool
end

p = precflags(false, false)
prob = DAEProblem(
    prob_dae_resrob.f, prob_dae_resrob.du0, prob_dae_resrob.u0,
    prob_dae_resrob.tspan, p
)

dt = 1000
saveat = float(collect(0:dt:100000))
sol1 = solve(prob, IDA())
@info "Multiple abstol"
sol = solve(prob, IDA(); abstol = [1.0e-9, 1.0e-8, 1.0e-7])
@info "Band solver"
sol2 = solve(prob, IDA(; linear_solver = :Band, jac_upper = 2, jac_lower = 2))
# Testing iterative solvers
@info "GMRES solver"
sol3 = solve(prob, IDA(; linear_solver = :GMRES))
@info "TFQMR solver"
sol5 = solve(prob, IDA(; linear_solver = :TFQMR))  # Returns ConvergenceFailure
@info "FGMRES solver"
sol6 = solve(prob, IDA(; linear_solver = :FGMRES))
@info "PCG solver"
sol7 = solve(prob, IDA(; linear_solver = :PCG))  # Returns MaxIters
#sol4 = solve(prob,IDA(linear_solver=:BCG)) # Fails but doesn't throw an error?
# @info "KLU solver"
# sol8 = solve(prob, IDA(; linear_solver = :KLU)) # Requires sparse Jacobian prototype

# Testing LapackBand/LapackDense solvers
sol9 = solve(prob, IDA(; linear_solver = :LapackBand, jac_upper = 2, jac_lower = 2))
sol10 = solve(prob, IDA(; linear_solver = :LapackDense))
sol11 = solve(prob, IDA(; linear_solver = :Dense))

# Test that LAPACK solvers work
@test sol9.retcode == ReturnCode.Success
@test sol10.retcode == ReturnCode.Success
@test sol11.retcode == ReturnCode.Success
@test isapprox(sol1.u[end], sol9.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol10.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol11.u[end]; rtol = 1.0e-3)

# Test iterative solvers work
@test sol3.retcode == ReturnCode.Success
@test_broken sol5.retcode == ReturnCode.Success  # TFQMR has convergence issues
@test sol6.retcode == ReturnCode.Success
@test_broken sol7.retcode == ReturnCode.Success  # PCG requires symmetric linear system
# Iterative solvers without preconditioner are unstable - mark as broken
@test_broken isapprox(sol1.u[end], sol3.u[end]; rtol = 1.0e-3)  # GMRES without preconditioner
@test_broken isapprox(sol1.u[end], sol5.u[end]; rtol = 1.0e-3)  # TFQMR convergence issues
@test_broken isapprox(sol1.u[end], sol6.u[end]; rtol = 1.0e-3)  # FGMRES without preconditioner
@test_broken isapprox(sol1.u[end], sol7.u[end]; rtol = 1.0e-3)  # PCG requires symmetric

# Test identity preconditioner
prec = (z, r, p, t, y, fy, resid, gamma, delta) -> (p.prec_used = true; z .= r)
psetup = (p, t, resid, u, du, gamma) -> (p.psetup_used = true)
@info "GMRES for identity preconditioner"
sol4 = solve(prob, IDA(; linear_solver = :GMRES, prec = prec))
@test p.prec_used
@info "GMRES with pset"
sol4 = solve(prob, IDA(; linear_solver = :GMRES, prec = prec, psetup = psetup))
@test p.psetup_used

@info "IDA with save_start=false"
@test SciMLBase.successful_retcode(solve(prob, IDA(); save_start = false))

@info "IDA with saveat"
sol = solve(prob, IDA(); saveat = saveat)

@test sol.t == saveat
@info "IDA with saveat everystep"
sol = solve(prob, IDA(); saveat = saveat, save_everystep = true)

@test sol.t != saveat
@test intersect(sol.t, saveat) == saveat
@info "IDA with tstops"
for tstops in [0.9, [0.9]]
    local sol = solve(prob, IDA(); tstops)
    @test 0.9 ∈ sol.t
end

sol = solve(prob, IDA(); d_discontinuities = [0.9])
@test 0.9 ∈ sol.t

@test solve(prob, IDA(); save_idxs = 1).u isa Vector{Float64}

prob = deepcopy(prob_dae_resrob)
prob2 = DAEProblem(prob.f, prob.du0, prob.u0, (1.0, 0.0))
sol = solve(prob2, IDA())
@test maximum(diff(sol.t)) < 0 # Make sure all go negative

function f!(res, du, u, p, t)
    res[1] = du[1] - 1.01
    return
end

u0 = [0.0]
du0 = [1.01] #consistent
tspan = (0.0, 10.0)

dae_prob = DAEProblem(f!, du0, u0, tspan; differential_vars = [true])
sol = solve(dae_prob, IDA())
@test sol.retcode == ReturnCode.Success

du0 = [0.0] # inconsistent
dae_prob = DAEProblem(f!, du0, u0, tspan; differential_vars = [true])
sol = solve(dae_prob, IDA(); initializealg = BrownFullBasicInit())

function f!(res, du, u, p, t)
    res[1] = u[1] - 1.01
    return
end

u0 = [0.0] #inconsistent
du0 = [0.0]
tspan = (0.0, 10.0)

dae_prob = DAEProblem(f!, du0, u0, tspan; differential_vars = [false])
#Currently broken because initialize_dae! in OrdiniaryDiffEq specializes on ODEIntegrator
init(dae_prob, IDA(), initializealg = NoInit()).u == [0.0]

# test that initializers which modify states actually modify the states
struct DumbInit <: DiffEqBase.DAEInitializationAlgorithm end
function DiffEqBase.initialize_dae!(
        integrator::Sundials.IDAIntegrator,
        initializealg::DumbInit
    )
    integrator.u .= 1
    integrator.u_modified = true
    return DiffEqBase.initialize_dae!(integrator, Sundials.BrownFullBasicInit())
end
f(du, u, p, t) = du - u # u(t) = exp(t)
prob = DAEProblem(f, zeros(1), zeros(1), (0, 1), differential_vars = trues(1))
sol = solve(prob, IDA(), initializealg = DumbInit())
# test that initializealg is reflected in the sol
isapprox(only(sol.u[begin]), 1, rtol = 1.0e-3)
# test that solve produced the right answer.
isapprox(only(sol.u[end]), exp(1), rtol = 1.0e-3)

f_noconverge(out, du, u, p, t) = out .= [du[1] + u[1] / (t - 1)]
prob = DAEProblem(f_noconverge, [1.0], [1.0], (0, 2); differential_vars = [true])
sol = solve(prob, IDA())
@test !(sol.retcode in (ReturnCode.Success,))

# Test that we're saving the correct initial data for du
function f_initial_data(du, u, p, t)
    return [du[1] - (u[1] + 10.0)]
end
prob = DAEProblem(f_initial_data, [0.0], [1.0], (0.0, 1.0); differential_vars = [true])
sol = solve(prob, IDA(), initializealg = Sundials.BrownFullBasicInit())
# If this is one, it incorrectly saved u, if it is 0., it incorrectly solved
# the pre-init value rather than the post-init one.
@test sol(0.0, Val{1})[1] ≈ 11.0

# test that callbacks modifying p get the new p
daefun = (du, u, p, t) -> [du[1] - u[2], u[2] - p]
callback = PresetTimeCallback(0.5, integ -> (integ.p = -integ.p;))
prob = DAEProblem(
    daefun, [0.0, 0.0], [0.0, -1.0], (0.0, 1), 1;
    differential_vars = [true, false], callback
)
sol = solve(prob, IDA(), initializealg = Sundials.BrownFullBasicInit())
@test sol.retcode == ReturnCode.Success
# test that the callback flipping p caused u[2] to get flipped.
first_t = findfirst(isequal(0.5), sol.t)
@test sol.u[first_t][2] == -sol.u[first_t + 1][2]

abstract type AbstractFunJac{J2} end
mutable struct FunJac{
        N, F, F2, J, P, M, J2, Prec, PS,
        TResid <: Union{Nothing, Array{Float64, N}},
    } <: AbstractFunJac{J2}
    fun::F
    fun2::F2
    jac::J
    p::P
    mass_matrix::M
    jac_prototype::J2
    prec::Prec
    psetup::PS
    u::Array{Float64, N}
    du::Array{Float64, N}
    resid::TResid
end
function FunJac(fun, jac, p, m, jac_prototype, prec, psetup, u, du)
    return FunJac(
        fun, nothing, jac, p, m,
        jac_prototype, prec,
        psetup, u, du, nothing
    )
end
function FunJac(fun, jac, p, m, jac_prototype, prec, psetup, u, du, resid)
    return FunJac(
        fun, nothing,
        jac, p, m,
        jac_prototype,
        prec, psetup, u,
        du, resid
    )
end

function cvodefunjac(t::Float64, u::N_Vector, du::N_Vector, funjac::FunJac{N}) where {N}
    funjac.u = unsafe_wrap(Array{Float64, N}, N_VGetArrayPointer_Serial(u), size(funjac.u))
    funjac.du = unsafe_wrap(
        Array{Float64, N}, N_VGetArrayPointer_Serial(du),
        size(funjac.du)
    )
    _du = funjac.du
    _u = funjac.u
    funjac.fun(_du, _u, funjac.p, t)
    return CV_SUCCESS
end

function cvodefunjac2(t::Float64, u::N_Vector, du::N_Vector, funjac::FunJac{N}) where {N}
    funjac.u = unsafe_wrap(Array{Float64, N}, N_VGetArrayPointer_Serial(u), size(funjac.u))
    funjac.du = unsafe_wrap(
        Array{Float64, N}, N_VGetArrayPointer_Serial(du),
        size(funjac.du)
    )
    _du = funjac.du
    _u = funjac.u
    funjac.fun2(_du, _u, funjac.p, t)
    return CV_SUCCESS
end

function cvodejac(
        t::realtype,
        u::N_Vector,
        du::N_Vector,
        J::SUNMatrix,
        funjac::AbstractFunJac{Nothing},
        tmp1::N_Vector,
        tmp2::N_Vector,
        tmp3::N_Vector
    )
    funjac.u = unsafe_wrap(Vector{Float64}, N_VGetArrayPointer_Serial(u), length(funjac.u))
    _u = funjac.u
    funjac.jac(convert(Matrix, J), _u, funjac.p, t)
    return CV_SUCCESS
end

function cvodejac(
        t::realtype,
        u::N_Vector,
        du::N_Vector,
        _J::SUNMatrix,
        funjac::AbstractFunJac{<:SparseArrays.SparseMatrixCSC},
        tmp1::N_Vector,
        tmp2::N_Vector,
        tmp3::N_Vector
    )
    jac_prototype = funjac.jac_prototype

    funjac.u = unsafe_wrap(Vector{Float64}, N_VGetArrayPointer_Serial(u), length(funjac.u))
    _u = funjac.u

    funjac.jac(jac_prototype, _u, funjac.p, t)

    copyto!(_J, jac_prototype)

    return CV_SUCCESS
end

function idasolfun(
        t::Float64, u::N_Vector, du::N_Vector, resid::N_Vector,
        funjac::FunJac{N}
    ) where {N}
    funjac.u = unsafe_wrap(Array{Float64, N}, N_VGetArrayPointer_Serial(u), size(funjac.u))
    _u = funjac.u
    funjac.du = unsafe_wrap(
        Array{Float64, N}, N_VGetArrayPointer_Serial(du),
        size(funjac.du)
    )
    _du = funjac.du
    funjac.resid = unsafe_wrap(
        Array{Float64, N}, N_VGetArrayPointer_Serial(resid),
        size(funjac.resid)
    )
    _resid = funjac.resid
    funjac.fun(_resid, _du, _u, funjac.p, t)
    return IDA_SUCCESS
end

function idajac(
        t::realtype,
        cj::realtype,
        u::N_Vector,
        du::N_Vector,
        res::N_Vector,
        J::SUNMatrix,
        funjac::AbstractFunJac{Nothing},
        tmp1::N_Vector,
        tmp2::N_Vector,
        tmp3::N_Vector
    )
    N = ndims(funjac.u)
    funjac.u = unsafe_wrap(Array{Float64, N}, N_VGetArrayPointer_Serial(u), size(funjac.u))
    _u = funjac.u
    funjac.du = unsafe_wrap(
        Array{Float64, N}, N_VGetArrayPointer_Serial(du),
        size(funjac.du)
    )
    _du = funjac.du

    funjac.jac(convert(Matrix, J), _du, _u, funjac.p, cj, t)
    return IDA_SUCCESS
end

function idajac(
        t::realtype,
        cj::realtype,
        u::N_Vector,
        du::N_Vector,
        res::N_Vector,
        _J::SUNMatrix,
        funjac::AbstractFunJac{<:SparseArrays.SparseMatrixCSC},
        tmp1::N_Vector,
        tmp2::N_Vector,
        tmp3::N_Vector
    )
    jac_prototype = funjac.jac_prototype
    N = ndims(funjac.u)
    funjac.u = unsafe_wrap(Array{Float64, N}, N_VGetArrayPointer_Serial(u), size(funjac.u))
    _u = funjac.u
    funjac.du = unsafe_wrap(
        Array{Float64, N}, N_VGetArrayPointer_Serial(du),
        size(funjac.du)
    )
    _du = funjac.du

    funjac.jac(jac_prototype, _du, _u, funjac.p, cj, t)

    copyto!(_J, jac_prototype)

    return IDA_SUCCESS
end

function massmat(
        t::Float64,
        _M::SUNMatrix,
        mmf::AbstractFunJac,
        tmp1::N_Vector,
        tmp2::N_Vector,
        tmp3::N_Vector
    )
    if mmf.mass_matrix isa Array
        M = convert(Matrix, _M)
        M .= mmf.mass_matrix
    else
        copyto!(_M, mmf.mass_matrix)
    end

    return IDA_SUCCESS
end

function jactimes(
        v::N_Vector,
        Jv::N_Vector,
        t::Float64,
        y::N_Vector,
        fy::N_Vector,
        fj::AbstractFunJac,
        tmp::N_Vector
    )
    DiffEqBase.update_coefficients!(fj.jac_prototype, convert(Vector, y), fj.p, t)
    LinearAlgebra.mul!(convert(Vector, Jv), fj.jac_prototype, convert(Vector, v))
    return CV_SUCCESS
end

function idajactimes(
        t::Float64,
        y::N_Vector,
        fy::N_Vector,
        r::N_Vector,
        v::N_Vector,
        Jv::N_Vector,
        cj::Float64,
        fj::AbstractFunJac,
        tmp1::N_Vector,
        tmp2::N_Vector
    )
    DiffEqBase.update_coefficients!(fj.jac_prototype, convert(Vector, y), fj.p, t)
    LinearAlgebra.mul!(convert(Vector, Jv), fj.jac_prototype, convert(Vector, v))
    return IDA_SUCCESS
end

function precsolve(
        t::Float64,
        y::N_Vector,
        fy::N_Vector,
        r::N_Vector,
        z::N_Vector,
        gamma::Float64,
        delta::Float64,
        lr::Int,
        fj::AbstractFunJac
    )
    fj.prec(
        convert(Vector, z),
        convert(Vector, r),
        fj.p,
        t,
        convert(Vector, y),
        convert(Vector, fy),
        gamma,
        delta,
        lr
    )
    return CV_SUCCESS
end

function precsetup(
        t::Float64,
        y::N_Vector,
        fy::N_Vector,
        jok::Int,
        jcurPtr::Ref{Int},
        gamma::Float64,
        fj::AbstractFunJac
    )
    fj.psetup(
        fj.p,
        t,
        convert(Vector, y),
        convert(Vector, fy),
        jok == 1,
        Base.unsafe_wrap(Vector{Int}, jcurPtr, 1),
        gamma
    )
    return CV_SUCCESS
end

function idaprecsolve(
        t::Float64,
        y::N_Vector,
        fy::N_Vector,
        resid::N_Vector,
        r::N_Vector,
        z::N_Vector,
        gamma::Float64,
        delta::Float64,
        fj::AbstractFunJac
    )
    fj.prec(
        convert(Vector, z),
        convert(Vector, r),
        fj.p,
        t,
        convert(Vector, y),
        convert(Vector, fy),
        convert(Vector, resid),
        gamma,
        delta
    )
    return IDA_SUCCESS
end

function idaprecsetup(
        t::Float64,
        y::N_Vector,
        fy::N_Vector,
        rr::N_Vector,
        gamma::Float64,
        fj::AbstractFunJac
    )
    fj.psetup(fj.p, t, convert(Vector, rr), convert(Vector, y), convert(Vector, fy), gamma)
    return IDA_SUCCESS
end

using Sundials, Test, ForwardDiff
using Sundials: N_Vector, N_Vector_S
using LinearAlgebra

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]

function mycopy!(pp, arr::Matrix)
    nj = size(arr, 2)
    ps = unsafe_wrap(Array, pp, nj)
    for j in 1:nj
        arr[:, j] = Sundials.asarray(ps[j])
    end
    return arr
end

function mycopy!(arr::Matrix, pp)
    nj = size(arr, 2)
    ps = unsafe_wrap(Array, pp, nj)
    for j in 1:nj
        Sundials.asarray(ps[j])[:] = arr[:, j]
    end
    return
end

f!(dy, t, y, p) = (dy[:] = y .* p)

function srhs(t, y, ydot, ys, ysdot)
    n = length(y)
    np = 2
    dyt = similar(y)
    chunk = min(n, 8)
    c1 = ForwardDiff.JacobianConfig(nothing, dyt, dyt, ForwardDiff.Chunk{chunk}())
    c2 = ForwardDiff.JacobianConfig(nothing, dyt, p, ForwardDiff.Chunk{chunk}())
    jac = ForwardDiff.jacobian((dy, y) -> f!(dy, t, y, p), dyt, y, c1, Val{false}())
    #jac = ReverseDiff.jacobian!(t1, y)
    ysdot[:] = jac * ys

    jac = ForwardDiff.jacobian((dy, p) -> f!(dy, t, y, p), dyt, p, c2, Val{false}())
    #jac = ReverseDiff.jacobian!(t2, p)
    return ysdot[:, 1:np] += jac
end

"""
    sens(f!, t0, y0, p, tout; reltol, abstol)
Compute the solution and sensitivities to the parametrized ODE problem defined by `f!(ẏ, t, y, p)`, starting at t0, y0, p.
Return the solutions `y` at times tout (>t0) as well as the corresponding sensitivity matrices `ys`.
y[i, t] is the solutions component i at timestep t.
ys[i, j, t] is the i-th component sensitivity wrt the j-th parameter at timestep t.
ys[i, np+j, t] the i-th component sensitivity wrt the j-th initial condition value.
"""
function sens(
        f!::Function,
        t0::Float64,
        y0::Vector{Float64},
        p::Vector{Float64},
        tout::Vector{Float64};
        reltol::Float64 = 1.0e-5,
        abstol::Float64 = 1.0e-5
    )
    n = length(y0)
    np = length(p)
    ys0 = zeros(n, np .+ n)
    ys0[:, np .+ (1:n)] = Matrix(1.0I, n, n)

    #t1 = ReverseDiff.JacobianTape((dy,y)->f!(dy,0,y,p), dyt, y0)
    #t2 = ReverseDiff.JacobianTape((dy,p)->f!(dy,0,y0,p), dyt, p)

    pbar = abs.(vcat(p, y0))
    return y, ys = cvodes(f!, srhs, t0, y0, ys0, p, reltol, abstol, pbar, tout)
end

### internals

## data structure dealing with the sundials callbacks

mutable struct CVSData
    f::Any  # f(t,y,dy)
    fs::Any # fs()
    p::Any
    jys::Any
    jdys::Any
end

function CVSData(f, fs, p, n::Int, nS::Int)
    return CVSData(
        f, fs, p, Array{Float64}(undef, n, nS),
        Array{Float64}(undef, n, nS)
    )
end

function cvrhsfn(t::Float64, y::N_Vector, dy::N_Vector, data::CVSData)
    data.f(convert(Vector, dy), t, convert(Vector, y), data.p)
    return Sundials.CV_SUCCESS
end

function cvsensrhsfn(
        ns::Cint,
        t::Float64,
        y::N_Vector,
        dy::N_Vector,
        ys::N_Vector_S,
        dys::N_Vector_S,
        data::CVSData,
        tmp1::N_Vector,
        tmp2::N_Vector
    )
    jys = data.jys
    jdys = data.jdys
    mycopy!(ys, data.jys)
    data.fs(t, convert(Vector, y), convert(Vector, dy), jys, jdys)
    mycopy!(jdys, dys)
    return Sundials.CV_SUCCESS
end

## cvodes wrapper

"Given the sensitivity problem, return (y,ys) where
y[i,t] is the solutions i-th component for timestep t and
ys[i,j,t] is the sensitivity of the i-th component wrt to the j-th parameter, where
the last parameter indices correspond to the initial conditions components."
function cvodes(f, fS, t0, y0, yS0, p, reltol, abstol, pbar, t::AbstractVector)
    N, Ns = size(yS0)
    y = zeros(N, length(t))
    ys = zeros(N, Ns, length(t))
    tret = [t0]
    yret = similar(y0)
    ysret = similar(yS0)
    y0n = Sundials.NVector(y0, ctx)
    yretn = Sundials.NVector(yret, ctx)
    yS0n = [Sundials.NVector(yS0[:, j], ctx) for j in 1:Ns]
    yS0nv = Sundials.NVectorArray(yS0n)
    crhs = Sundials.@cfunction(
        cvrhsfn,
        Cint,
        (Sundials.realtype, N_Vector, N_Vector, Ref{CVSData})
    )
    csensrhs = Sundials.@cfunction(
        cvsensrhsfn,
        Cint,
        (
            Cint,
            Sundials.realtype,
            N_Vector,
            N_Vector,
            N_Vector_S,
            N_Vector_S,
            Ref{CVSData},
            N_Vector,
            N_Vector,
        )
    )

    ##

    mem_ptr = Sundials.CVodeCreate(Sundials.CV_ADAMS, ctx)
    #mem_ptr = Sundials.CVodeCreate(Sundials.CV_BDF, ctx)
    cvode_mem = Sundials.Handle(mem_ptr)
    Sundials.CVodeInit(cvode_mem, crhs, t0, y0n)
    nls = Sundials.SUNNonlinSol_FixedPoint(yretn, Cint(0), ctx)
    nls_handle = Sundials.NonLinSolHandle(nls, Sundials.FixedPoint())
    Sundials.CVodeSetNonlinearSolver(cvode_mem, nls)
    Sundials.CVodeSStolerances(cvode_mem, reltol, abstol)
    data = CVSData(f, fS, p, size(yS0)...)
    Sundials.CVodeSetUserData(cvode_mem, data)

    Sundials.CVodeSensInit(cvode_mem, Ns, Sundials.CV_STAGGERED, csensrhs, yS0nv)
    nlsS = Sundials.SUNNonlinSol_FixedPointSens(Cint(Ns), yretn, Cint(0), ctx)
    nlsS_handle = Sundials.NonLinSolHandle(nlsS, Sundials.FixedPoint())
    Sundials.CVodeSetNonlinearSolverSensStg(cvode_mem, nlsS)
    Sundials.CVodeSetSensParams(cvode_mem, C_NULL, pbar, C_NULL)
    Sundials.CVodeSensEEtolerances(cvode_mem)
    GC.@preserve data y0n yretn yS0n yS0nv pbar nls_handle nlsS_handle begin
        for i in 1:length(t)
            Sundials.CVode(cvode_mem, t[i], yretn, tret, Sundials.CV_NORMAL)
            Sundials.CVodeGetSens(cvode_mem, tret, yS0nv)
            mycopy!(pointer(yS0nv), ysret)
            y[:, i] = yret
            ys[:, :, i] = ysret
        end
    end
    empty!(nlsS_handle)
    empty!(nls_handle)
    empty!(cvode_mem)
    return y, ys
end

t0 = 0.0
t = [1.0, 2.0]
y0 = [1.0, 2.0]
p = [3.0, 4.0]
y, ys = sens(f!, t0, y0, p, t)
@test isapprox(y[1, 1], 20.0856; rtol = 1.0e-3)
@test isapprox(ys[2, 2, 2], 11924.3; rtol = 1.0e-3)

# Clean up context
Sundials.SUNContext_Free(ctx)

## Common Interface Solve Functions

function DiffEqBase.__solve(
        prob::Union{
            SciMLBase.AbstractODEProblem,
            SciMLBase.AbstractDAEProblem,
        },
        alg::algType,
        timeseries = [],
        ts = [],
        ks = [],
        recompile::Type{Val{recompile_flag}} = Val{true};
        calculate_error = true,
        kwargs...
    ) where {
        algType <: Union{
            SundialsODEAlgorithm,
            SundialsDAEAlgorithm,
        },
        recompile_flag,
    }
    integrator = DiffEqBase.__init(prob, alg, timeseries, ts, ks; kwargs...)
    if integrator.sol.retcode == ReturnCode.Default
        solve!(integrator; early_free = true, calculate_error = calculate_error)
    end
    return integrator.sol
end

function DiffEqBase.__solve(
        prob::Union{
            SciMLBase.AbstractSteadyStateProblem{
                uType,
                isinplace,
            },
            SciMLBase.AbstractNonlinearProblem{
                uType,
                isinplace,
            },
        },
        alg::algType,
        timeseries = [],
        ts = [],
        ks = [],
        recompile::Type{Val{recompile_flag}} = Val{true};
        abstol = eps(Float64)^(4 // 5),
        maxiters = 1000,
        kwargs...
    ) where {
        algType <: SundialsNonlinearSolveAlgorithm,
        recompile_flag, uType, isinplace,
    }
    if prob.u0 isa Number
        u0 = [prob.u0]
    else
        u0 = deepcopy(prob.u0)
    end

    p = prob.p
    userdata = alg.userdata
    linsolve = linear_solver(alg)
    jac_upper = alg.jac_upper
    jac_lower = alg.jac_lower

    ### Fix the more general function to Sundials allowed style
    if prob.f isa ODEFunction
        t = Inf
        if !isinplace && prob.u0 isa Number
            f! = (du, u) -> (du .= prob.f(first(u), p, t); Cint(0))
        elseif !isinplace
            f! = (du, u) -> (du .= prob.f(u, p, t); Cint(0))
        else # Then it's an in-place function on an abstract array
            f! = (du, u) -> prob.f(du, u, p, t)
        end
    elseif prob.f isa NonlinearFunction
        if !isinplace && prob.u0 isa Number
            f! = (du, u) -> (du .= prob.f(first(u), p); Cint(0))
        elseif !isinplace
            f! = (du, u) -> (du .= prob.f(u, p); Cint(0))
        else # Then it's an in-place function on an abstract array
            f! = (du, u) -> prob.f(du, u, p)
        end
    else
        error("Problem function must be ODEFunction or NonlinearFunction")
    end
    u = zero(u0)
    resid = similar(u)
    u,
        flag = ___kinsol(
        f!, u0;
        userdata = userdata,
        linear_solver = linsolve,
        jac_upper = jac_upper,
        jac_lower = jac_lower,
        abstol,
        prob.f.jac_prototype,
        alg.prec_side,
        alg.krylov_dim,
        maxiters,
        strategy = alg.globalization_strategy,
        alg.maxsetupcalls
    )

    f!(resid, u)
    retcode = interpret_sundials_retcode(flag)
    return if prob.u0 isa Number
        SciMLBase.build_solution(prob, alg, u[1], resid[1]; retcode = retcode)
    else
        SciMLBase.build_solution(prob, alg, u, resid; retcode = retcode)
    end
end

function DiffEqBase.__init(
        prob::SciMLBase.AbstractODEProblem{uType, tupType, isinplace},
        alg::SundialsODEAlgorithm{Method, LinearSolver},
        timeseries = [],
        ts = [],
        ks = [];
        verbose = Standard(),
        callback = nothing,
        abstol = 1 / 10^6,
        reltol = 1 / 10^3,
        saveat = Float64[],
        d_discontinuities = Float64[],
        tstops = Float64[],
        maxiters = Int(1.0e5),
        dt = nothing,
        dtmin = 0.0,
        dtmax = 0.0,
        timeseries_errors = true,
        dense_errors = false,
        save_everystep = isempty(saveat), save_idxs = nothing,
        save_on = true,
        save_start = save_everystep || isempty(saveat) ||
            saveat isa Number ? true :
            prob.tspan[1] in saveat,
        save_end = save_everystep || isempty(saveat) ||
            saveat isa Number ? true :
            prob.tspan[2] in saveat,
        dense = save_everystep && isempty(saveat),
        progress = false,
        progress_steps = 1000,
        progress_name = "ODE",
        progress_message = DiffEqBase.ODE_DEFAULT_PROG_MESSAGE,
        progress_id = :Sundials,
        save_timeseries = nothing,
        advance_to_tstop = false,
        stop_at_next_tstop = false,
        userdata = nothing,
        alias_u0 = false,
        initializealg = DefaultInit(),
        kwargs...
    ) where {
        uType, tupType, isinplace, Method, LinearSolver,
    }
    tType = eltype(tupType)
    verbose = _process_verbose_param(verbose)

    if !isempty(kwargs)
        warned = DiffEqBase.check_keywords(alg, kwargs, warnlist)
        if warned
            @SciMLMessage(
                "Unrecognized keyword arguments passed to Sundials solver.",
                verbose, :inconsistent_input
            )
        end
    end

    if prob.f.mass_matrix != LinearAlgebra.I
        error("This solver is not able to use mass matrices.")
    end

    if reltol isa AbstractArray
        error("Sundials only allows scalar reltol.")
    end

    if length(prob.u0) <= 0
        error("Sundials requires at least one state variable.")
    end

    progress &&
        Logging.@logmsg(Logging.LogLevel(-1), progress_name, _id = progress_id, progress = 0)

    tstops = vcat(tstops, d_discontinuities)
    callbacks_internal = DiffEqBase.CallbackSet(callback)

    max_len_cb = DiffEqBase.max_vector_callback_length(callbacks_internal)
    if max_len_cb isa VectorContinuousCallback
        callback_cache = DiffEqBase.CallbackCache(max_len_cb.len, Float64, Float64)
    else
        callback_cache = nothing
    end

    tspan = Float64.(prob.tspan)
    t0 = tspan[1]

    tdir = sign(tspan[2] - tspan[1])

    tstops_internal,
        saveat_internal = tstop_saveat_disc_handling(
        tstops, saveat, tdir,
        tspan, tType
    )

    if prob.u0 isa Number
        u0 = [prob.u0]
    else
        if alias_u0
            u0 = prob.u0
        else
            u0 = copy(prob.u0)
        end
    end

    ### Fix the more general function to Sundials allowed style
    if !isinplace && prob.u0 isa Number
        f! = (du, u, p, t) -> (du .= prob.f(first(u), p, t); Cint(0))
    elseif !isinplace
        f! = (du, u, p, t) -> (du .= prob.f(u, p, t); Cint(0))
    else # Then it's an in-place function on an abstract array
        f! = prob.f
    end

    if alg isa CVODE_BDF
        alg_code = CV_BDF
    elseif alg isa CVODE_Adams
        alg_code = CV_ADAMS
    else
        error("Algorithm must be CVODE_BDF or CVODE_Adams")
    end

    #if Method == :Newton
    #    method_code = CV_NEWTON
    #elseif Method ==  :Functional
    #    method_code = CV_FUNCTIONAL
    #end

    ctx_handle = ContextHandle()
    ctx = ctx_handle.ctx
    mem_ptr = CVodeCreate(alg_code, ctx)
    (mem_ptr == C_NULL) && error("Failed to allocate CVODE solver object")
    mem = Handle(mem_ptr)

    save_start ? ts = [t0] : ts = Float64[]

    out = copy(u0)
    uvec = vec(u0) # aliases u0
    utmp = NVector(uvec, ctx) # aliases u0

    use_jac_prototype = (
        isa(prob.f.jac_prototype, SparseArrays.SparseMatrixCSC) &&
            LinearSolver ∈ SPARSE_SOLVERS
    ) ||
        prob.f.jac_prototype isa AbstractSciMLOperator
    userfun = FunJac(
        f!,
        prob.f.jac,
        prob.p,
        nothing,
        use_jac_prototype ? prob.f.jac_prototype : nothing,
        alg.prec,
        alg.psetup,
        u0,
        out
    )

    function getcfunf(::T) where {T}
        return @cfunction(cvodefunjac, Cint, (realtype, N_Vector, N_Vector, Ref{T}))
    end

    flag = CVodeInit(mem, getcfunf(userfun), t0, utmp)

    dt !== nothing && (flag = CVodeSetInitStep(mem, Float64(dt)))
    flag = CVodeSetMinStep(mem, Float64(dtmin))
    flag = CVodeSetMaxStep(mem, Float64(dtmax))
    flag = CVodeSetUserData(mem, userfun)
    if abstol isa Array
        abstol_nvec = NVector(abstol, ctx)
        flag = CVodeSVtolerances(mem, reltol, abstol_nvec)
    else
        flag = CVodeSStolerances(mem, reltol, abstol)
    end
    flag = CVodeSetMaxNumSteps(mem, maxiters)
    flag = CVodeSetMaxOrd(mem, alg.max_order)
    flag = CVodeSetMaxHnilWarns(mem, alg.max_hnil_warns)
    flag = CVodeSetStabLimDet(mem, alg.stability_limit_detect)
    flag = CVodeSetMaxErrTestFails(mem, alg.max_error_test_failures)
    flag = CVodeSetMaxNonlinIters(mem, alg.max_nonlinear_iters)
    flag = CVodeSetMaxConvFails(mem, alg.max_convergence_failures)

    nojacobian = true

    if Method == :Newton # Only use a linear solver if it's a Newton-based method
        if LinearSolver in (:Dense, :LapackDense)
            nojacobian = false
            A = SUNDenseMatrix(length(uvec), length(uvec), ctx)
            _A = MatrixHandle(A, DenseMatrix())
            if LinearSolver === :Dense
                LS = SUNLinSol_Dense(utmp, A, ctx)
                _LS = LinSolHandle(LS, Dense())
            else
                LS = SUNLinSol_LapackDense(utmp, A, ctx)
                _LS = LinSolHandle(LS, LapackDense())
            end
        elseif LinearSolver in (:Band, :LapackBand)
            nojacobian = false
            A = SUNBandMatrix(length(uvec), alg.jac_upper, alg.jac_lower, ctx)
            _A = MatrixHandle(A, BandMatrix())
            if LinearSolver === :Band
                LS = SUNLinSol_Band(utmp, A, ctx)
                _LS = LinSolHandle(LS, Band())
            else
                LS = SUNLinSol_LapackBand(utmp, A, ctx)
                _LS = LinSolHandle(LS, LapackBand())
            end
        elseif LinearSolver == :Diagonal
            nojacobian = false
            flag = CVDiag(mem)
            _A = nothing
            _LS = nothing
        elseif LinearSolver == :GMRES
            LS = SUNLinSol_SPGMR(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = Sundials.LinSolHandle(LS, Sundials.SPGMR())
        elseif LinearSolver == :FGMRES
            LS = SUNLinSol_SPFGMR(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, SPFGMR())
        elseif LinearSolver == :BCG
            LS = SUNLinSol_SPBCGS(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, SPBCGS())
        elseif LinearSolver == :PCG
            LS = SUNLinSol_PCG(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, PCG())
        elseif LinearSolver == :TFQMR
            LS = SUNLinSol_SPTFQMR(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, PTFQMR())
        elseif LinearSolver == :KLU
            nojacobian = false
            nnz = length(SparseArrays.nonzeros(prob.f.jac_prototype))
            A = SUNSparseMatrix(length(uvec), length(uvec), nnz, CSC_MAT, ctx)
            LS = SUNLinSol_KLU(utmp, A, ctx)
            _A = MatrixHandle(A, SparseMatrix())
            _LS = LinSolHandle(LS, KLU())
        end
        if LinearSolver !== :Diagonal
            flag = CVodeSetLinearSolver(mem, LS, _A === nothing ? C_NULL : A)
        end
        NLS = SUNNonlinSol_Newton(utmp, ctx)
        CVodeSetNonlinearSolver(mem, NLS)
    else
        _A = nothing
        _LS = nothing
        # TODO: Anderson Acceleration
        anderson_m = Cint(0)
        NLS = SUNNonlinSol_FixedPoint(utmp, anderson_m, ctx)
        CVodeSetNonlinearSolver(mem, NLS)
    end

    if SciMLBase.has_jac(prob.f) && Method == :Newton
        function getcfunjac(::T) where {T}
            return @cfunction(
                cvodejac,
                Cint,
                (
                    realtype,
                    N_Vector,
                    N_Vector,
                    SUNMatrix,
                    Ref{T},
                    N_Vector,
                    N_Vector,
                    N_Vector,
                )
            )
        end
        jac = getcfunjac(userfun)
        flag = CVodeSetUserData(mem, userfun)
        nojacobian || (flag = CVodeSetJacFn(mem, jac))
    else
        jac = nothing
    end

    if prob.f.jac_prototype isa AbstractSciMLOperator
        "here!!!!"
        function getcfunjtimes(::T) where {T}
            return @cfunction(
                jactimes,
                Cint,
                (N_Vector, N_Vector, realtype, N_Vector, N_Vector, Ref{T}, N_Vector)
            )
        end
        jtimes = getcfunjtimes(userfun)
        CVodeSetJacTimes(mem, C_NULL, jtimes)
    end

    if alg.prec !== nothing
        function getpercfun(::T) where {T}
            return @cfunction(
                precsolve,
                Cint,
                (
                    Float64,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    Float64,
                    Float64,
                    Int,
                    Ref{T},
                )
            )
        end
        precfun = getpercfun(userfun)

        function getpsetupfun(::T) where {T}
            return @cfunction(
                precsetup,
                Cint,
                (Float64, N_Vector, N_Vector, Int, Ptr{Int}, Float64, Ref{T})
            )
        end
        psetupfun = alg.psetup === nothing ? C_NULL : getpsetupfun(userfun)

        CVodeSetPreconditioner(mem, psetupfun, precfun)
    end

    tmp = isnothing(callbacks_internal) ? u0 : similar(u0)
    uprev = isnothing(callbacks_internal) ? u0 : similar(u0)
    tout = [tspan[1]]

    if save_start
        if save_idxs === nothing
            ures = Vector{uType}()
            dures = Vector{uType}()
            save_value!(ures, u0, uType, save_idxs)
            if dense
                f!(out, u0, prob.p, tspan[1])
                save_value!(dures, out, uType, save_idxs)
            end
        else
            ures = [u0[save_idxs]]
            if dense
                f!(out, u0, prob.p, tspan[1])
                dures = [out[save_idxs]]
            end
        end
    else
        ures = Vector{uType}()
        dures = Vector{uType}()
    end

    sol = SciMLBase.build_solution(
        prob,
        alg,
        ts,
        ures;
        dense = dense,
        interp = dense ?
            SciMLBase.HermiteInterpolation(
                ts, ures,
                dures
            ) :
            SciMLBase.LinearInterpolation(ts, ures),
        timeseries_errors = timeseries_errors,
        stats = SciMLBase.DEStats(0),
        calculate_error = false
    )
    opts = DEOptions(
        saveat_internal,
        tstops_internal,
        saveat, tstops, save_start,
        save_everystep, save_idxs,
        dense,
        timeseries_errors,
        dense_errors,
        save_on,
        save_end,
        callbacks_internal,
        abstol,
        reltol,
        verbose,
        advance_to_tstop,
        stop_at_next_tstop,
        progress,
        progress_steps,
        progress_name,
        progress_message,
        progress_id,
        maxiters
    )
    integrator = CVODEIntegrator(
        u0,
        utmp,
        prob.p,
        t0,
        t0,
        mem,
        _LS,
        _A,
        sol,
        alg,
        f!,
        userfun,
        jac,
        opts,
        tout,
        tdir,
        false,
        tmp,
        uprev,
        Cint(flag),
        false,
        0,
        1,
        callback_cache,
        0.0,
        initializealg,
        ctx_handle
    )
    SciMLBase.initialize_dae!(integrator, initializealg)
    integrator.u_modified && CVodeReInit(integrator.mem, integrator.t, integrator.u_nvec)
    initialize_callbacks!(integrator)
    return integrator
end # function solve

function DiffEqBase.__init(
        prob::SciMLBase.AbstractODEProblem{uType, tupType, isinplace},
        alg::ARKODE{Method, LinearSolver, MassLinearSolver},
        timeseries = [],
        ts = [],
        ks = [];
        verbose = Standard(),
        callback = nothing,
        abstol = 1 / 10^6,
        reltol = 1 / 10^3,
        saveat = Float64[],
        tstops = Float64[],
        d_discontinuities = Float64[],
        maxiters = Int(1.0e5),
        dt = nothing,
        dtmin = 0.0,
        dtmax = 0.0,
        timeseries_errors = true,
        dense_errors = false,
        save_everystep = isempty(saveat), save_idxs = nothing,
        dense = save_everystep,
        save_on = true,
        save_start = save_everystep || isempty(saveat) ||
            saveat isa Number ? true :
            prob.tspan[1] in saveat,
        save_end = save_everystep || isempty(saveat) ||
            saveat isa Number ? true :
            prob.tspan[2] in saveat,
        save_timeseries = nothing,
        progress = false,
        progress_steps = 1000,
        progress_name = "ODE",
        progress_message = DiffEqBase.ODE_DEFAULT_PROG_MESSAGE,
        progress_id = :Sundials,
        advance_to_tstop = false,
        stop_at_next_tstop = false,
        userdata = nothing,
        alias_u0 = false,
        initializealg = DefaultInit(),
        kwargs...
    ) where {
        uType, tupType, isinplace, Method,
        LinearSolver,
        MassLinearSolver,
    }
    tType = eltype(tupType)
    verbose = _process_verbose_param(verbose)

    if !isempty(kwargs)
        warned = DiffEqBase.check_keywords(alg, kwargs, warnlist)
        if warned
            @SciMLMessage(
                "Unrecognized keyword arguments passed to Sundials solver.",
                verbose, :inconsistent_input
            )
        end
    end

    if reltol isa AbstractArray
        error("Sundials only allows scalar reltol.")
    end

    if length(prob.u0) <= 0
        error("Sundials requires at least one state variable.")
    end

    progress &&
        Logging.@logmsg(Logging.LogLevel(-1), progress_name, _id = progress_id, progress = 0)

    tstops = vcat(tstops, d_discontinuities)
    callbacks_internal = DiffEqBase.CallbackSet(callback)

    max_len_cb = DiffEqBase.max_vector_callback_length(callbacks_internal)
    if max_len_cb isa VectorContinuousCallback
        callback_cache = DiffEqBase.CallbackCache(max_len_cb.len, Float64, Float64)
    else
        callback_cache = nothing
    end

    tspan = prob.tspan
    t0 = tspan[1]

    tdir = sign(tspan[2] - tspan[1])

    tstops_internal,
        saveat_internal = tstop_saveat_disc_handling(
        tstops, saveat, tdir,
        tspan, tType
    )

    if prob.u0 isa Number
        u0 = [prob.u0]
    else
        if alias_u0
            u0 = prob.u0
        else
            u0 = copy(prob.u0)
        end
    end

    save_start ? ts = [t0] : ts = Float64[]
    out = copy(u0)
    uvec = vec(u0)
    ctx_handle = ContextHandle()
    ctx = ctx_handle.ctx
    utmp = NVector(uvec, ctx)

    function arkodemem(; fe = C_NULL, fi = C_NULL, t0 = t0, u0 = utmp)
        mem_ptr = ARKStepCreate(fe, fi, t0, u0, ctx)
        (mem_ptr == C_NULL) && error("Failed to allocate ARKODE solver object")
        mem = Handle(mem_ptr)

        return mem
    end

    function erkodemem(; f = C_NULL, t0 = t0, u0 = utmp)
        mem_ptr = ERKStepCreate(f, t0, u0, ctx)
        (mem_ptr == C_NULL) && error("Failed to allocate ERKODE solver object")
        mem = Handle(mem_ptr)

        return mem
    end

    ### Fix the more general function to Sundials allowed style
    if !isinplace && prob.u0 isa Number
        f! = (du, u, p, t) -> (du .= prob.f(first(u), p, t); Cint(0))
    elseif !isinplace
        f! = (du, u, p, t) -> (du .= prob.f(u, p, t); Cint(0))
    else # Then it's an in-place function on an abstract array
        f! = prob.f
    end

    cfj1, cfj2, mem = if prob.problem_type isa SplitODEProblem

        ### Fix the more general function to Sundials allowed style
        if !isinplace && prob.u0 isa Number
            f1! = (du, u, p, t) -> (du .= prob.f.f1(first(u), p, t); Cint(0))
            f2! = (du, u, p, t) -> (du .= prob.f.f2(first(u), p, t); Cint(0))
        elseif !isinplace
            f1! = (du, u, p, t) -> (du .= prob.f.f1(u, p, t); Cint(0))
            f2! = (du, u, p, t) -> (du .= prob.f.f2(u, p, t); Cint(0))
        else # Then it's an in-place function on an abstract array
            f1! = prob.f.f1
            f2! = prob.f.f2
        end

        use_jac_prototype = (
            isa(prob.f.f1.jac_prototype, SparseArrays.SparseMatrixCSC) &&
                LinearSolver ∈ SPARSE_SOLVERS
        )
        userfun = FunJac(
            f1!,
            f2!,
            prob.f.f1.jac,
            prob.p,
            prob.f.mass_matrix,
            use_jac_prototype ? prob.f.f1.jac_prototype : nothing,
            alg.prec,
            alg.psetup,
            u0,
            out,
            nothing
        )

        function getcfunjac(::T) where {T}
            return @cfunction(cvodefunjac, Cint, (realtype, N_Vector, N_Vector, Ref{T}))
        end
        function getcfunjac2(::T) where {T}
            return @cfunction(cvodefunjac2, Cint, (realtype, N_Vector, N_Vector, Ref{T}))
        end
        cfj1 = getcfunjac(userfun)
        cfj2 = getcfunjac2(userfun)

        mem = arkodemem(; fi = cfj1, fe = cfj2)
        cfj1, cfj2, mem
    else
        use_jac_prototype = (
            isa(prob.f.jac_prototype, SparseArrays.SparseMatrixCSC) &&
                LinearSolver ∈ SPARSE_SOLVERS
        )
        userfun = FunJac(
            f!,
            prob.f.jac,
            prob.p,
            prob.f.mass_matrix,
            use_jac_prototype ? prob.f.jac_prototype : nothing,
            alg.prec,
            alg.psetup,
            u0,
            out
        )
        if alg.stiffness == Explicit()
            function getcfun1(::T) where {T}
                return @cfunction(cvodefunjac, Cint, (realtype, N_Vector, N_Vector, Ref{T}))
            end
            cfj1 = getcfun1(userfun)
            cfj2 = C_NULL
            mem = erkodemem(; f = cfj1)
            cfj1, cfj2, mem
        elseif alg.stiffness == Implicit()
            function getcfun2(::T) where {T}
                return @cfunction(cvodefunjac, Cint, (realtype, N_Vector, N_Vector, Ref{T}))
            end
            cfj1 = C_NULL
            cfj2 = getcfun2(userfun)
            mem = arkodemem(; fi = cfj2)
            cfj1, cfj2, mem
        end
    end

    # Use ERKStep functions for explicit methods, ARKStep for others
    is_explicit = (alg.stiffness == Explicit() && !isa(prob.problem_type, SplitODEProblem))

    if is_explicit
        # ERKStep functions
        dt !== nothing && (flag = ERKStepSetInitStep(mem, Float64(dt)))
        flag = ERKStepSetMinStep(mem, Float64(dtmin))
        flag = ERKStepSetMaxStep(mem, Float64(dtmax))
        flag = ERKStepSetUserData(mem, userfun)
        if abstol isa Array
            abstol_nvec = NVector(abstol, ctx)
            flag = ERKStepSVtolerances(mem, reltol, abstol_nvec)
        else
            flag = ERKStepSStolerances(mem, reltol, abstol)
        end
        flag = ERKStepSetMaxNumSteps(mem, maxiters)
        flag = ERKStepSetMaxHnilWarns(mem, alg.max_hnil_warns)
        flag = ERKStepSetMaxErrTestFails(mem, alg.max_error_test_failures)
        # ERKStep doesn't have max convergence fails (no nonlinear solver)
        # ERKStep doesn't have predictor or nonlinear convergence settings
        flag = ERKStepSetDenseOrder(mem, alg.dense_order)
    else
        # ARKStep functions
        dt !== nothing && (flag = ARKStepSetInitStep(mem, Float64(dt)))
        flag = ARKStepSetMinStep(mem, Float64(dtmin))
        flag = ARKStepSetMaxStep(mem, Float64(dtmax))
        flag = ARKStepSetUserData(mem, userfun)
        if abstol isa Array
            abstol_nvec = NVector(abstol, ctx)
            flag = ARKStepSVtolerances(mem, reltol, abstol_nvec)
        else
            flag = ARKStepSStolerances(mem, reltol, abstol)
        end
        flag = ARKStepSetMaxNumSteps(mem, maxiters)
        flag = ARKStepSetMaxHnilWarns(mem, alg.max_hnil_warns)
        flag = ARKStepSetMaxErrTestFails(mem, alg.max_error_test_failures)
        flag = ARKStepSetMaxConvFails(mem, alg.max_convergence_failures)
        flag = ARKStepSetPredictorMethod(mem, alg.predictor_method)
        flag = ARKStepSetNonlinConvCoef(mem, alg.nonlinear_convergence_coefficient)
        flag = ARKStepSetDenseOrder(mem, alg.dense_order)
    end

    #=
    Reference from Manual on ARKODE
    To choose an explicit table, set itable to a negative value. This automatically calls ARKStepSetExplicit(). However, if the problem is posed in explicit form, i.e. 𝑦 ̇ = 𝑓 (𝑡, 𝑦), then we recommend that the ERKStep time- stepper module be used instead of ARKStep.
    To select an implicit table, set etable to a negative value. This automatically calls ARKStepSetImplicit(). If both itable and etable are non-negative, then these should match an existing implicit/explicit pair, listed in the section Additive Butcher tables. This automatically calls ARKStepSetImEx().
    =#
    if is_explicit
        # ERKStep table settings
        if alg.etable !== nothing
            flag = ERKStepSetTableNum(mem, alg.etable)
        else
            flag = ERKStepSetOrder(mem, alg.order)
        end
    else
        # ARKStep table settings
        if alg.itable === nothing && alg.etable === nothing
            flag = ARKStepSetOrder(mem, alg.order)
        elseif alg.itable === nothing && alg.etable !== nothing
            flag = ARKStepSetTableNum(mem, -1, alg.etable)
        elseif alg.itable !== nothing && alg.etable === nothing
            flag = ARKStepSetTableNum(mem, alg.itable, -1)
        else
            flag = ARKStepSetTableNum(mem, alg.itable, alg.etable)
        end

        flag = ARKStepSetNonlinCRDown(mem, alg.crdown)
        flag = ARKStepSetNonlinRDiv(mem, alg.rdiv)
        flag = ARKStepSetDeltaGammaMax(mem, alg.dgmax)
        flag = ARKStepSetLSetupFrequency(mem, alg.msbp)
        #flag = ARKStepSetAdaptivityMethod(mem,alg.adaptivity_method,1,0)

        #flag = ARKStepSetFixedStep(mem,)
        alg.set_optimal_params && (flag = ARKStepSetOptimalParams(mem))
    end

    if Method == :Newton && alg.stiffness !== Explicit() # Only use a linear solver if it's a Newton-based method
        if LinearSolver in (:Dense, :LapackDense)
            nojacobian = false
            A = SUNDenseMatrix(length(uvec), length(uvec), ctx)
            _A = MatrixHandle(A, DenseMatrix())
            if LinearSolver === :Dense
                LS = SUNLinSol_Dense(utmp, A, ctx)
                _LS = LinSolHandle(LS, Dense())
            else
                LS = SUNLinSol_LapackDense(utmp, A, ctx)
                _LS = LinSolHandle(LS, LapackDense())
            end
        elseif LinearSolver in (:Band, :LapackBand)
            nojacobian = false
            A = SUNBandMatrix(length(uvec), alg.jac_upper, alg.jac_lower, ctx)
            _A = MatrixHandle(A, BandMatrix())
            if LinearSolver === :Band
                LS = SUNLinSol_Band(utmp, A, ctx)
                _LS = LinSolHandle(LS, Band())
            else
                LS = SUNLinSol_LapackBand(utmp, A, ctx)
                _LS = LinSolHandle(LS, LapackBand())
            end
        elseif LinearSolver == :GMRES
            LS = SUNLinSol_SPGMR(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = Sundials.LinSolHandle(LS, Sundials.SPGMR())
        elseif LinearSolver == :FGMRES
            LS = SUNLinSol_SPFGMR(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, SPFGMR())
        elseif LinearSolver == :BCG
            LS = SUNLinSol_SPBCGS(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, SPBCGS())
        elseif LinearSolver == :PCG
            LS = SUNLinSol_PCG(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, PCG())
        elseif LinearSolver == :TFQMR
            LS = SUNLinSol_SPTFQMR(utmp, Cint(alg.prec_side), Cint(alg.krylov_dim), ctx)
            _A = nothing
            _LS = LinSolHandle(LS, PTFQMR())
        elseif LinearSolver == :KLU
            nnz = length(SparseArrays.nonzeros(prob.f.jac_prototype))
            A = SUNSparseMatrix(length(uvec), length(uvec), nnz, CSC_MAT, ctx)
            LS = SUNLinSol_KLU(utmp, A, ctx)
            _A = MatrixHandle(A, SparseMatrix())
            _LS = LinSolHandle(LS, KLU())
        end
        flag = ARKStepSetLinearSolver(mem, LS, _A === nothing ? C_NULL : A)
        flag = ARKStepSetMaxNonlinIters(mem, alg.max_nonlinear_iters)
    elseif Method == :Functional && alg.stiffness !== Explicit()
        ARKStepSetFixedPoint(mem, Clong(alg.krylov_dim))
    else
        _A = nothing
        _LS = nothing
    end

    if (
            prob.problem_type isa SplitODEProblem &&
                prob.f.f1.jac_prototype isa AbstractSciMLOperator
        ) ||
            (
            !(prob.problem_type isa SplitODEProblem) &&
                prob.f.jac_prototype isa AbstractSciMLOperator
        ) &&
            alg.stiffness !== Explicit()
        function getcfunjtimes(::T) where {T}
            return @cfunction(
                jactimes,
                Cint,
                (N_Vector, N_Vector, realtype, N_Vector, N_Vector, Ref{T}, N_Vector)
            )
        end
        jtimes = getcfunjtimes(userfun)
        ARKStepSetJacTimes(mem, C_NULL, jtimes)
    end

    if prob.f.mass_matrix != LinearAlgebra.I && alg.stiffness !== Explicit()
        if MassLinearSolver in (:Dense, :LapackDense)
            nojacobian = false
            M = SUNDenseMatrix(length(uvec), length(uvec), ctx)
            _M = MatrixHandle(M, DenseMatrix())
            if MassLinearSolver === :Dense
                MLS = SUNLinSol_Dense(utmp, M, ctx)
                _MLS = LinSolHandle(MLS, Dense())
            else
                MLS = SUNLinSol_LapackDense(utmp, M, ctx)
                _MLS = LinSolHandle(MLS, LapackDense())
            end
        elseif MassLinearSolver in (:Band, :LapackBand)
            nojacobian = false
            M = SUNBandMatrix(length(uvec), alg.jac_upper, alg.jac_lower, ctx)
            _M = MatrixHandle(M, BandMatrix())
            if MassLinearSolver === :Band
                MLS = SUNLinSol_Band(utmp, M, ctx)
                _MLS = LinSolHandle(MLS, Band())
            else
                MLS = SUNLinSol_LapackBand(utmp, M, ctx)
                _MLS = LinSolHandle(MLS, LapackBand())
            end
        elseif MassLinearSolver == :GMRES
            MLS = SUNLinSol_SPGMR(utmp, Cint(alg.prec_side), Cint(alg.mass_krylov_dim), ctx)
            _M = nothing
            _MLS = LinSolHandle(MLS, SPGMR())
        elseif MassLinearSolver == :FGMRES
            MLS = SUNLinSol_SPGMR(utmp, Cint(alg.prec_side), Cint(alg.mass_krylov_dim), ctx)
            _M = nothing
            _MLS = LinSolHandle(MLS, SPFGMR())
        elseif MassLinearSolver == :BCG
            MLS = SUNLinSol_SPGMR(utmp, Cint(alg.prec_side), Cint(alg.mass_krylov_dim), ctx)
            _M = nothing
            _MLS = LinSolHandle(MLS, SPBCGS())
        elseif MassLinearSolver == :PCG
            MLS = SUNLinSol_SPGMR(utmp, Cint(alg.prec_side), Cint(alg.mass_krylov_dim), ctx)
            _M = nothing
            _MLS = LinSolHandle(MLS, PCG())
        elseif MassLinearSolver == :TFQMR
            MLS = SUNLinSol_SPGMR(utmp, Cint(alg.prec_side), Cint(alg.mass_krylov_dim), ctx)
            _M = nothing
            _MLS = LinSolHandle(MLS, PTFQMR())
        elseif MassLinearSolver == :KLU
            nnz = length(SparseArrays.nonzeros(prob.f.mass_matrix))
            M = SUNSparseMatrix(length(uvec), length(uvec), nnz, CSC_MAT, ctx)
            MLS = SUNLinSol_KLU(utmp, M, ctx)
            _M = MatrixHandle(M, SparseMatrix())
            _MLS = LinSolHandle(MLS, KLU())
        end
        flag = ARKStepSetMassLinearSolver(mem, MLS, _M === nothing ? C_NULL : M, false)
        function getmatfun(::T) where {T}
            return @cfunction(
                massmat,
                Cint,
                (realtype, SUNMatrix, Ref{T}, N_Vector, N_Vector, N_Vector)
            )
        end
        matfun = getmatfun(userfun)
        ARKStepSetMassFn(mem, matfun)
    else
        _M = nothing
        _MLS = nothing
    end

    if SciMLBase.has_jac(prob.f) && alg.stiffness !== Explicit()
        function getfunjac(::T) where {T}
            return @cfunction(
                cvodejac,
                Cint,
                (
                    realtype,
                    N_Vector,
                    N_Vector,
                    SUNMatrix,
                    Ref{T},
                    N_Vector,
                    N_Vector,
                    N_Vector,
                )
            )
        end
        jac = getfunjac(userfun)
        flag = ARKStepSetUserData(mem, userfun)
        flag = ARKStepSetJacFn(mem, jac)
    else
        jac = nothing
    end

    if alg.prec !== nothing && alg.stiffness !== Explicit()
        function getpercfun(::T) where {T}
            return @cfunction(
                precsolve,
                Cint,
                (
                    Float64,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    Float64,
                    Float64,
                    Int,
                    Ref{T},
                )
            )
        end
        precfun = getpercfun(userfun)

        function getpsetupfun(::T) where {T}
            return @cfunction(
                precsetup,
                Cint,
                (Float64, N_Vector, N_Vector, Int, Ptr{Int}, Float64, Ref{T})
            )
        end
        psetupfun = alg.psetup === nothing ? C_NULL : getpsetupfun(userfun)

        ARKStepSetPreconditioner(mem, psetupfun, precfun)
    end

    tmp = isnothing(callbacks_internal) ? u0 : similar(u0)
    uprev = isnothing(callbacks_internal) ? u0 : similar(u0)
    tout = [tspan[1]]

    if save_start
        if save_idxs === nothing
            ures = Vector{uType}()
            dures = Vector{uType}()
            save_value!(ures, u0, uType, save_idxs)
            if dense
                f!(out, u0, prob.p, tspan[1])
                save_value!(dures, out, uType, save_idxs)
            end
        else
            ures = [u0[save_idxs]]
            if dense
                f!(out, u0, prob.p, tspan[1])
                dures = [out[save_idxs]]
            end
        end
    else
        ures = Vector{uType}()
        dures = Vector{uType}()
    end

    sol = SciMLBase.build_solution(
        prob,
        alg,
        ts,
        ures;
        dense = dense,
        interp = dense ?
            SciMLBase.HermiteInterpolation(
                ts, ures,
                dures
            ) :
            SciMLBase.LinearInterpolation(ts, ures),
        timeseries_errors = timeseries_errors,
        stats = SciMLBase.DEStats(0),
        calculate_error = false
    )
    opts = DEOptions(
        saveat_internal,
        tstops_internal,
        saveat, tstops, save_start,
        save_everystep, save_idxs,
        dense,
        timeseries_errors,
        dense_errors,
        save_on,
        save_end,
        callbacks_internal,
        abstol,
        reltol,
        verbose,
        advance_to_tstop,
        stop_at_next_tstop,
        progress,
        progress_steps,
        progress_name,
        progress_message,
        progress_id,
        maxiters
    )
    integrator = ARKODEIntegrator(
        u0,
        utmp,
        prob.p,
        t0,
        t0,
        mem,
        _LS,
        _A,
        _MLS,
        _M,
        sol,
        alg,
        f!,
        userfun,
        jac,
        opts,
        tout,
        tdir,
        false,
        tmp,
        uprev,
        Cint(flag),
        false,
        0,
        1,
        callback_cache,
        0.0,
        initializealg,
        cfj1, cfj2,
        ctx_handle
    )
    SciMLBase.initialize_dae!(integrator, initializealg)
    integrator.u_modified &&  ARKStepReInit(
        integrator.mem, integrator.cfj2, integrator.cfj1,
        integrator.t, integrator.u_nvec
    )

    initialize_callbacks!(integrator)
    return integrator
end # function solve

function tstop_saveat_disc_handling(tstops, saveat, tdir, tspan, tType)
    tstops_internal = DataStructures.BinaryHeap{tType}(DataStructures.FasterForward())
    saveat_internal = DataStructures.BinaryHeap{tType}(DataStructures.FasterForward())

    t0, tf = tspan
    tdir_t0 = tdir * t0
    tdir_tf = tdir * tf

    for t in tstops
        tdir_t = tdir * t
        tdir_t0 < tdir_t ≤ tdir_tf && push!(tstops_internal, tdir_t)
    end
    push!(tstops_internal, tdir_tf)

    if saveat isa Number
        saveat = (t0:(tdir * abs(saveat)):tf)[2:end]
    end
    for t in saveat
        tdir_t = tdir * t
        tdir_t0 < tdir_t ≤ tdir_tf && push!(saveat_internal, tdir_t)
    end

    return tstops_internal, saveat_internal
end

## Solve for DAEs uses IDA

function DiffEqBase.__init(
        prob::SciMLBase.AbstractDAEProblem{
            uType, duType, tupType,
            isinplace,
        },
        alg::SundialsDAEAlgorithm{LinearSolver},
        timeseries = [],
        ts = [],
        ks = [];
        verbose = Standard(),
        dt = nothing,
        dtmax = 0.0,
        save_on = true,
        save_start = true,
        callback = nothing,
        abstol = 1 / 10^6,
        reltol = 1 / 10^3,
        saveat = Float64[],
        tstops = Float64[],
        d_discontinuities = Float64[],
        maxiters = Int(1.0e5),
        timeseries_errors = true,
        dense_errors = false,
        save_everystep = isempty(saveat), save_idxs = nothing,
        dense = save_everystep,
        save_timeseries = nothing,
        save_end = true,
        progress = false,
        progress_steps = 1000,
        progress_name = "DAE IDA",
        progress_message = DiffEqBase.ODE_DEFAULT_PROG_MESSAGE,
        progress_id = :Sundials,
        advance_to_tstop = false,
        stop_at_next_tstop = false,
        userdata = nothing,
        initializealg = DefaultInit(),
        kwargs...
    ) where {
        uType, duType, tupType, isinplace, LinearSolver,
    }
    tType = eltype(tupType)
    verbose = _process_verbose_param(verbose)

    if !isempty(kwargs)
        warned = DiffEqBase.check_keywords(alg, kwargs, warnida)
        if warned
            @SciMLMessage(
                "Unrecognized keyword arguments passed to Sundials solver.",
                verbose, :inconsistent_input
            )
        end
    end

    if reltol isa AbstractArray
        error("Sundials only allows scalar reltol.")
    end

    if length(prob.u0) == 0
        error("Sundials requires at least one state variable.")
    end

    progress &&
        Logging.@logmsg(Logging.LogLevel(-1), progress_name, _id = progress_id, progress = 0)

    tstops = vcat(tstops, d_discontinuities)
    callbacks_internal = DiffEqBase.CallbackSet(callback)

    max_len_cb = DiffEqBase.max_vector_callback_length(callbacks_internal)
    if max_len_cb isa VectorContinuousCallback
        callback_cache = DiffEqBase.CallbackCache(max_len_cb.len, Float64, Float64)
    else
        callback_cache = nothing
    end

    tspan = prob.tspan
    t0 = tspan[1]

    tdir = sign(tspan[2] - tspan[1])

    tstops_internal,
        saveat_internal = tstop_saveat_disc_handling(
        tstops, saveat, tdir,
        tspan, tType
    )
    @assert size(prob.u0) == size(prob.du0)
    if prob.u0 isa Number
        u0 = [prob.u0]
        du0 = [prob.du0]
    else
        u0 = copy(prob.u0)
        du0 = copy(prob.du0)
    end

    ### Fix the more general function to Sundials allowed style
    if !isinplace && prob.u0 isa Number
        f! = (out, du, u, p, t) -> (out .= prob.f(first(du), first(u), p, t); Cint(0))
    elseif !isinplace
        f! = (out, du, u, p, t) -> (out .= prob.f(du, u, p, t); Cint(0))
    else # Then it's an in-place function on an abstract array
        f! = prob.f
    end

    ctx_handle = ContextHandle()
    ctx = ctx_handle.ctx
    mem_ptr = IDACreate(ctx)
    (mem_ptr == C_NULL) && error("Failed to allocate IDA solver object")
    mem = Handle(mem_ptr)

    ts = [t0]

    # vec shares memory
    utmp = NVector(vec(u0), ctx)
    dutmp = NVector(vec(du0), ctx)
    rtest = zeros(size(u0))

    use_jac_prototype = (
        isa(prob.f.jac_prototype, SparseArrays.SparseMatrixCSC) &&
            LinearSolver ∈ SPARSE_SOLVERS
    )
    userfun = FunJac(
        f!,
        prob.f.jac,
        prob.p,
        nothing,
        use_jac_prototype ? prob.f.jac_prototype : nothing,
        alg.prec,
        alg.psetup,
        u0,
        du0,
        rtest
    )

    function getcfun(::T) where {T}
        return @cfunction(idasolfun, Cint, (realtype, N_Vector, N_Vector, N_Vector, Ref{T}))
    end
    cfun = getcfun(userfun)
    flag = IDAInit(mem, cfun, t0, utmp, dutmp)
    dt !== nothing && (flag = IDASetInitStep(mem, dt))
    flag = IDASetUserData(mem, userfun)
    flag = IDASetMaxStep(mem, dtmax)
    if abstol isa Array
        abstol_nvec = NVector(abstol, ctx)
        flag = IDASVtolerances(mem, reltol, abstol_nvec)
    else
        flag = IDASStolerances(mem, reltol, abstol)
    end
    flag = IDASetMaxNumSteps(mem, maxiters)
    flag = IDASetMaxOrd(mem, alg.max_order)
    flag = IDASetMaxErrTestFails(mem, alg.max_error_test_failures)
    flag = IDASetNonlinConvCoef(mem, alg.nonlinear_convergence_coefficient)
    flag = IDASetMaxNonlinIters(mem, alg.max_nonlinear_iters)
    flag = IDASetMaxConvFails(mem, alg.max_convergence_failures)
    flag = IDASetNonlinConvCoefIC(mem, alg.nonlinear_convergence_coefficient_ic)
    flag = IDASetMaxNumStepsIC(mem, alg.max_num_steps_ic)
    flag = IDASetMaxNumJacsIC(mem, alg.max_num_jacs_ic)
    flag = IDASetMaxNumItersIC(mem, alg.max_num_iters_ic)
    #flag = IDASetMaxBacksIC(mem,alg.max_num_backs_ic) # Needs newer version?
    flag = IDASetLineSearchOffIC(mem, alg.use_linesearch_ic)

    prec_side = isnothing(alg.prec) ? 0 : 1  # IDA only supports left preconditioning (prec_side = 1)
    if LinearSolver in (:Dense, :LapackDense)
        nojacobian = false
        A = SUNDenseMatrix(length(u0), length(u0), ctx)
        _A = MatrixHandle(A, DenseMatrix())
        if LinearSolver === :Dense
            LS = SUNLinSol_Dense(utmp, A, ctx)
            _LS = LinSolHandle(LS, Dense())
        else
            LS = SUNLinSol_LapackDense(utmp, A, ctx)
            _LS = LinSolHandle(LS, LapackDense())
        end
    elseif LinearSolver in (:Band, :LapackBand)
        nojacobian = false
        A = SUNBandMatrix(length(u0), alg.jac_upper, alg.jac_lower, ctx)
        _A = MatrixHandle(A, BandMatrix())
        if LinearSolver === :Band
            LS = SUNLinSol_Band(utmp, A, ctx)
            _LS = LinSolHandle(LS, Band())
        else
            LS = SUNLinSol_LapackBand(utmp, A, ctx)
            _LS = LinSolHandle(LS, LapackBand())
        end
    elseif LinearSolver == :GMRES
        LS = SUNLinSol_SPGMR(utmp, Cint(prec_side), Cint(alg.krylov_dim), ctx)
        _A = nothing
        _LS = LinSolHandle(LS, SPGMR())
    elseif LinearSolver == :FGMRES
        LS = SUNLinSol_SPFGMR(utmp, Cint(prec_side), Cint(alg.krylov_dim), ctx)
        _A = nothing
        _LS = LinSolHandle(LS, SPFGMR())
    elseif LinearSolver == :BCG
        LS = SUNLinSol_SPBCGS(utmp, Cint(prec_side), Cint(alg.krylov_dim), ctx)
        _A = nothing
        _LS = LinSolHandle(LS, SPBCGS())
    elseif LinearSolver == :PCG
        LS = SUNLinSol_PCG(utmp, Cint(prec_side), Cint(alg.krylov_dim), ctx)
        _A = nothing
        _LS = LinSolHandle(LS, PCG())
    elseif LinearSolver == :TFQMR
        LS = SUNLinSol_SPTFQMR(utmp, Cint(prec_side), Cint(alg.krylov_dim), ctx)
        _A = nothing
        _LS = LinSolHandle(LS, PTFQMR())
    elseif LinearSolver == :KLU
        nnz = length(SparseArrays.nonzeros(prob.f.jac_prototype))
        A = SUNSparseMatrix(length(u0), length(u0), nnz, Sundials.CSC_MAT, ctx)
        LS = SUNLinSol_KLU(utmp, A, ctx)
        _A = MatrixHandle(A, SparseMatrix())
        _LS = LinSolHandle(LS, KLU())
    end
    flag = IDASetLinearSolver(mem, LS, _A === nothing ? C_NULL : A)

    if prob.f.jac_prototype isa AbstractSciMLOperator
        function getcfunjtimes(::T) where {T}
            return @cfunction(
                idajactimes,
                Cint,
                (
                    realtype,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    realtype,
                    Ref{T},
                    N_Vector,
                    N_Vector,
                )
            )
        end
        jtimes = getcfunjtimes(userfun)
        IDASetJacTimes(mem, C_NULL, jtimes)
    end

    if alg.prec !== nothing
        function getprecfun(::T) where {T}
            return @cfunction(
                idaprecsolve,
                Cint,
                (
                    Float64,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    Float64,
                    Float64,
                    Ref{T},
                )
            )
        end
        precfun = getprecfun(userfun)

        function getpsetupfun(::T) where {T}
            return @cfunction(
                idaprecsetup,
                Cint,
                (Float64, N_Vector, N_Vector, N_Vector, Float64, Ref{T})
            )
        end
        psetupfun = alg.psetup === nothing ? C_NULL : getpsetupfun(userfun)

        IDASetPreconditioner(mem, psetupfun, precfun)
    end

    if SciMLBase.has_jac(prob.f)
        function getcfunjacc(::T) where {T}
            return @cfunction(
                idajac,
                Cint,
                (
                    realtype,
                    realtype,
                    N_Vector,
                    N_Vector,
                    N_Vector,
                    SUNMatrix,
                    Ref{T},
                    N_Vector,
                    N_Vector,
                    N_Vector,
                )
            )
        end
        jac = getcfunjacc(userfun)
        flag = IDASetUserData(mem, userfun)
        flag = IDASetJacFn(mem, jac)
    else
        jac = nothing
    end

    tout = Float64[first(tspan)]
    if save_idxs isa Integer
        ures = Vector{eltype(uType)}()
        dures = Vector{eltype(uType)}()
    else
        ures = Vector{uType}()
        dures = Vector{uType}()
    end
    tmp = isnothing(callbacks_internal) ? u0 : similar(u0)
    uprev = isnothing(callbacks_internal) ? u0 : similar(u0)
    retcode = flag >= 0 ? ReturnCode.Default : ReturnCode.InitialFailure
    sol = SciMLBase.build_solution(
        prob,
        alg,
        ts,
        ures, dense ? dures : nothing;
        dense = dense,
        calculate_error = false,
        timeseries_errors = timeseries_errors,
        retcode = retcode,
        stats = SciMLBase.DEStats(0),
        dense_errors = dense_errors
    )

    opts = DEOptions(
        saveat_internal,
        tstops_internal,
        saveat, tstops, save_start,
        save_everystep, save_idxs,
        dense,
        timeseries_errors,
        dense_errors,
        save_on,
        save_end,
        callbacks_internal,
        abstol,
        reltol,
        verbose,
        advance_to_tstop,
        stop_at_next_tstop,
        progress,
        progress_steps,
        progress_name,
        progress_message,
        progress_id,
        maxiters
    )

    # Preallocate NVector for differential_vars if provided
    diff_vars_nvec = if prob.differential_vars !== nothing
        NVector(vec(Float64.(prob.differential_vars)), ctx)
    else
        nothing
    end

    integrator = IDAIntegrator(
        u0,
        du0,
        prob.p,
        t0,
        t0,
        mem,
        _LS,
        _A,
        sol,
        alg,
        f!,
        userfun,
        jac,
        opts,
        tout,
        tdir,
        false,
        tmp,
        uprev,
        Cint(flag),
        0,
        false,
        0,
        1,
        callback_cache,
        0.0,
        utmp,
        dutmp,
        diff_vars_nvec,
        initializealg,
        ctx_handle
    )

    # Context will be freed when integrator is garbage collected
    # through the Handle mechanism

    SciMLBase.initialize_dae!(integrator, initializealg)
    integrator.u_modified && IDAReinit!(integrator)

    if save_start
        save_value!(ures, integrator.u, uType, save_idxs)
        save_value!(dures, integrator.du, duType, save_idxs)
    end

    initialize_callbacks!(integrator)
    return integrator
end # function solve

## Common calls

function interpret_sundials_retcode(flag)
    flag >= 0 && return ReturnCode.Success
    flag == -1 && return ReturnCode.MaxIters
    (flag == -2 || flag == -3) && return ReturnCode.Unstable
    flag == -4 && return ReturnCode.ConvergenceFailure
    return ReturnCode.Failure
end

function solver_step(integrator::CVODEIntegrator, tstop)
    integrator.flag = CVode(
        integrator.mem, tstop, integrator.u_nvec, integrator.tout,
        CV_ONE_STEP
    )
    return if integrator.opts.progress
        Logging.@logmsg(
            Logging.LogLevel(-1),
            integrator.opts.progress_name,
            _id = integrator.opts.progress_id,
            message = integrator.opts.progress_message(
                integrator.dt,
                integrator.u,
                integrator.p,
                integrator.t
            ),
            progress = integrator.t / integrator.sol.prob.tspan[2]
        )
    end
end
# Dispatch for ARKStep (implicit methods)
function solver_step(
        integrator::ARKODEIntegrator{
            N, pType, solType, algType, fType, UFType, JType, oType,
            LStype, Atype, MLStype, Mtype, CallbackCacheType, ARKStepMem,
        },
        tstop
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    integrator.flag = ARKStepEvolve(
        integrator.mem, tstop, integrator.u_nvec,
        integrator.tout, ARK_ONE_STEP
    )
    return if integrator.opts.progress
        Logging.@logmsg(
            Logging.LogLevel(-1),
            integrator.opts.progress_name,
            _id = integrator.opts.progress_id,
            message = integrator.opts.progress_message(
                integrator.dt,
                integrator.u_nvec,
                integrator.p,
                integrator.t
            ),
            progress = integrator.t / integrator.sol.prob.tspan[2]
        )
    end
end

# Dispatch for ERKStep (explicit methods)
function solver_step(
        integrator::ARKODEIntegrator{
            N, pType, solType, algType, fType, UFType, JType, oType,
            LStype, Atype, MLStype, Mtype, CallbackCacheType, ERKStepMem,
        },
        tstop
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    integrator.flag = ERKStepEvolve(
        integrator.mem, tstop, integrator.u_nvec,
        integrator.tout, ARK_ONE_STEP
    )
    return if integrator.opts.progress
        Logging.@logmsg(
            Logging.LogLevel(-1),
            integrator.opts.progress_name,
            _id = integrator.opts.progress_id,
            message = integrator.opts.progress_message(
                integrator.dt,
                integrator.u_nvec,
                integrator.p,
                integrator.t
            ),
            progress = integrator.t / integrator.sol.prob.tspan[2]
        )
    end
end
function solver_step(integrator::IDAIntegrator, tstop)
    integrator.flag = IDASolve(
        integrator.mem,
        tstop,
        integrator.tout,
        integrator.u_nvec,
        integrator.du_nvec,
        IDA_ONE_STEP
    )
    integrator.iter += 1
    return if integrator.opts.progress && integrator.iter % integrator.opts.progress_steps == 0
        Logging.@logmsg(
            Logging.LogLevel(-1),
            integrator.opts.progress_name,
            _id = integrator.opts.progress_id,
            message = integrator.opts.progress_message(
                integrator.dt,
                integrator.u,
                integrator.p,
                integrator.t
            ),
            progress = integrator.t / integrator.sol.prob.tspan[2]
        )
    end
end

function set_stop_time(integrator::CVODEIntegrator, tstop)
    return CVodeSetStopTime(integrator.mem, tstop)
end
# Dispatch for ARKStep (implicit methods)
function set_stop_time(
        integrator::ARKODEIntegrator{
            N, pType, solType, algType, fType, UFType, JType, oType,
            LStype, Atype, MLStype, Mtype, CallbackCacheType, ARKStepMem,
        },
        tstop
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    return ARKStepSetStopTime(integrator.mem, tstop)
end

# Dispatch for ERKStep (explicit methods)
function set_stop_time(
        integrator::ARKODEIntegrator{
            N, pType, solType, algType, fType, UFType, JType, oType,
            LStype, Atype, MLStype, Mtype, CallbackCacheType, ERKStepMem,
        },
        tstop
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    return ERKStepSetStopTime(integrator.mem, tstop)
end
function set_stop_time(integrator::IDAIntegrator, tstop)
    return IDASetStopTime(integrator.mem, tstop)
end

function get_iters!(integrator::CVODEIntegrator, iters)
    return CVodeGetNumSteps(integrator.mem, iters)
end
# Dispatch for ARKStep (implicit methods)
function get_iters!(
        integrator::ARKODEIntegrator{
            N, pType, solType, algType, fType, UFType, JType, oType,
            LStype, Atype, MLStype, Mtype, CallbackCacheType, ARKStepMem,
        },
        iters
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    return ARKStepGetNumSteps(integrator.mem, iters)
end

# Dispatch for ERKStep (explicit methods)
function get_iters!(
        integrator::ARKODEIntegrator{
            N, pType, solType, algType, fType, UFType, JType, oType,
            LStype, Atype, MLStype, Mtype, CallbackCacheType, ERKStepMem,
        },
        iters
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    return ERKStepGetNumSteps(integrator.mem, iters)
end
function get_iters!(integrator::IDAIntegrator, iters)
    return IDAGetNumSteps(integrator.mem, iters)
end

function DiffEqBase.solve!(
        integrator::AbstractSundialsIntegrator; early_free = false,
        calculate_error = false
    )
    uType = eltype(integrator.sol.u)
    iters = Ref(Clong(-1))
    while !isempty(integrator.opts.tstops)
        # The call to first is an overload of Base.first implemented in DataStructures
        while integrator.tdir * integrator.t < first(integrator.opts.tstops)
            tstop = integrator.tdir * first(integrator.opts.tstops)
            set_stop_time(integrator, tstop)
            integrator.tprev = integrator.t
            if !(integrator.opts.callback.continuous_callbacks isa Tuple{})
                integrator.uprev .= integrator.u
            end
            integrator.userfun.p = integrator.p
            solver_step(integrator, tstop)
            integrator.t = first(integrator.tout)
            # NB: CVode, ARKode may warn and then recover if integrator.t == integrator.tprev so don't flag this as an error
            integrator.flag < 0 && break
            handle_callbacks!(integrator) # this also updates the interpolation
            integrator.flag < 0 && break
            if isempty(integrator.opts.tstops)
                break
            end
            get_iters!(integrator, iters)
            if iters[] + 1 > integrator.opts.maxiters
                integrator.flag = -1 # MaxIters: -1
                break
            end
        end
        integrator.flag < 0 && break
        handle_tstop!(integrator)
    end

    DiffEqBase.finalize!(integrator.opts.callback, integrator.u, integrator.t, integrator)
    tend = integrator.t
    if integrator.opts.save_end &&
            (isempty(integrator.sol.t) || integrator.sol.t[end] != tend)
        save_value!(
            integrator.sol.u, integrator.u, uType,
            integrator.opts.save_idxs
        )
        push!(integrator.sol.t, tend)
        if integrator.opts.dense
            save_value!(
                integrator.sol.interp.du, get_du(integrator), uType,
                integrator.opts.save_idxs
            )
        end
    end

    if integrator.opts.progress
        Logging.@logmsg(
            Logging.LogLevel(-1),
            integrator.opts.progress_name,
            _id = integrator.opts.progress_id,
            message = integrator.opts.progress_message(
                integrator.dt,
                integrator.u,
                integrator.p,
                integrator.t
            ),
            progress = "done"
        )
    end

    fill_stats!(integrator)

    if early_free
        empty!(integrator.mem)
        integrator.A !== nothing && empty!(integrator.A)
        integrator.LS !== nothing && empty!(integrator.LS)
    end

    if SciMLBase.has_analytic(integrator.sol.prob.f) && calculate_error
        SciMLBase.calculate_solution_errors!(
            integrator.sol;
            timeseries_errors = integrator.opts.timeseries_errors,
            dense_errors = integrator.opts.dense_errors
        )
    end

    if integrator.sol.retcode == ReturnCode.Default
        integrator.sol = DiffEqBase.solution_new_retcode(
            integrator.sol,
            interpret_sundials_retcode(integrator.flag)
        )
    end

    return integrator.sol
end

function handle_tstop!(integrator::AbstractSundialsIntegrator)
    tstops = integrator.opts.tstops
    return if !isempty(tstops) && integrator.tdir * integrator.t >= first(tstops)
        pop!(tstops)
        # If we passed multiple tstops at once (possible if Sundials ignores us or we had redundant tstops)
        while !isempty(tstops) && integrator.tdir * integrator.t >= first(tstops)
            pop!(tstops)
        end
        integrator.just_hit_tstop = true
    end
end

function fill_stats!(integrator::AbstractSundialsIntegrator) end

function fill_stats!(integrator::CVODEIntegrator)
    stats = integrator.sol.stats
    mem = integrator.mem
    tmp = Ref(Clong(-1))
    CVodeGetNumRhsEvals(mem, tmp)
    stats.nf = tmp[]
    CVodeGetNumLinSolvSetups(mem, tmp)
    stats.nw = tmp[]
    CVodeGetNumErrTestFails(mem, tmp)
    stats.nreject = tmp[]
    CVodeGetNumSteps(mem, tmp)
    stats.naccept = tmp[] - stats.nreject
    CVodeGetNumNonlinSolvIters(mem, tmp)
    stats.nnonliniter = tmp[]
    CVodeGetNumNonlinSolvConvFails(mem, tmp)
    stats.nnonlinconvfail = tmp[]
    return if method_choice(integrator.alg) == :Newton
        CVodeGetNumJacEvals(mem, tmp)
        stats.njacs = tmp[]
    end
end

# Dispatch for ARKStep (implicit methods)
function fill_stats!(
        integrator::ARKODEIntegrator{
            N,
            pType,
            solType,
            algType,
            fType,
            UFType,
            JType,
            oType,
            LStype,
            Atype,
            MLStype,
            Mtype,
            CallbackCacheType,
            ARKStepMem,
        }
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    stats = integrator.sol.stats
    mem = integrator.mem
    tmp = Ref(Clong(-1))
    tmp2 = Ref(Clong(-1))
    ARKStepGetNumRhsEvals(mem, tmp, tmp2)
    stats.nf = tmp[]
    stats.nf2 = tmp2[]
    integrator.alg.stiffness !== Explicit() && ARKStepGetNumLinSolvSetups(mem, tmp)
    stats.nw = tmp[]
    ARKStepGetNumErrTestFails(mem, tmp)
    stats.nreject = tmp[]
    ARKStepGetNumSteps(mem, tmp)
    stats.naccept = tmp[] - stats.nreject
    integrator.alg.stiffness !== Explicit() && ARKStepGetNumNonlinSolvIters(mem, tmp)
    stats.nnonliniter = tmp[]
    integrator.alg.stiffness !== Explicit() && ARKStepGetNumNonlinSolvConvFails(mem, tmp)
    stats.nnonlinconvfail = tmp[]
    return if integrator.alg.stiffness !== Explicit() && method_choice(integrator.alg) == :Newton
        ARKStepGetNumJacEvals(mem, tmp)
        stats.njacs = tmp[]
    end
end

# Dispatch for ERKStep (explicit methods)
function fill_stats!(
        integrator::ARKODEIntegrator{
            N,
            pType,
            solType,
            algType,
            fType,
            UFType,
            JType,
            oType,
            LStype,
            Atype,
            MLStype,
            Mtype,
            CallbackCacheType,
            ERKStepMem,
        }
    ) where {
        N, pType, solType, algType, fType, UFType, JType, oType,
        LStype, Atype, MLStype, Mtype, CallbackCacheType,
    }
    stats = integrator.sol.stats
    mem = integrator.mem
    tmp = Ref(Clong(-1))
    # ERKStepGetNumRhsEvals only takes one argument for explicit RHS evaluations
    ERKStepGetNumRhsEvals(mem, tmp)
    stats.nf = tmp[]
    stats.nf2 = 0  # No implicit RHS for explicit methods
    # No linear solver setups for explicit methods
    stats.nw = 0
    ERKStepGetNumErrTestFails(mem, tmp)
    stats.nreject = tmp[]
    ERKStepGetNumSteps(mem, tmp)
    stats.naccept = tmp[] - stats.nreject
    # No nonlinear solver iterations or convergence failures for explicit methods
    stats.nnonliniter = 0
    stats.nnonlinconvfail = 0
    # No Jacobian evaluations for explicit methods
    return stats.njacs = 0
end

function fill_stats!(integrator::IDAIntegrator)
    stats = integrator.sol.stats
    mem = integrator.mem
    tmp = Ref(Clong(-1))
    IDAGetNumResEvals(mem, tmp)
    stats.nf = tmp[]
    IDAGetNumLinSolvSetups(mem, tmp)
    stats.nw = tmp[]
    IDAGetNumErrTestFails(mem, tmp)
    stats.nreject = tmp[]
    IDAGetNumSteps(mem, tmp)
    stats.naccept = tmp[] - stats.nreject
    IDAGetNumNonlinSolvIters(mem, tmp)
    stats.nnonliniter = tmp[]
    IDAGetNumNonlinSolvConvFails(mem, tmp)
    stats.nnonlinconvfail = tmp[]
    return if method_choice(integrator.alg) == :Newton
        IDAGetNumJacEvals(mem, tmp)
        stats.njacs = tmp[]
    end
end

function initialize_callbacks!(integrator, initialize_save = true)
    t = integrator.t
    u = integrator.u
    callbacks = integrator.opts.callback
    integrator.u_modified = true

    u_modified = initialize!(callbacks, u, t, integrator)

    # if the user modifies u, we need to fix current values
    if u_modified
        handle_callback_modifiers!(integrator)

        if initialize_save &&
                (
                any((c) -> c.save_positions[2], callbacks.discrete_callbacks) ||
                    any((c) -> c.save_positions[2], callbacks.continuous_callbacks)
            )
            savevalues!(integrator, true)
        end
    end

    # reset this as it is now handled so the integrators should proceed as normal
    return integrator.u_modified = false
end

using Sundials, Test

function _strip_comment(line)
    io = IOBuffer()
    in_string = false
    quotechar = '\0'
    escaped = false

    for char in line
        if escaped
            print(io, char)
            escaped = false
        elseif char == '\\'
            print(io, char)
            escaped = true
        elseif in_string
            print(io, char)
            char == quotechar && (in_string = false)
        elseif char == '"' || char == '\''
            print(io, char)
            in_string = true
            quotechar = char
        elseif char == '#'
            break
        else
            print(io, char)
        end
    end

    return String(take!(io))
end

function _public_names_from_statement(statement)
    normalized = replace(statement, r"^\s*(export|public|@public|SciMLPublic\.@public)\s+" => "")
    normalized = replace(normalized, r"\b(export|public)\b" => "")
    normalized = replace(normalized, "SciMLPublic.@public" => "")
    normalized = replace(normalized, "@public" => "")
    normalized = replace(normalized, r"Expr\s*\(\s*:public\s*,?" => "")
    normalized = replace(normalized, r"eval\s*\(" => "")
    normalized = replace(normalized, r"Symbol\s*\(\s*\"(@?[A-Za-z_][A-Za-z0-9_!]*)\"\s*\)" => s"\1")
    normalized = replace(normalized, ')' => " ")
    normalized = replace(normalized, ':' => "")

    public_names = Symbol[]
    for token in split(normalized, [',', ' ', '\t', '\n'])
        name = strip(token)
        isempty(name) && continue
        occursin(r"^@?[A-Za-z_][A-Za-z0-9_!]*$", name) || continue
        name in ("return", "symbols", "symbols_expr") && continue
        push!(public_names, Symbol(name))
    end

    return public_names
end

function _source_public_names()
    public_names = Symbol[]

    for src_dir in ("src", "lib")
        src_root = normpath(joinpath(@__DIR__, "..", "..", src_dir))
        isdir(src_root) || continue

        for (root, _, files) in walkdir(src_root)
            for file in files
                endswith(file, ".jl") || continue
                path = joinpath(root, file)
                lines = readlines(path)
                in_docstring = false
                line_index = 1

                while line_index <= length(lines)
                    line = lines[line_index]
                    if occursin("\"\"\"", line)
                        in_docstring = !in_docstring
                        count("\"\"\"", line) >= 2 && (in_docstring = !in_docstring)
                    end

                    raw = in_docstring ? "" : _strip_comment(line)
                    stripped = strip(raw)
                    if startswith(stripped, "export ") ||
                            startswith(stripped, "public ") ||
                            startswith(stripped, "@public ") ||
                            startswith(stripped, "SciMLPublic.@public ") ||
                            occursin("Expr(:public", stripped) ||
                            occursin("Expr(:(public)", stripped)
                        statement = raw
                        parens = count(==('('), statement) - count(==(')'), statement)
                        while (endswith(rstrip(statement), ",") || parens > 0) &&
                                line_index < length(lines)
                            line_index += 1
                            statement *= " " * _strip_comment(lines[line_index])
                            parens = count(==('('), statement) - count(==(')'), statement)
                        end
                        append!(public_names, _public_names_from_statement(statement))
                    end

                    line_index += 1
                end
            end
        end
    end

    return sort!(unique(public_names))
end

function _rendered_docs_entries()
    docs_root = normpath(joinpath(@__DIR__, "..", "..", "docs", "src"))
    entries = Set{Symbol}()

    for (root, _, files) in walkdir(docs_root)
        for file in files
            endswith(file, ".md") || continue
            in_docs_block = false
            for line in eachline(joinpath(root, file))
                stripped = strip(line)
                if stripped == "```@docs"
                    in_docs_block = true
                    continue
                elseif startswith(stripped, "```")
                    in_docs_block = false
                    continue
                end

                in_docs_block || continue
                isempty(stripped) && continue
                startswith(stripped, "#") && continue
                identifier = replace(stripped, r"\(.*" => "")
                identifier = split(identifier, ".")[end]
                isempty(identifier) || push!(entries, Symbol(identifier))
            end
        end
    end

    return entries
end

function _binding_owner(mod::Module, name::Symbol)
    return parentmodule(getfield(mod, name))
end

function _has_docstring(mod::Module, name::Symbol)
    return haskey(Docs.meta(mod), Docs.Binding(mod, name))
end

@testset "Sundials public API documentation coverage" begin
    source_public_names = _source_public_names()
    source_owned_public_names = filter(
        name -> _binding_owner(Sundials, name) === Sundials,
        source_public_names
    )
    owned_exports = filter(sort!(collect(names(Sundials; all = false)))) do name
        name !== :Sundials &&
            isdefined(Sundials, name) &&
            _binding_owner(Sundials, name) === Sundials
    end

    @test source_owned_public_names == owned_exports

    undocumented = filter(source_public_names) do name
        !_has_docstring(_binding_owner(Sundials, name), name)
    end
    @test isempty(undocumented)

    rendered_entries = _rendered_docs_entries()
    missing_rendered = filter(name -> name ∉ rendered_entries, source_public_names)
    @test isempty(missing_rendered)
end

function null_error_handler(error_code::Cint, mod::Char, func::Char, eh_data::Ptr{Cvoid})
    return nothing
end

# Normalize the verbose parameter to DEVerbosity
_process_verbose_param(v::SciMLLogging.AbstractVerbosityPreset) = DEVerbosity(v)
_process_verbose_param(v::Bool) = v ? DEVerbosity() : DEVerbosity(SciMLLogging.None())
_process_verbose_param(v::DEVerbosity) = v

# Sundials.jl algorithms

# Abstract Types
"""
    SundialsODEAlgorithm{Method, LinearSolver}

Abstract supertype for Sundials-backed ODE algorithm values.

# Arguments
- `Method`: Sundials nonlinear iteration choice encoded in the algorithm type, such as
  `:Newton` or `:Functional`.
- `LinearSolver`: Sundials linear solver choice encoded in the algorithm type, such as
  `:Dense`, `:Band`, `:GMRES`, or `:KLU`.

# Returns
Concrete subtypes, such as [`CVODE_BDF`](@ref), [`CVODE_Adams`](@ref), and
[`ARKODE`](@ref), are algorithm objects passed to `solve`.

# Interface Notes
This type is part of the SciML common solve interface. Downstream extensions should dispatch
on concrete algorithm types when they need solver-specific options, and on
`SundialsODEAlgorithm` only for behavior shared by all Sundials ODE algorithms.
"""
abstract type SundialsODEAlgorithm{Method, LinearSolver} <: SciMLBase.AbstractODEAlgorithm end

"""
    SundialsDAEAlgorithm{LinearSolver}

Abstract supertype for Sundials-backed DAE algorithm values.

# Arguments
- `LinearSolver`: Sundials linear solver choice encoded in the algorithm type, such as
  `:Dense`, `:Band`, `:GMRES`, or `:KLU`.

# Returns
Concrete subtypes, such as [`IDA`](@ref), are algorithm objects passed to `solve`.

# Interface Notes
This type is part of the SciML common solve interface. Downstream extensions should dispatch
on concrete algorithm types when they need solver-specific options, and on
`SundialsDAEAlgorithm` only for behavior shared by all Sundials DAE algorithms.
"""
abstract type SundialsDAEAlgorithm{LinearSolver} <: SciMLBase.AbstractDAEAlgorithm end

abstract type SundialsNonlinearSolveAlgorithm{LinearSolver} <:
SciMLBase.AbstractNonlinearAlgorithm end

SciMLBase.alg_order(alg::Union{SundialsODEAlgorithm, SundialsDAEAlgorithm}) = alg.max_order

# ODE Algorithms
"""
```julia
CVODE_BDF(;method=:Newton,linear_solver=:Dense,
          jac_upper=0,jac_lower=0,
          stored_upper = jac_upper + jac_lower,
          non_zero=0,krylov_dim=0,
          stability_limit_detect=false,
          max_hnil_warns = 10,
          max_order = 5,
          max_error_test_failures = 7,
          max_nonlinear_iters = 3,
          max_convergence_failures = 10,
          prec = nothing, prec_side = 0)
```

CVODE_BDF: CVode Backward Differentiation Formula (BDF) solver.

### Method Choices

* method - This is the method for solving the implicit equation. For BDF this defaults to
    :Newton while for Adams this defaults to :Functional. These choices match the
    recommended pairing in the Sundials.jl manual. However, note that using the :Newton
    method may take less iterations but requires more memory than the :Function iteration
    approach.
* linear_solver - This is the linear solver which is used in the :Newton method.

### Linear Solver Choices

The choices for the linear solver are:

* :Dense - A dense linear solver.
* :Band - A solver specialized for banded Jacobians. If used, you must set the position of the upper and lower non-zero diagonals via jac_upper and jac_lower.
* :LapackDense - A version of the dense linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Dense on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* :LapackBand - A version of the banded linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Band on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* :Diagonal - This method is specialized for diagonal Jacobians.
* :GMRES - A GMRES method. Recommended first choice Krylov method
* :BCG - A Biconjugate gradient method.
* :PCG - A preconditioned conjugate gradient method. Only for symmetric linear systems.
* :TFQMR - A TFQMR method.
* :KLU - A sparse factorization method. Requires that the user specifies a Jacobian. The Jacobian must be set as a sparse matrix in the ODEProblem type.

Example:

```julia
CVODE_BDF() # BDF method using Newton + Dense solver
CVODE_BDF(method=:Functional) # BDF method using Functional iterations
CVODE_BDF(linear_solver=:Band,jac_upper=3,jac_lower=3) # Banded solver with nonzero diagonals 3 up and 3 down
CVODE_BDF(linear_solver=:BCG) # Biconjugate gradient method
```

### Preconditioners

Note that here `prec` is a preconditioner function
`prec(z,r,p,t,y,fy,gamma,delta,lr)` where:

- `z`: the computed output vector
- `r`: the right-hand side vector of the linear system
- `p`: the parameters
- `t`: the current independent variable
- `du`: the current value of `f(u,p,t)`
- `gamma`: the `gamma` of `W = M - gamma*J`
- `delta`: the iterative method tolerance
- `lr`: a flag for whether `lr=1` (left) or `lr=2` (right)
  preconditioning

and `psetup` is the preconditioner setup function for pre-computing Jacobian
information `psetup(p, t, u, du, jok, jcurPtr, gamma)`. Where:

- `p`: the parameters
- `t`: the current independent variable
- `u`: the current state
- `du`: the current `f(u,p,t)`
- `jok`: a bool indicating whether the Jacobian needs to be updated
- `jcurPtr`: a reference to an Int for whether the Jacobian was updated.
  `jcurPtr[]=true` should be set if the Jacobian was updated, and
  `jcurPtr[]=false` should be set if the Jacobian was not updated.
- `gamma`: the `gamma` of `W = M - gamma*J`

`psetup` is optional when `prec` is set.

### Additional Options

See [the CVODE manual](https://computing.llnl.gov/sites/default/files/cv_guide-5.7.0.pdf)
for details on the additional options.
"""
struct CVODE_BDF{Method, LinearSolver, P, PS} <: SundialsODEAlgorithm{Method, LinearSolver}
    jac_upper::Int
    jac_lower::Int
    krylov_dim::Int
    stability_limit_detect::Bool
    max_hnil_warns::Int
    max_order::Int
    max_error_test_failures::Int
    max_nonlinear_iters::Int
    max_convergence_failures::Int
    prec::P
    psetup::PS
    prec_side::Int
end
Base.@pure function CVODE_BDF(;
        method = :Newton,
        linear_solver = :Dense,
        jac_upper = 0,
        jac_lower = 0,
        non_zero = 0,
        krylov_dim = 0,
        stability_limit_detect = false,
        max_hnil_warns = 10,
        max_order = 5,
        max_error_test_failures = 7,
        max_nonlinear_iters = 3,
        max_convergence_failures = 10,
        prec = nothing,
        psetup = nothing,
        prec_side = 0
    )
    if linear_solver == :Band && (jac_upper == 0 || jac_lower == 0)
        error("Banded solver must set the jac_upper and jac_lower")
    end
    if !(
            linear_solver in (
                :None,
                :Diagonal,
                :Dense,
                :LapackDense,
                :Band,
                :LapackBand,
                :BCG,
                :GMRES,
                :FGMRES,
                :PCG,
                :TFQMR,
                :KLU,
            )
        )
        error("Linear solver choice not accepted.")
    end
    CVODE_BDF{method, linear_solver, typeof(prec), typeof(psetup)}(
        jac_upper,
        jac_lower,
        krylov_dim,
        stability_limit_detect,
        max_hnil_warns,
        max_order,
        max_error_test_failures,
        max_nonlinear_iters,
        max_convergence_failures,
        prec,
        psetup,
        prec_side
    )
end
"""
```julia
CVODE_Adams(;method=:Functional,linear_solver=:None,
            jac_upper=0,jac_lower=0,
            stored_upper = jac_upper + jac_lower,
            krylov_dim=0,
            stability_limit_detect=false,
            max_hnil_warns = 10,
            max_order = 12,
            max_error_test_failures = 7,
            max_nonlinear_iters = 3,
            max_convergence_failures = 10,
            prec = nothing, psetup = nothing, prec_side = 0)
```

CVODE_Adams: CVode Adams-Moulton solver.

### Method Choices

* method - This is the method for solving the implicit equation. For BDF this defaults to
    :Newton while for Adams this defaults to :Functional. These choices match the
    recommended pairing in the Sundials.jl manual. However, note that using the :Newton
    method may take less iterations but requires more memory than the :Function iteration
    approach.
* linear_solver - This is the linear solver which is used in the :Newton method.

### Linear Solver Choices

The choices for the linear solver are:

* :Dense - A dense linear solver.
* :Band - A solver specialized for banded Jacobians. If used, you must set the position of the upper and lower non-zero diagonals via jac_upper and jac_lower.
* :LapackDense - A version of the dense linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Dense on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* :LapackBand - A version of the banded linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Band on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* :Diagonal - This method is specialized for diagonal Jacobians.
* :GMRES - A GMRES method. Recommended first choice Krylov method
* :BCG - A Biconjugate gradient method.
* :PCG - A preconditioned conjugate gradient method. Only for symmetric linear systems.
* :TFQMR - A TFQMR method.
* :KLU - A sparse factorization method. Requires that the user specifies a Jacobian. The Jacobian must be set as a sparse matrix in the ODEProblem type.

Example:

```julia
CVODE_Adams() # Adams method using Newton + Dense solver
CVODE_Adams(method=:Functional) # Adams method using Functional iterations
CVODE_Adams(linear_solver=:Band,jac_upper=3,jac_lower=3) # Banded solver with nonzero diagonals 3 up and 3 down
CVODE_Adams(linear_solver=:BCG) # Biconjugate gradient method
```

### Preconditioners

Note that here `prec` is a preconditioner function
`prec(z,r,p,t,y,fy,gamma,delta,lr)` where:

- `z`: the computed output vector
- `r`: the right-hand side vector of the linear system
- `p`: the parameters
- `t`: the current independent variable
- `du`: the current value of `f(u,p,t)`
- `gamma`: the `gamma` of `W = M - gamma*J`
- `delta`: the iterative method tolerance
- `lr`: a flag for whether `lr=1` (left) or `lr=2` (right)
  preconditioning

and `psetup` is the preconditioner setup function for pre-computing Jacobian
information `psetup(p, t, u, du, jok, jcurPtr, gamma)`. Where:

- `p`: the parameters
- `t`: the current independent variable
- `u`: the current state
- `du`: the current `f(u,p,t)`
- `jok`: a bool indicating whether the Jacobian needs to be updated
- `jcurPtr`: a reference to an Int for whether the Jacobian was updated.
  `jcurPtr[]=true` should be set if the Jacobian was updated, and
  `jcurPtr[]=false` should be set if the Jacobian was not updated.
- `gamma`: the `gamma` of `W = M - gamma*J`

`psetup` is optional when `prec` is set.

### Additional Options

See [the CVODE manual](https://computing.llnl.gov/sites/default/files/cv_guide-5.7.0.pdf)
for details on the additional options.
"""
struct CVODE_Adams{Method, LinearSolver, P, PS} <:
    SundialsODEAlgorithm{Method, LinearSolver}
    jac_upper::Int
    jac_lower::Int
    krylov_dim::Int
    stability_limit_detect::Bool
    max_hnil_warns::Int
    max_order::Int
    max_error_test_failures::Int
    max_nonlinear_iters::Int
    max_convergence_failures::Int
    prec::P
    psetup::PS
    prec_side::Int
end
Base.@pure function CVODE_Adams(;
        method = :Functional,
        linear_solver = :None,
        jac_upper = 0,
        jac_lower = 0,
        krylov_dim = 0,
        stability_limit_detect = false,
        max_hnil_warns = 10,
        max_order = 12,
        max_error_test_failures = 7,
        max_nonlinear_iters = 3,
        max_convergence_failures = 10,
        prec = nothing,
        psetup = nothing,
        prec_side = 0
    )
    if linear_solver == :Band && (jac_upper == 0 || jac_lower == 0)
        error("Banded solver must set the jac_upper and jac_lower")
    end
    if !(
            linear_solver in (
                :None,
                :Diagonal,
                :Dense,
                :LapackDense,
                :Band,
                :LapackBand,
                :BCG,
                :GMRES,
                :FGMRES,
                :PCG,
                :TFQMR,
                :KLU,
            )
        )
        error("Linear solver choice not accepted.")
    end
    CVODE_Adams{method, linear_solver, typeof(prec), typeof(psetup)}(
        jac_upper,
        jac_lower,
        krylov_dim,
        stability_limit_detect,
        max_hnil_warns,
        max_order,
        max_error_test_failures,
        max_nonlinear_iters,
        max_convergence_failures,
        prec,
        psetup,
        prec_side
    )
end
"""
```julia
ARKODE(stiffness=Sundials.Implicit();
       method=:Newton,linear_solver=:Dense,
       jac_upper=0,jac_lower=0,stored_upper = jac_upper+jac_lower,
       non_zero=0,krylov_dim=0,
       max_hnil_warns = 10,
       max_error_test_failures = 7,
       max_nonlinear_iters = 3,
       max_convergence_failures = 10,
       predictor_method = 0,
       nonlinear_convergence_coefficient = 0.1,
       dense_order = 3,
       order = 4,
       set_optimal_params = false,
       crdown = 0.3,
       dgmax = 0.2,
       rdiv = 2.3,
       msbp = 20,
       adaptivity_method = 0,
       prec = nothing, psetup = nothing, prec_side = 0)
```

ARKODE: Explicit and ESDIRK Runge-Kutta methods of orders 2-8 depending on choice of options.

### Tableau Choices

The main options for ARKODE are the choice between explicit and implicit and the method
order, given via:

```julia
ARKODE(Sundials.Explicit()) # Solve with explicit tableau of default order 4
ARKODE(Sundials.Implicit(), order = 3) # Solve with explicit tableau of order 3
```

The order choices for explicit are 2 through 8 and for implicit 3 through 5. Specific
methods can also be set through the etable and itable options for explicit and implicit
tableaus respectively. The available tableaus are:

`etable`:

* `HEUN_EULER_2_1_2`: 2nd order Heun's method
* `BOGACKI_SHAMPINE_4_2_3`: third-order method of Bogacki and Shampine
* `ARK324L2SA_ERK_4_2_3`: explicit portion of Kennedy and Carpenter's 3rd order method
* `ZONNEVELD_5_3_4`: 4th order explicit method
* `ARK436L2SA_ERK_6_3_4`: explicit portion of Kennedy and Carpenter's 4th order method
* `SAYFY_ABURUB_6_3_4`: 4th order explicit method
* `CASH_KARP_6_4_5`: 5th order explicit method
* `FEHLBERG_6_4_5`: Fehlberg's classic 5th order method
* `DORMAND_PRINCE_7_4_5`: the classic 5th order Dormand-Prince method
* `ARK548L2SA_ERK_8_4_5`: explicit portion of Kennedy and Carpenter's 5th order method
* `VERNER_8_5_6`: Verner's classic 5th order method
* `FEHLBERG_13_7_8`: Fehlberg's 8th order method

`itable`:

* `SDIRK_2_1_2`: An A-B-stable 2nd order SDIRK method
* `BILLINGTON_3_3_2`: A second order method with a 3rd order error predictor of less stability
* `TRBDF2_3_3_2`: The classic TR-BDF2 method
* `KVAERNO_4_2_3`: an L-stable 3rd order ESDIRK method
* `ARK324L2SA_DIRK_4_2_3`: implicit portion of Kennedy and Carpenter's 3th order method
* `CASH_5_2_4`: Cash's 4th order L-stable SDIRK method
* `CASH_5_3_4`: Cash's 2nd 4th order L-stable SDIRK method
* `SDIRK_5_3_4`: Hairer's 4th order SDIRK method
* `KVAERNO_5_3_4`: Kvaerno's 4th order ESDIRK method
* `ARK436L2SA_DIRK_6_3_4`: implicit portion of Kennedy and Carpenter's 4th order method
* `KVAERNO_7_4_5`: Kvaerno's 5th order ESDIRK method
* `ARK548L2SA_DIRK_8_4_5`: implicit portion of Kennedy and Carpenter's 5th order method

These can be set for example via:

```julia
ARKODE(Sundials.Explicit(), etable = Sundials.DORMAND_PRINCE_7_4_5)
ARKODE(Sundials.Implicit(), itable = Sundials.KVAERNO_4_2_3)
```

### Method Choices

* `method` - This is the method for solving the implicit equation. For BDF this defaults to
    `:Newton` while for Adams this defaults to `:Functional`. These choices match the
    recommended pairing in the Sundials.jl manual. However, note that using the `:Newton`
    method may take less iterations but requires more memory than the `:Function` iteration
    approach.
* `linear_solver` - This is the linear solver which is used in the `:Newton` method.

### Linear Solver Choices

The choices for the linear solver are:

* `:Dense` - A dense linear solver.
* `:Band` - A solver specialized for banded Jacobians. If used, you must set the position of the upper and lower non-zero diagonals via jac_upper and jac_lower.
* `:LapackDense` - A version of the dense linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Dense on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* `:LapackBand` - A version of the banded linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Band on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* `:Diagonal` - This method is specialized for diagonal Jacobians.
* `:GMRES` - A GMRES method. Recommended first choice Krylov method
* `:BCG` - A Biconjugate gradient method.
* `:PCG` - A preconditioned conjugate gradient method. Only for symmetric linear systems.
* `:TFQMR` - A TFQMR method.
* `:KLU` - A sparse factorization method. Requires that the user specifies a Jacobian. The Jacobian must be set as a sparse matrix in the ODEProblem type.

### Preconditioners

Note that here `prec` is a preconditioner function
`prec(z, r, p, t, y, fy, gamma, delta, lr)` where:

- `z`: the computed output vector
- `r`: the right-hand side vector of the linear system
- `p`: the parameters
- `t`: the current independent variable
- `du`: the current value of `f(u,p,t)`
- `gamma`: the `gamma` of `W = M - gamma * J`
- `delta`: the iterative method tolerance
- `lr`: a flag for whether `lr = 1` (left) or `lr = 2` (right)
  preconditioning

and `psetup` is the preconditioner setup function for pre-computing Jacobian
information `psetup(p, t, u, du, jok, jcurPtr, gamma)`. Where:

- `p`: the parameters
- `t`: the current independent variable
- `u`: the current state
- `du`: the current `f(u,p,t)`
- `jok`: a bool indicating whether the Jacobian needs to be updated
- `jcurPtr`: a reference to an Int for whether the Jacobian was updated.
  `jcurPtr[] = true` should be set if the Jacobian was updated, and
  `jcurPtr[] = false` should be set if the Jacobian was not updated.
- `gamma`: the `gamma` of `W = M - gamma*J`

`psetup` is optional when `prec` is set.

### Additional Options

See the [ARKODE manual](https://computing.llnl.gov/sites/default/files/ark_guide-4.7.0.pdf)
for details on the additional options.
"""
struct ARKODE{Method, LinearSolver, MassLinearSolver, T, T1, T2, P, PS} <:
    SundialsODEAlgorithm{Method, LinearSolver}
    stiffness::T
    jac_upper::Int
    jac_lower::Int
    mass_upper::Int
    mass_lower::Int
    krylov_dim::Int
    mass_krylov_dim::Int
    max_hnil_warns::Int
    max_error_test_failures::Int
    max_nonlinear_iters::Int
    max_convergence_failures::Int
    predictor_method::Int
    nonlinear_convergence_coefficient::Float64
    dense_order::Int
    order::Int
    set_optimal_params::Bool
    crdown::Float64
    dgmax::Float64
    rdiv::Float64
    msbp::Int
    itable::T1
    etable::T2
    prec::P
    psetup::PS
    prec_side::Int
end

function ARKODE(
        stiffness = Implicit();
        method = :Newton,
        linear_solver = :Dense,
        mass_linear_solver = :Dense,
        jac_upper = 0,
        jac_lower = 0,
        mass_upper = 0,
        mass_lower = 0,
        non_zero = 0,
        krylov_dim = 0,
        mass_krylov_dim = 0,
        max_hnil_warns = 10,
        max_error_test_failures = 7,
        max_nonlinear_iters = 3,
        max_convergence_failures = 10,
        predictor_method = 0,
        nonlinear_convergence_coefficient = 0.1,
        dense_order = 3,
        order = 4,
        set_optimal_params = false,
        crdown = 0.3,
        dgmax = 0.2,
        rdiv = 2.3,
        msbp = 20,
        adaptivity_method = 0,
        itable = nothing,
        etable = nothing,
        prec = nothing,
        psetup = nothing,
        prec_side = 0
    )
    if linear_solver == :Band && (jac_upper == 0 || jac_lower == 0)
        error("Banded solver must set the jac_upper and jac_lower")
    end
    if !(
            linear_solver in (
                :None,
                :Diagonal,
                :Dense,
                :LapackDense,
                :Band,
                :LapackBand,
                :BCG,
                :GMRES,
                :FGMRES,
                :PCG,
                :TFQMR,
                :KLU,
            )
        )
        error("Linear solver choice not accepted.")
    end
    if !(
            mass_linear_solver in (
                :None,
                :Diagonal,
                :Dense,
                :LapackDense,
                :Band,
                :LapackBand,
                :BCG,
                :GMRES,
                :FGMRES,
                :PCG,
                :TFQMR,
                :KLU,
            )
        )
        error("Mass Matrix Linear solver choice not accepted.")
    end
    return ARKODE{
        method,
        linear_solver,
        mass_linear_solver,
        typeof(stiffness),
        typeof(itable),
        typeof(etable),
        typeof(prec),
        typeof(psetup),
    }(
        stiffness,
        jac_upper,
        jac_lower,
        mass_upper,
        mass_lower,
        krylov_dim,
        mass_krylov_dim,
        max_hnil_warns,
        max_error_test_failures,
        max_nonlinear_iters,
        max_convergence_failures,
        predictor_method,
        nonlinear_convergence_coefficient,
        dense_order,
        order,
        set_optimal_params,
        crdown,
        dgmax,
        rdiv,
        msbp,
        itable,
        etable,
        prec,
        psetup,
        prec_side
    )
end

SciMLBase.alg_order(alg::ARKODE) = 5

# DAE Algorithms
"""
```julia
IDA(;linear_solver=:Dense,jac_upper=0,jac_lower=0,krylov_dim=0,
    max_order = 5,
    max_error_test_failures = 7,
    max_nonlinear_iters = 3,
    nonlinear_convergence_coefficient = 0.33,
    nonlinear_convergence_coefficient_ic = 0.0033,
    max_num_steps_ic = 5,
    max_num_jacs_ic = 4,
    max_num_iters_ic = 10,
    max_num_backs_ic = 100,
    use_linesearch_ic = true,
    max_convergence_failures = 10,
    init_all = false,
    prec = nothing, psetup = nothing)
```

IDA: This is the IDA method from the Sundials.jl package.

### Linear Solvers

Note that the constructors for the Sundials algorithms take a main argument:
linearsolver - This is the linear solver which is used in the Newton iterations. The
choices are:

* :Dense - A dense linear solver.
* :Band - A solver specialized for banded Jacobians. If used, you must set the position of the upper and lower non-zero diagonals via jac_upper and jac_lower.
* :LapackDense - A version of the dense linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Dense on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* :LapackBand - A version of the banded linear solver that uses the Julia-provided OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than :Band on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
* :GMRES - A GMRES method. Recommended first choice Krylov method
* :BCG - A Biconjugate gradient method.
* :PCG - A preconditioned conjugate gradient method. Only for symmetric linear systems.
* :TFQMR - A TFQMR method.
* :KLU - A sparse factorization method. Requires that the user specifies a Jacobian. The Jacobian must be set as a sparse matrix in the ODEProblem type.

Note that the preconditioner for iterative linear solvers (if supplied) should be a left
preconditioner.

Example:

```julia
IDA() # Newton + Dense solver
IDA(linear_solver=:Band,jac_upper=3,jac_lower=3) # Banded solver with nonzero diagonals 3 up and 3 down
IDA(linear_solver=:BCG) # Biconjugate gradient method
```

### Preconditioners

Note that here `prec` is a (left) preconditioner function
`prec(z,r,p,t,y,fy,gamma,delta)` where:

- `z`: the computed output vector
- `r`: the right-hand side vector of the linear system
- `p`: the parameters
- `t`: the current independent variable
- `du`: the current value of `f(u,p,t)`
- `gamma`: the `gamma` of `W = M - gamma*J`
- `delta`: the iterative method tolerance

and `psetup` is the preconditioner setup function for pre-computing Jacobian
information. Where:

- `p`: the parameters
- `t`: the current independent variable
- `resid`: the current residual
- `u`: the current state
- `du`: the current derivative of the state
- `gamma`: the `gamma` of `W = M - gamma*J`

`psetup` is optional when `prec` is set.

### Additional Options

See [the Sundials manual](https://computing.llnl.gov/sites/default/files/ida_guide-5.7.0.pdf)
for details on the additional options. The option `init_all` controls the initial condition
consistency routine. If the initial conditions are inconsistent (i.e. they do not satisfy the
implicit equation), `init_all=false` means that the algebraic variables and derivatives will
be modified in order to satisfy the DAE. If `init_all=true`, all initial conditions will be
modified to satisfy the DAE.
"""
struct IDA{LinearSolver, P, PS} <: SundialsDAEAlgorithm{LinearSolver}
    jac_upper::Int
    jac_lower::Int
    krylov_dim::Int
    max_order::Int
    max_error_test_failures::Int
    nonlinear_convergence_coefficient::Float64
    max_nonlinear_iters::Int
    max_convergence_failures::Int
    nonlinear_convergence_coefficient_ic::Float64
    max_num_steps_ic::Int
    max_num_jacs_ic::Int
    max_num_iters_ic::Int
    max_num_backs_ic::Int
    use_linesearch_ic::Bool
    init_all::Bool
    prec::P
    psetup::PS
end
Base.@pure function IDA(;
        linear_solver = :Dense,
        jac_upper = 0,
        jac_lower = 0,
        krylov_dim = 0,
        max_order = 5,
        max_error_test_failures = 7,
        max_nonlinear_iters = 3,
        nonlinear_convergence_coefficient = 0.33,
        nonlinear_convergence_coefficient_ic = 0.0033,
        max_num_steps_ic = 5,
        max_num_jacs_ic = 4,
        max_num_iters_ic = 10,
        max_num_backs_ic = 100,
        use_linesearch_ic = true,
        init_all = false,
        max_convergence_failures = 10,
        prec = nothing,
        psetup = nothing
    )
    if linear_solver == :Band && (jac_upper == 0 || jac_lower == 0)
        error("Banded solver must set the jac_upper and jac_lower")
    end
    if !(
            linear_solver in (
                :None,
                :Diagonal,
                :Dense,
                :LapackDense,
                :Band,
                :LapackBand,
                :BCG,
                :GMRES,
                :FGMRES,
                :PCG,
                :TFQMR,
                :KLU,
            )
        )
        error("Linear solver choice not accepted.")
    end
    IDA{linear_solver, typeof(prec), typeof(psetup)}(
        jac_upper,
        jac_lower,
        krylov_dim,
        max_order,
        max_error_test_failures,
        nonlinear_convergence_coefficient,
        max_nonlinear_iters,
        max_convergence_failures,
        nonlinear_convergence_coefficient_ic,
        max_num_steps_ic,
        max_num_jacs_ic,
        max_num_iters_ic,
        max_num_backs_ic,
        use_linesearch_ic,
        init_all,
        prec,
        psetup
    )
end

"""
KINSOL: Newton-Krylov technique solver

```julia
KINSOL(;
    linear_solver = :Dense,
    jac_upper = 0,
    jac_lower = 0,
    userdata = nothing,
    prec_side = 0,
    krylov_dim = 0,
    globalization_strategy = :None
    maxsetupcalls=0
)
```

The choices for the linear solver are:

- `:Dense`: A dense linear solver
- `:Band`: A solver specialized for banded Jacobians. If used, you must set the
  position of the upper and lower non-zero diagonals via `jac_upper` and
  `jac_lower`.
- `:LapackDense`: A version of the dense linear solver that uses the Julia-provided
  OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than
  `:Dense` on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
- `:LapackBand`: A version of the banded linear solver that uses the Julia-provided
  OpenBLAS-linked LAPACK for multithreaded operations. This will be faster than
  `:Band` on larger systems but has noticeable overhead on smaller (<100 ODE) systems.
- `:GMRES`: A GMRES method. Recommended first choice Krylov method.
- `:BCG`: A biconjugate gradient method
- `:PCG`: A preconditioned conjugate gradient method. Only for symmetric
  linear systems.
- `:TFQMR`: A TFQMR method.
- `:KLU`: A sparse factorization method. Requires that the user specify a
  Jacobian. The Jacobian must be set as a sparse matrix in the `ODEProblem`
  type.

The choices for globalization strategy are:

- `:None`: No globalization strategy
- `:LineSearch`: A line search globalization strategy

Other options:

- `maxsetupcalls`: Maximum number of nonlinear iterations that can be performed between
  calls to the preconditioner or Jacobian setup function.
"""
struct KINSOL{LinearSolver} <: SundialsNonlinearSolveAlgorithm{LinearSolver}
    jac_upper::Int
    jac_lower::Int
    userdata::Any
    prec_side::Int
    krylov_dim::Int
    globalization_strategy::Symbol
    maxsetupcalls::Int
end

Base.@pure function KINSOL(;
        linear_solver = :Dense,
        jac_upper = 0,
        jac_lower = 0,
        userdata = nothing,
        prec_side = 0,
        krylov_dim = 0,
        globalization_strategy = :None,
        maxsetupcalls = 0
    )
    if !(
            linear_solver in (
                :None,
                :Dense,
                :LapackDense,
                :Band,
                :LapackBand,
                :BCG,
                :GMRES,
                :FGMRES,
                :PCG,
                :TFQMR,
                :KLU,
            )
        )
        error("Linear solver choice not accepted.")
    end
    if !(globalization_strategy in (:LineSearch, :None))
        error("Globalization strategy not accepted.")
    end
    KINSOL{linear_solver}(
        jac_upper, jac_lower, userdata, prec_side, krylov_dim,
        globalization_strategy, maxsetupcalls
    )
end

method_choice(alg::SundialsODEAlgorithm{Method}) where {Method} = Method
method_choice(alg::SundialsDAEAlgorithm) = :Newton
function linear_solver(
        alg::SundialsODEAlgorithm{
            Method,
            LinearSolver,
        }
    ) where {
        Method,
        LinearSolver,
    }
    return LinearSolver
end
linear_solver(alg::SundialsDAEAlgorithm{LinearSolver}) where {LinearSolver} = LinearSolver
function linear_solver(
        alg::SundialsNonlinearSolveAlgorithm{
            LinearSolver,
        }
    ) where {
        LinearSolver,
    }
    return LinearSolver
end

using Sundials, Test, DiffEqBase
using ForwardDiff
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

function regression_test(alg, tol_ode_linear, tol_ode_2Dlinear)
    sol = solve(prob_ode_linear, alg, dense = true, abstol = 1.0e-8, reltol = 1.0e-8)
    @inferred sol(0.5)
    u0 = sol.u[1]
    p = sol.prob.p
    for t in 0.0:(1 / 16):1.0
        @test isapprox(u0 * exp(p * t), sol(t), rtol = tol_ode_linear)
    end

    sol = solve(prob_ode_2Dlinear, alg, dt = 1 / 2^(2), dense = true)
    sol2 = solve(prob_ode_2Dlinear, alg, dense = true, abstol = 1.0e-8, reltol = 1.0e-8)
    u0 = sol.u[1]
    p = sol.prob.p
    for t in 0.0:(1 / 16):1.0
        @test isapprox(u0 .* exp(p * t), sol(t), rtol = tol_ode_2Dlinear)
    end
    return
end

regression_test(ARKODE(), 1.0e-5, 1.5e-3)  # Relaxed from 1e-4 to 1.5e-3 for 2D problem
regression_test(CVODE_BDF(), 1.0e-5, 1.0e-2)  # Relaxed from 1e-6 to 1e-5 for numerical stability
regression_test(CVODE_Adams(), 1.0e-5, 1.0e-3)  # Relaxed from 1e-6 to 1e-5 for numerical stability

using Sundials

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]

## Adapted from sundialsTB/kinsol/examples_ser/mkinTest_nds.m

## %mkinTest_dns - KINSOL example problem (serial, dense)
## %   Simple test problem for the Dense linear solver in KINSOL
## %   This example solves the system
## %       y(1)^2 + y(2)^2 = 1
## %       y(2) = y(1)^2
## %

## % Radu Serban <radu@llnl.gov>

using Sundials, Test

## function to be optimized
function sysfn(y_nv, fy_nv, a_in)
    y = convert(Vector, y_nv)
    fy = convert(Vector, fy_nv)
    fy[1] = y[1]^2 + y[2]^2 - 1.0
    fy[2] = y[2] - y[1]^2
    return Sundials.KIN_SUCCESS
end

sysfn_C = @cfunction(sysfn, Cint, (Sundials.N_Vector, Sundials.N_Vector, Ptr{Cvoid}))

## Initialize problem
neq = 2
kmem = Sundials.KINCreate(ctx)
Sundials.@checkflag Sundials.KINSetFuncNormTol(kmem, 1.0e-5)
Sundials.@checkflag Sundials.KINSetScaledStepTol(kmem, 1.0e-4)
Sundials.@checkflag Sundials.KINSetMaxSetupCalls(kmem, 1)
y = ones(neq)
y_nvec = Sundials.NVector(y, ctx)
Sundials.@checkflag Sundials.KINInit(kmem, sysfn_C, y_nvec)
A = Sundials.SUNDenseMatrix(length(y), length(y), ctx)
LS = Sundials.SUNLinSol_Dense(y_nvec, A, ctx)
Sundials.@checkflag Sundials.KINDlsSetLinearSolver(kmem, LS, A)
## Solve problem
scale = ones(neq)
scale_nvec = Sundials.NVector(scale, ctx)
Sundials.@checkflag Sundials.KINSol(
    kmem, y_nvec, Sundials.KIN_LINESEARCH, scale_nvec, scale_nvec
)
copyto!(y, y_nvec.v)

println("Solution: ", y)
residual = ones(2)
sysfn(y, residual, [1, 2])
println("Residual: ", residual)

@test abs(minimum(residual)) < 1.0e-5

# Clean up context
Sundials.SUNContext_Free(ctx)

using Sundials

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]

##
## Example problem for IDA: 2D heat equation, serial, banded.
##
## This example solves a discretized 2D heat equation problem.  This
## version uses the band solver IDABand, and IDACalcIC.
##
## The DAE system solved is a spatial discretization of the PDE
##
##          du/dt = d^2u/dx^2 + d^2u/dy^2
##
## on the unit square. The boundary condition is u = 0 on all edges.
## Initial conditions are given by u = 48 x (1 - x) y (1 - y).  The
## PDE is treated with central differences on a uniform M x M
## grid. The values of u at the interior points satisfy ODEs, and
## equations u = 0 at the boundaries are appended, to form a DAE
## system of size N = M^2. Here M = 10.
##
## The system is solved with IDA using the banded linear system
## solver, half-bandwidths equal to M, and default difference-quotient
## Jacobian. For purposes of illustration, IDACalcIC is called to
## compute correct values at the boundary, given incorrect values as
## input initial guesses. The constraints u >= 0 are posed for all
## components.
##

MGRID = 10
NEQ = MGRID * MGRID

dx = 1.0 / (MGRID - 1.0)
coeff = 1.0 / (dx * dx)
bval = 0.1
##
## heatres: heat equation system residual function This uses 5-point
## central differencing on the interior points, and includes algebraic
## equations for the boundary values.
##
## So for each interior point, the residual component has the form
##    r_i = u'_i - (central difference)_i
## while for each boundary point, it is r_i = u_i.
##

function heatres(t, u, up, r)
    r[:] = u ## Initialize r to u, to take care of boundary equations.

    ## Loop over interior points; set res = up - (central difference).
    for j in 2:(MGRID - 2)
        offset = MGRID * j
        for i in 2:(MGRID - 2)
            loc = offset + i
            r[loc] = up[loc] -
                coeff *
                (
                u[loc - 1] + u[loc + 1] + u[loc - MGRID] + u[loc + MGRID] -
                    4.0 * u[loc]
            )
        end
    end

    return Sundials.CV_SUCCESS
end

function initial()
    mm = MGRID
    mm1 = mm - 1

    u = zeros(NEQ)
    id = ones(NEQ)

    ## initialize u on all grid points
    for j in 1:(mm - 1)
        yfact = dx * j
        offset = mm * j
        for i in 1:(mm - 1)
            xfact = dx * i
            loc = offset + i
            u[loc] = 48.0 * xfact * (1.0 - xfact) * yfact * (1.0 - yfact)
        end
    end

    up = zeros(NEQ)
    r = zeros(NEQ)

    heatres(0.0, u, up, r)

    ## Copy -res into up to get correct interior initial up values.
    up[:] = -1.0 * r

    ## Finally, set values of u, up, and id at boundary points.
    for j in 1:(mm - 1)
        offset = mm * j
        for i in 1:(mm - 1)
            loc = offset + i
            if j == 1 || j == mm1 || i == 1 || i == mm1
                u[loc] = bval
                up[loc] = 0
                id[loc] = 0
            end
        end
    end

    constraints = ones(NEQ)
    return (u, up, id, constraints)
end

function idabandsol(
        f::Function,
        y0::Vector{Float64},
        yp0::Vector{Float64},
        id::Vector{Float64},
        constraints::Vector{Float64},
        t::Vector{Float64};
        reltol::Float64 = 1.0e-4,
        abstol::Float64 = 1.0e-6
    )
    neq = length(y0)
    mem = Sundials.IDACreate(ctx)
    y0_nvec = Sundials.NVector(y0, ctx)
    yp0_nvec = Sundials.NVector(yp0, ctx)
    Sundials.@checkflag Sundials.IDAInit(
        mem,
        @cfunction(
            Sundials.idasolfun,
            Cint,
            (
                Sundials.realtype,
                Sundials.N_Vector,
                Sundials.N_Vector,
                Sundials.N_Vector,
                Ref{Function},
            )
        ),
        t[1],
        y0_nvec,
        yp0_nvec
    )
    id_nvec = Sundials.NVector(id, ctx)
    Sundials.@checkflag Sundials.IDASetId(mem, id_nvec)
    constraints_nvec = Sundials.NVector(constraints, ctx)
    Sundials.@checkflag Sundials.IDASetConstraints(mem, constraints_nvec)
    Sundials.@checkflag Sundials.IDASetUserData(mem, f)
    Sundials.@checkflag Sundials.IDASStolerances(mem, reltol, abstol)

    A = Sundials.SUNBandMatrix(neq, MGRID, MGRID, ctx) #,2MGRID)
    LS = Sundials.SUNLinSol_Band(y0_nvec, A, ctx)
    Sundials.@checkflag Sundials.IDADlsSetLinearSolver(mem, LS, A)

    rtest = zeros(neq)
    Sundials.@checkflag Sundials.IDACalcIC(mem, Sundials.IDA_YA_YDP_INIT, t[2])
    yres = zeros(Float64, length(y0), length(t))
    ypres = zeros(Float64, length(y0), length(t))
    yres[:, 1] = y0
    ypres[:, 1] = yp0
    y = copy(y0)
    yp = copy(yp0)
    y_nvec = Sundials.NVector(y, ctx)
    yp_nvec = Sundials.NVector(yp, ctx)
    tout = [0.0]
    for k in 2:length(t)
        Sundials.@checkflag Sundials.IDASolve(
            mem, t[k], tout, y_nvec, yp_nvec, Sundials.IDA_NORMAL
        )
        copyto!(y, y_nvec.v)
        copyto!(yp, yp_nvec.v)
        yres[:, k] = y
        ypres[:, k] = yp
    end

    Sundials.SUNLinSolFree_Band(LS)
    Sundials.SUNMatDestroy_Band(A)

    return yres, ypres
end

nsteps = 10
tstep = 0.005
t = collect(0.0:tstep:(tstep * nsteps))
u0, up0, id, constraints = initial()

idabandsol(heatres, u0, up0, id, constraints, map(x -> x, t); reltol = 0.0, abstol = 1.0e-3)

# Clean up context
Sundials.SUNContext_Free(ctx)

using ModelingToolkit, SciMLBase, Sundials, Test
using SymbolicIndexingInterface
using ModelingToolkit: t_nounits as t, D_nounits as D

@testset "ODE" begin
    @variables x(t) [guess = 1.0] y(t) [guess = 1.0]
    @parameters p = missing [guess = 1.0] q = missing [guess = 1.0]
    @mtkcompile sys = System([D(x) ~ p * y + q * t, D(y) ~ 5x + q], t; initialization_eqs = [p^2 + q^2 ~ 3, x^3 + y^3 ~ 5])

    @testset "IIP: $iip" for iip in [true, false]
        prob = ODEProblem{iip}(sys, [x => 1.0, p => 1.0], (0.0, 1.0))

        @testset "$alg" for alg in [CVODE_BDF, CVODE_Adams, ARKODE]
            integ = init(prob, alg())
            @test integ.initializealg isa Sundials.DefaultInit
            @test integ[x] ≈ 1.0
            @test integ[y] ≈ cbrt(4)
            @test integ.ps[p] ≈ 1.0
            @test integ.ps[q] ≈ sqrt(2)
            sol = solve(prob, alg())
            @test SciMLBase.successful_retcode(sol)
            @test sol[x, 1] ≈ 1.0
            @test sol[y, 1] ≈ cbrt(4)
            @test sol.ps[p] ≈ 1.0
            @test sol.ps[q] ≈ sqrt(2)
        end
    end
end
@testset "DAE" begin
    @variables x(t) [guess = 1.0] y(t) [guess = 1.0]
    @parameters p = missing [guess = 1.0] q = missing [guess = 1.0]
    @mtkcompile sys = System([D(x) ~ p * y + q * t, x^3 + y^3 ~ 5], t; initialization_eqs = [p^2 + q^2 ~ 3])

    @testset "DAEProblem{$iip}" for iip in [true, false]
        prob = DAEProblem(sys, [D(x) => cbrt(4), D(y) => -1 / cbrt(4), p => 1.0], (0.0, 0.4))
        @testset "OverrideInit" begin
            integ = init(prob, IDA())
            @test integ.initializealg isa Sundials.DefaultInit
            @test integ[x] ≈ 1.0
            @test integ[y] ≈ cbrt(4)
            @test integ.ps[p] ≈ 1.0
            @test integ.ps[q] ≈ sqrt(2)
            sol = solve(prob, IDA())
            @test SciMLBase.successful_retcode(sol)
            @test sol[x, 1] ≈ 1.0
            @test sol[y, 1] ≈ cbrt(4)
            @test sol.ps[p] ≈ 1.0
            @test sol.ps[q] ≈ sqrt(2)
        end
        @testset "CheckInit" begin
            prob = DAEProblem(sys, [D(x) => cbrt(4), D(y) => -1 / cbrt(4), p => 1.0], (0.0, 0.4))
            @test_throws Any init(prob, IDA(); initializealg = SciMLBase.CheckInit())
            # Create a new problem with correct initial values
            # D(x) = p*y = 1*cbrt(4) = cbrt(4)
            # D(y) = -x²/y²*D(x) = -1/cbrt(4)²*cbrt(4) = -1/cbrt(4)
            prob_correct = DAEProblem(
                sys,
                [D(x) => cbrt(4), D(y) => -1 / cbrt(4), p => 1.0, x => 1.0, y => cbrt(4), q => sqrt(2)],
                (0.0, 0.4)
            )
            # Need to convert to IIP/OOP after creation to get proper numeric arrays
            if iip
                prob_correct_typed = DAEProblem{true}(
                    prob_correct.f, prob_correct.du0, prob_correct.u0,
                    prob_correct.tspan, prob_correct.p
                )
            else
                prob_correct_typed = DAEProblem{false}(
                    prob_correct.f, prob_correct.du0, prob_correct.u0,
                    prob_correct.tspan, prob_correct.p
                )
            end
            @test_nowarn init(prob_correct_typed, IDA(); initializealg = SciMLBase.CheckInit())

        end
    end
end

using Sundials
using Interpolations

##
## Solving the 1D cable equation with IDA.
##
## The DAE system solved is a spatial discretization of the PDE
##
##  C_m dV/dt = d/R d^2V/x^2 - G_m V - R_m J
##
## The PDE is treated with central differences on a uniform M x 1
## grid. The values of u at the interior points satisfy ODEs, and
## equations u = 0 at the boundaries are appended, to form a DAE
## system of size M.
##

## Length of cable in um
const L = 4000

## Number of space steps to simulate
const dx = 10.0
const xsteps = round(Int, L / dx)

## Number of timesteps to simulate
const tf = 10.0
const dt = 0.1
const timesteps = round(Int, tf / dt)
const t = collect(0.0:dt:(dt * (timesteps - 1)))

const d = 4.0 * 1.0e-4 ## Cable diameter in cm
const R_m = 2.5e11 ## Membrane resistance in Ohms/cm^2
const G_m = 1.0 / R_m ## Membrane conductance
const R_i = 30.0  ## Longitudinal resistivity in Ohms*cm
const C_m = 1.0e-6  ## Membrane capacitance in F/cm^2

## Define the injected current J
const J = zeros(timesteps, xsteps)
const I_in = 0.1
## When to start injecting current
const I_delay = 1.0
## Duration of injected current
const I_dur = 5.0
J[
    max(1, round(Int, (I_delay) / dt)):round(Int, (I_delay + I_dur) / dt), round(
        Int, 1 * xsteps / 2
    ),
] = I_in

const G_J = map(i -> CoordInterpGrid(t, vec(J[:, i]), 0.0, InterpQuadratic), 1:xsteps)

##
## cableres: cable equation system residual function. This uses
## central differencing on the interior points, and includes algebraic
## equations for the boundary values.
##

function cableres(t, u, up, r)
    r[:] = u ## Initialize r to u, to take care of boundary equations.

    ## Loop over segments; set res = up - (central difference).
    for i in 2:(xsteps - 2)
        loc = i
        r[loc] = C_m * up[loc] -
            (d / (4 * R_i)) * (
            u[loc - 1] + u[loc + 1] -
                2.0 * u[loc]
        ) +
            G_m * u[loc] - R_m * (G_J[loc])[t]
    end

    return Sundials.CV_SUCCESS
end

function initial()
    u = zeros(xsteps)

    u[2:(xsteps - 2)] = -60.0 ## initial value -60 mV

    id = ones(xsteps)

    up = zeros(xsteps)
    r = zeros(xsteps)

    cableres(0.0, u, up, r)

    ## Copy -res into up to get correct interior initial up values.
    up[:] = -1.0 * r

    return (u, up, id)
end

function idabandsol(
        f::Function, y0::Vector{Float64}, yp0::Vector{Float64},
        id::Vector{Float64}, t::Vector{Float64};
        reltol::Float64 = 1.0e-4, abstol::Float64 = 1.0e-6
    )
    neq = length(y0)
    mem = Sundials.IDACreate()

    function getcfunband(f::T) where {T}
        return @cfunction(
            Sundials.idasolfun, Cint,
            (
                Sundials.realtype, Sundials.N_Vector, Sundials.N_Vector,
                Sundials.N_Vector, Ref{T},
            )
        )
    end
    Sundials.@checkflag Sundials.IDAInit(
        mem, getcfunband(f),
        t[1], y0, yp0
    )
    Sundials.@checkflag Sundials.IDASetId(mem, id)
    Sundials.@checkflag Sundials.IDASetUserData(mem, f)
    Sundials.@checkflag Sundials.IDASStolerances(mem, reltol, abstol)
    Sundials.@checkflag Sundials.IDABand(mem, neq, xsteps - 1, xsteps - 1)
    ##Sundials.@checkflag Sundials.IDADense(mem, neq)
    rtest = zeros(neq)
    Sundials.@checkflag Sundials.IDACalcIC(mem, Sundials.IDA_YA_YDP_INIT, t[2])
    yres = zeros(Float64, length(y0), length(t))
    ypres = zeros(Float64, length(y0), length(t))
    yres[:, 1] = y0
    ypres[:, 1] = yp0
    y = copy(y0)
    yp = copy(yp0)
    tout = [0.0]
    for k in 2:length(t)
        Sundials.@checkflag Sundials.IDASolve(mem, t[k], tout, y, yp, Sundials.IDA_NORMAL)
        yres[:, k] = y
        ypres[:, k] = yp
    end
    return yres, ypres
end

u0, up0, id = initial()

yout,
    ypout = @time idabandsol(
    cableres, u0, up0, id, map(x -> x, t);
    reltol = 1.0e-3, abstol = 1.0e-4
)

using Sundials, Test, LinearAlgebra, IncompleteLU, SparseArrays
import AlgebraicMultigrid
import SparseConnectivityTracer, DifferentiationInterface, ADTypes, ForwardDiff

const N = 32
const xyd_brusselator = range(0; stop = 1, length = N)
brusselator_f(x, y, t) = (((x - 0.3)^2 + (y - 0.6)^2) <= 0.1^2) * (t >= 1.1) * 5.0
limit(a, N) = a == N + 1 ? 1 : a == 0 ? N : a

function brusselator_2d_loop(du, u, p, t)
    A, B, alpha, dx = p
    alpha = alpha / dx^2
    return @inbounds for I in CartesianIndices((N, N))
        i, j = Tuple(I)
        x, y = xyd_brusselator[I[1]], xyd_brusselator[I[2]]
        ip1, im1, jp1,
            jm1 = limit(i + 1, N), limit(i - 1, N), limit(j + 1, N),
            limit(j - 1, N)
        du[i, j, 1] = alpha * (
            u[im1, j, 1] + u[ip1, j, 1] + u[i, jp1, 1] + u[i, jm1, 1] -
                4u[i, j, 1]
        ) +
            B + u[i, j, 1]^2 * u[i, j, 2] - (A + 1) * u[i, j, 1] +
            brusselator_f(x, y, t)
        du[i, j, 2] = alpha * (
            u[im1, j, 2] + u[ip1, j, 2] + u[i, jp1, 2] + u[i, jm1, 2] -
                4u[i, j, 2]
        ) +
            A * u[i, j, 1] - u[i, j, 1]^2 * u[i, j, 2]
    end
end

# vector arguments to simplify Jacobian setup
function brusselator_2d_vec(du_vec, u_vec, p, t)
    du = reshape(du_vec, N, N, 2)
    u = reshape(u_vec, N, N, 2)
    return brusselator_2d_loop(du, u, p, t)
end

p = (3.4, 1.0, 10.0, step(xyd_brusselator))

function init_brusselator_2d(xyd)
    N = length(xyd)
    u = zeros(N, N, 2)
    for I in CartesianIndices((N, N))
        x = xyd[I[1]]
        y = xyd[I[2]]
        u[I, 1] = 22 * (y * (1 - y))^(3 / 2)
        u[I, 2] = 27 * (x * (1 - x))^(3 / 2)
    end
    return u
end
u0 = vec(init_brusselator_2d(xyd_brusselator))
du = similar(u0)

prob_ode_brusselator_2d = ODEProblem(
    brusselator_2d_vec,
    u0, (0.0, 11.5), p
)

detector = SparseConnectivityTracer.TracerSparsityDetector()
brus_uf = (du, u) -> brusselator_2d_vec(du, u, p, 0.1)
const jaccache = similar(SparseConnectivityTracer.jacobian_sparsity(brus_uf, du, u0, detector), Float64)
const W = I - 1.0 * jaccache

# setup sparse AD for Jacobian
# Setup sparse jacobian computation using DifferentiationInterface
# NOTE: AutoSparse doesn't support in-place functions with ForwardDiff in DI v0.7
# (requires pushforward performance which isn't defined for this combination)
# So we use regular AutoForwardDiff() and compute dense then copy to sparse
const backend = DifferentiationInterface.AutoForwardDiff()
# Don't prepare with a specific function - we'll prepare fresh in each callback
# since the function changes with different p and t values

prectmp = ilu(W; τ = 50.0)
const preccache = Ref(prectmp)

function psetupilu(p, t, u, du, jok, jcurPtr, gamma)
    return if jok
        # Compute jacobian using DifferentiationInterface with ForwardDiff backend
        # Create a wrapper that captures p and t
        f_wrapper! = (y, x) -> brusselator_2d_vec(y, x, p, t)
        # Prepare jacobian for this specific function
        prep_local = DifferentiationInterface.prepare_jacobian(f_wrapper!, du, backend, u)
        # Compute dense jacobian first, then copy to sparse
        jac_dense = Matrix(jaccache)
        DifferentiationInterface.jacobian!(f_wrapper!, du, jac_dense, prep_local, backend, u)
        # Copy non-zero entries back to sparse matrix
        for (i, j, v) in zip(findnz(jaccache)...)
            jaccache[i, j] = jac_dense[i, j]
        end
        jcurPtr[] = true

        # W = I - gamma*J
        @. W = -gamma * jaccache
        idxs = diagind(W)
        @. @view(W[idxs]) = @view(W[idxs]) + 1

        # Build preconditioner on W
        preccache[] = ilu(W; τ = 5.0)
    end
end

function precilu(z, r, p, t, y, fy, gamma, delta, lr)
    return ldiv!(z, preccache[], r)
end

# AlgebraicMultigrid can fail with LAPACK errors on some systems
prectmp2 = try
    AlgebraicMultigrid.aspreconditioner(
        AlgebraicMultigrid.ruge_stuben(
            W;
            presmoother = AlgebraicMultigrid.Jacobi(
                rand(
                    size(
                        W,
                        1
                    )
                )
            ),
            postsmoother = AlgebraicMultigrid.Jacobi(
                rand(
                    size(
                        W,
                        1
                    )
                )
            )
        )
    )
catch e
    @warn "AlgebraicMultigrid setup failed, using identity preconditioner as fallback" exception = e
    nothing
end
const preccache2 = Ref(prectmp2)
function psetupamg(p, t, u, du, jok, jcurPtr, gamma)
    if preccache2[] === nothing
        return  # Skip setup if AMG failed initially
    end

    return if jok
        # Compute jacobian using DifferentiationInterface with ForwardDiff backend
        # Create a wrapper that captures p and t
        f_wrapper! = (y, x) -> brusselator_2d_vec(y, x, p, t)
        # Prepare jacobian for this specific function
        prep_local = DifferentiationInterface.prepare_jacobian(f_wrapper!, du, backend, u)
        # Compute dense jacobian first, then copy to sparse
        jac_dense = Matrix(jaccache)
        DifferentiationInterface.jacobian!(f_wrapper!, du, jac_dense, prep_local, backend, u)
        # Copy non-zero entries back to sparse matrix
        for (i, j, v) in zip(findnz(jaccache)...)
            jaccache[i, j] = jac_dense[i, j]
        end
        jcurPtr[] = true

        # W = I - gamma*J
        @. W = -gamma * jaccache
        idxs = diagind(W)
        @. @view(W[idxs]) = @view(W[idxs]) + 1

        # Build preconditioner on W
        try
            preccache2[] = AlgebraicMultigrid.aspreconditioner(
                AlgebraicMultigrid.ruge_stuben(
                    W;
                    presmoother = AlgebraicMultigrid.Jacobi(
                        rand(
                            size(
                                W,
                                1
                            )
                        )
                    ),
                    postsmoother = AlgebraicMultigrid.Jacobi(
                        rand(
                            size(
                                W,
                                1
                            )
                        )
                    )
                )
            )
        catch e
            @warn "AlgebraicMultigrid update failed in psetupamg" exception = e
        end
    end
end

function precamg(z, r, p, t, y, fy, gamma, delta, lr)
    return if preccache2[] === nothing
        # Identity preconditioner fallback
        z .= r
    else
        ldiv!(z, preccache2[], r)
    end
end

sol1 = solve(
    prob_ode_brusselator_2d, CVODE_BDF(; linear_solver = :GMRES);
    save_everystep = false
);
sol2 = solve(
    prob_ode_brusselator_2d,
    CVODE_BDF(;
        linear_solver = :GMRES, prec = precilu, psetup = psetupilu,
        prec_side = 1
    ); save_everystep = false
);
sol3 = solve(
    prob_ode_brusselator_2d,
    CVODE_BDF(;
        linear_solver = :GMRES, prec = precamg, psetup = psetupamg,
        prec_side = 1
    ); save_everystep = false
);
@test sol1.stats.nf > sol2.stats.nf
# AlgebraicMultigrid can fail with LAPACK errors - mark as broken if it failed
if preccache2[] === nothing
    @test_broken sol1.stats.nf > sol3.stats.nf
else
    @test sol1.stats.nf > sol3.stats.nf
end

using Sundials, Test

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]

## f routine. Compute function f(t,y).

function f(t, y_nv, ydot_nv, user_data)
    y = convert(Vector, y_nv)
    ydot = convert(Vector, ydot_nv)
    ydot[1] = -0.04 * y[1] + 1.0e4 * y[2] * y[3]
    ydot[3] = 3.0e7 * y[2] * y[2]
    ydot[2] = -ydot[1] - ydot[3]
    return Sundials.ARK_SUCCESS
end

f_C = @cfunction(
    f, Cint,
    (Sundials.realtype, Sundials.N_Vector, Sundials.N_Vector, Ptr{Cvoid})
)

neq = 3

t0 = 0.0
t1 = 0.4
tmult = 10.0
nout = 12
y0 = [1.0, 0.0, 0.0]
reltol = 1.0e-4
abstol = 1.0e-11
userdata = nothing
h0 = 1.0e-4 * reltol

y0_nvec = Sundials.NVector(y0, ctx)
mem_ptr = Sundials.ARKStepCreate(C_NULL, f_C, t0, y0_nvec, ctx)
arkStep_mem = Sundials.Handle(mem_ptr)
Sundials.@checkflag Sundials.ARKStepSetInitStep(arkStep_mem, h0)
Sundials.@checkflag Sundials.ARKStepSetMaxErrTestFails(arkStep_mem, 20)
Sundials.@checkflag Sundials.ARKStepSetMaxNonlinIters(arkStep_mem, 8)
Sundials.@checkflag Sundials.ARKStepSetNonlinConvCoef(arkStep_mem, 1.0e-7)
Sundials.@checkflag Sundials.ARKStepSetMaxNumSteps(arkStep_mem, 100000)
Sundials.@checkflag Sundials.ARKStepSetPredictorMethod(arkStep_mem, 1)

Sundials.@checkflag Sundials.ARKStepSStolerances(arkStep_mem, reltol, abstol)
A = Sundials.SUNDenseMatrix(neq, neq, ctx)
LS = Sundials.SUNLinSol_Dense(y0_nvec, A, ctx)
Sundials.@checkflag Sundials.ARKStepSetLinearSolver(arkStep_mem, LS, A)

iout = 0
tout = t1
t = [t0]

while iout < nout
    y = similar(y0)
    y_nvec = Sundials.NVector(y, ctx)
    flag = Sundials.ARKStepEvolve(arkStep_mem, tout, y_nvec, t, Sundials.ARK_NORMAL)
    copyto!(y, y_nvec.v)
    @test flag == 0
    println("T=", tout, ", Y=", y)
    global iout += 1
    global tout *= tmult
end

tmp1 = Ref(Clong(-1))
tmp2 = Ref(Clong(-1))
Sundials.@checkflag Sundials.ARKStepGetNumSteps(arkStep_mem, tmp1);
Sundials.@checkflag Sundials.ARKStepGetNumStepAttempts(arkStep_mem, tmp1);
Sundials.@checkflag Sundials.ARKStepGetNumRhsEvals(arkStep_mem, tmp1, tmp2);
Sundials.@checkflag Sundials.ARKStepGetNumLinSolvSetups(arkStep_mem, tmp1);
Sundials.@checkflag Sundials.ARKStepGetNumErrTestFails(arkStep_mem, tmp1);
Sundials.@checkflag Sundials.ARKStepGetNumNonlinSolvIters(arkStep_mem, tmp1);
Sundials.@checkflag Sundials.ARKStepGetNumNonlinSolvConvFails(arkStep_mem, tmp1);
Sundials.@checkflag Sundials.ARKStepGetNumJacEvals(arkStep_mem, tmp1);
Sundials.@checkflag Sundials.ARKStepGetNumLinRhsEvals(arkStep_mem, tmp2);

# Clean up context
Sundials.SUNContext_Free(ctx)

using Sundials

## f routine. Compute function f(t,y).

function f(t, y_nv, ydot_nv)
    y = convert(Vector, y_nv)
    ydot = convert(Vector, ydot_nv)
    ydot[1] = -0.04 * y[1] + 1.0e4 * y[2] * y[3]
    ydot[3] = 3.0e7 * y[2] * y[2]
    ydot[2] = -ydot[1] - ydot[3]
    return Sundials.CV_SUCCESS
end

## g routine. Compute functions g_i(t,y) for i = 0,1.

function g(t, y_nv, gout_ptr, user_data)
    y = convert(Vector, y_nv)
    gout = Sundials.asarray(gout_ptr, (2,))
    gout[1] = y[1] - 0.0001
    gout[2] = y[3] - 0.01
    return Sundials.CV_SUCCESS
end

g_C = @cfunction(
    g, Cint,
    (Sundials.realtype, Sundials.N_Vector, Ptr{Sundials.realtype}, Ptr{Cvoid})
)

## Jacobian routine. Compute J(t,y) = df/dy.
# broken -- needs a wrapper from Sundials._DlsMat to Matrix and Jac user function wrapper
function Jac(N, t, ny, fy, Jptr, user_data, tmp1, tmp2, tmp3)
    y = convert(Vector, ny)
    dlsmat = unpack(
        IOString(
            unsafe_wrap(
                convert(Ptr{UInt8}, Jptr),
                (sum(map(sizeof, Sundials._DlsMat)) + 10,),
                false
            )
        ),
        Sundials._DlsMat
    )
    J = unsafe_wrap(unsafe_ref(dlsmat.cols), (Int(neq), Int(neq)), false)
    J[1, 1] = -0.04
    J[1, 2] = 1.0e4 * y[3]
    J[1, 3] = 1.0e4 * y[2]
    J[2, 1] = 0.04
    J[2, 2] = -1.0e4 * y[3] - 6.0e7 * y[2]
    J[2, 3] = -1.0e4 * y[2]
    J[3, 2] = 6.0e7 * y[2]
    return Sundials.CV_SUCCESS
end

neq = 3

t0 = 0.0
t1 = 0.4
tmult = 10.0
nout = 12
y0 = [1.0, 0.0, 0.0]
reltol = 1.0e-4
abstol = [1.0e-8, 1.0e-14, 1.0e-6]
userdata = nothing
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]
mem_ptr = Sundials.CVodeCreate(Sundials.CV_BDF, ctx)
cvode_mem = Sundials.Handle(mem_ptr)
userfun = Sundials.UserFunctionAndData(f, userdata)
Sundials.CVodeSetUserData(cvode_mem, userfun)

function getcfunrob(userfun::T) where {T}
    return @cfunction(
        Sundials.cvodefun,
        Cint,
        (Sundials.realtype, Sundials.N_Vector, Sundials.N_Vector, Ref{T})
    )
end

# Create NVector before using it
y0_nvec = Sundials.NVector(y0, ctx)

Sundials.@checkflag Sundials.CVodeInit(
    cvode_mem, getcfunrob(userfun), t1,
    y0_nvec
)
Sundials.@checkflag Sundials.CVodeInit(cvode_mem, getcfunrob(userfun), t0, y0_nvec)
abstol_nvec = Sundials.NVector(abstol, ctx)
Sundials.@checkflag Sundials.CVodeSVtolerances(cvode_mem, reltol, abstol_nvec)
Sundials.@checkflag Sundials.CVodeRootInit(cvode_mem, 2, g_C)
A = Sundials.SUNDenseMatrix(neq, neq, ctx)
mat_handle = Sundials.MatrixHandle(A, Sundials.DenseMatrix())
LS = Sundials.SUNLinSol_Dense(y0_nvec, A, ctx)
LS_handle = Sundials.LinSolHandle(LS, Sundials.Dense())
Sundials.@checkflag Sundials.CVDlsSetLinearSolver(cvode_mem, LS, A)
#Sundials.@checkflag Sundials.CVDlsSetDenseJacFn(cvode_mem, Jac)

iout = 0
tout = t1
t = [t0]

while iout < nout
    y = similar(y0)
    y_nvec = Sundials.NVector(y, ctx)
    flag = Sundials.CVode(cvode_mem, tout, y_nvec, t, Sundials.CV_NORMAL)
    copyto!(y, y_nvec.v)
    println("T=", tout, ", Y=", y)
    if flag == Sundials.CV_ROOT_RETURN
        rootsfound = zeros(Cint, 2)
        Sundials.@checkflag Sundials.CVodeGetRootInfo(cvode_mem, rootsfound)
        println("roots=", rootsfound)
    elseif flag == Sundials.CV_SUCCESS
        global iout += 1
        global tout *= tmult
    end
end

empty!(cvode_mem)
empty!(mat_handle)
empty!(LS_handle)
Sundials.SUNContext_Free(ctx)

using Sundials

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]

## Adapted from  doc/libsundials-serial-dev/examples/ida/serial/idaRoberts_dns.c and
##               sundialsTB/ida/examples_ser/midasRoberts_dns.m

## /*
##  * -----------------------------------------------------------------
##  * $Revision: 1.2 $
##  * $Date: 2009/01/21 21:46:40 $
##  * -----------------------------------------------------------------
##  * Programmer(s): Allan Taylor, Alan Hindmarsh and
##  *                Radu Serban @ LLNL
##  * -----------------------------------------------------------------
##  * This simple example problem for IDA, due to Robertson,
##  * is from chemical kinetics, and consists of the following three
##  * equations:
##  *
##  *      dy1/dt = -.04*y1 + 1.e4*y2*y3
##  *      dy2/dt = .04*y1 - 1.e4*y2*y3 - 3.e7*y2**2
##  *         0   = y1 + y2 + y3 - 1
##  *
##  * on the interval from t = 0.0 to t = 4.e10, with initial
##  * conditions: y1 = 1, y2 = y3 = 0.
##  *
##  * While integrating the system, we also use the rootfinding
##  * feature to find the points at which y1 = 1e-4 or at which
##  * y3 = 0.01.
##  *
##  * The problem is solved with IDA using IDADENSE for the linear
##  * solver, with a user-supplied Jacobian. Output is printed at
##  * t = .4, 4, 40, ..., 4e10.
##  * -----------------------------------------------------------------
##  */

using Sundials

## Define the system residual function.
function resrob(tres, yy_nv, yp_nv, rr_nv, user_data)
    yy = convert(Vector, yy_nv)
    yp = convert(Vector, yp_nv)
    rr = convert(Vector, rr_nv)
    rr[1] = -0.04 * yy[1] + 1.0e4 * yy[2] * yy[3]
    rr[2] = -rr[1] - 3.0e7 * yy[2] * yy[2] - yp[2]
    rr[1] -= yp[1]
    rr[3] = yy[1] + yy[2] + yy[3] - 1.0
    return Sundials.IDA_SUCCESS
end

resrob_C = @cfunction(
    resrob, Cint,
    (
        Sundials.realtype, Sundials.N_Vector, Sundials.N_Vector,
        Sundials.N_Vector, Ptr{Cvoid},
    )
)

## Root function routine. Compute functions g_i(t,y) for i = 0,1.
function grob(t, yy_nv, yp_nv, gout_ptr, user_data)
    yy = convert(Vector, yy_nv)
    gout = Sundials.asarray(gout_ptr, (2,))
    gout[1] = yy[1] - 0.0001
    gout[2] = yy[3] - 0.01
    return Sundials.IDA_SUCCESS
end

grob_C = @cfunction(
    grob, Cint,
    (
        Sundials.realtype, Sundials.N_Vector, Sundials.N_Vector,
        Ptr{Sundials.realtype}, Ptr{Cvoid},
    )
)

## Define the Jacobian function. BROKEN - JJ is wrong
function jacrob(Neq, tt, cj, yy, yp, resvec, JJ, user_data, tempv1, tempv2, tempv3)
    JJ = pointer_to_array(convert(Ptr{Float64}, JJ), (3, 3))
    JJ[1, 1] = -0.04 - cj
    JJ[2, 1] = 0.04
    JJ[3, 1] = 1.0
    JJ[1, 2] = 1.0e4 * yy[3]
    JJ[2, 2] = -1.0e4 * yy[3] - 6.0e7 * yy[2] - cj
    JJ[3, 2] = 1.0
    JJ[1, 3] = 1.0e4 * yy[2]
    JJ[2, 3] = -1.0e4 * yy[2]
    JJ[3, 3] = 1.0
    return Sundials.IDA_SUCCESS
end

neq = 3
nout = 12
t0 = 0.0
yy0 = [1.0, 0.0, 0.0]
yp0 = [-0.04, 0.04, 0.0]
rtol = 1.0e-4
avtol = [1.0e-8, 1.0e-14, 1.0e-6]
tout1 = 0.4

mem = Sundials.IDACreate(ctx)
yy0_nvec = Sundials.NVector(yy0, ctx)
yp0_nvec = Sundials.NVector(yp0, ctx)
Sundials.@checkflag Sundials.IDAInit(mem, resrob_C, t0, yy0_nvec, yp0_nvec)
avtol_nvec = Sundials.NVector(avtol, ctx)
Sundials.@checkflag Sundials.IDASVtolerances(mem, rtol, avtol_nvec)

## Call IDARootInit to specify the root function grob with 2 components
Sundials.@checkflag Sundials.IDARootInit(mem, 2, grob_C)

## Call IDADense and set up the linear solver.
A = Sundials.SUNDenseMatrix(length(yy0), length(yy0), ctx)
LS = Sundials.SUNLinSol_Dense(yy0_nvec, A, ctx)
Sundials.@checkflag Sundials.IDADlsSetLinearSolver(mem, LS, A)

iout = 0
tout = tout1
tret = [1.0]

while iout < nout
    yy = similar(yy0)
    yp = similar(yp0)
    yy_nvec = Sundials.NVector(yy, ctx)
    yp_nvec = Sundials.NVector(yp, ctx)
    retval = Sundials.IDASolve(mem, tout, tret, yy_nvec, yp_nvec, Sundials.IDA_NORMAL)
    copyto!(yy, yy_nvec.v)
    copyto!(yp, yp_nvec.v)
    println("T=", tout, ", Y=", yy)
    if retval == Sundials.IDA_ROOT_RETURN
        rootsfound = zeros(Cint, 2)
        Sundials.@checkflag Sundials.IDAGetRootInfo(mem, rootsfound)
        println("roots=", rootsfound)
    elseif retval == Sundials.IDA_SUCCESS
        global iout += 1
        global tout *= 10.0
    end
end

Sundials.SUNLinSolFree_Dense(LS)
Sundials.SUNMatDestroy_Dense(A)

# Clean up context
Sundials.SUNContext_Free(ctx)

using Sundials, Test
import ODEProblemLibrary: prob_ode_linear, prob_ode_2Dlinear

prob = prob_ode_linear
dt = 1 // 2^(4)
saveat = float(collect(0:dt:1))
sol = solve(prob, CVODE_BDF())
sol = solve(prob, CVODE_Adams())
@test sol.errors[:l2] < 1.0e-3
sol = solve(prob, CVODE_Adams(); reltol = 1.0e-5)
@test sol.errors[:l2] < 1.0e-5
sol = solve(prob, CVODE_Adams(); reltol = 1.0e-5, abstol = [1.0e-7])
sol = solve(prob, CVODE_Adams(); saveat = saveat)

@test sol.t == saveat

sol = solve(prob, CVODE_Adams(); saveat = dt)

@test sol.t == saveat

sol = solve(prob, CVODE_Adams(); saveat = saveat, save_everystep = true)

@test sol.t != saveat
@test intersect(sol.t, saveat) == saveat

sol = solve(prob, CVODE_Adams(); saveat = saveat, save_everystep = true, save_start = false)

@test sol.t[1] != 0

sol = solve(prob, CVODE_Adams(); tstops = [0.2, 0.5, 0.7])
@test all(t in sol.t for t in [0.2, 0.5, 0.7])

prob = prob_ode_2Dlinear
sol = solve(prob, CVODE_BDF())
sol = solve(prob, CVODE_Adams())
sol = solve(prob, CVODE_Adams(); saveat = saveat)

@test sol.t == saveat

sol = solve(prob, CVODE_Adams(); saveat = [prob.tspan[2]])

@test sol.t == [prob.tspan[2]]

sol = solve(prob, CVODE_Adams(); saveat = saveat, save_everystep = false)

@test sol.t == saveat

for tstops in [0.9, [0.9]]
    local sol = solve(prob, CVODE_Adams(); tstops)
    @test 0.9 ∈ sol.t
end

sol = solve(prob, CVODE_Adams())
sol_idxs = solve(prob, CVODE_Adams(); save_idxs = [1], timeseries_errors = false)

@test sol[1, :] == sol_idxs[1, :]

sol_idxs = solve(
    prob, CVODE_Adams(); save_idxs = [1, 2], timeseries_errors = false,
    calculate_error = false
)
@test length(sol_idxs[:, 1]) == 2
@test sol[1, :] == sol_idxs[1, :]
@test sol[2, :] == sol_idxs[2, :]

# Test the other function conversions
k = (du, u, p, t) -> du[1] = u[1]
prob = ODEProblem(k, [1.0], (0.0, 1.0))
sol = solve(prob, CVODE_BDF())
h = (u, p, t) -> u
u0 = [
    1.0 2.0
    3.0 2.0
]
prob = ODEProblem(h, u0, (0.0, 1.0))
sol = solve(prob, CVODE_BDF())

# Test Algorithm Choices
sol1 = solve(prob, CVODE_BDF(; method = :Functional))
sol2 = solve(prob, CVODE_BDF(; linear_solver = :Band, jac_upper = 3, jac_lower = 3))
sol3 = solve(prob, CVODE_BDF(; linear_solver = :Diagonal))
sol4 = solve(prob, CVODE_BDF(; linear_solver = :GMRES))
sol5 = solve(prob, CVODE_BDF(; linear_solver = :FGMRES))
sol6 = solve(prob, CVODE_BDF(; linear_solver = :PCG))
sol7 = solve(prob, CVODE_BDF(; linear_solver = :BCG))
sol8 = solve(prob, CVODE_BDF(; linear_solver = :TFQMR))
sol9 = solve(prob, CVODE_BDF(; linear_solver = :Dense))
# sol12 = solve(prob, CVODE_BDF(; linear_solver = :KLU)) # Requires sparse Jacobian prototype
# Testing LapackDense/LapackBand solvers
sol10 = solve(prob, CVODE_BDF(; linear_solver = :LapackDense))
sol11 = solve(prob, CVODE_BDF(; linear_solver = :LapackBand, jac_upper = 3, jac_lower = 3))

@test isapprox(sol1.u[end], sol2.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol3.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol4.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol5.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol6.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol7.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol8.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol9.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol10.u[end]; rtol = 1.0e-3)
@test isapprox(sol1.u[end], sol11.u[end]; rtol = 1.0e-3)

# Test identity preconditioner
global prec_used = false
global psetup_used = false
prec = (z, r, p, t, y, fy, gamma, delta, lr) -> (global prec_used = true; z .= r)
psetup = (
    p, t, u, du, jok, jcurPtr, gamma,
) -> (global psetup_used = true; jcurPtr[] = false)
sol4 = solve(prob, CVODE_BDF(; linear_solver = :GMRES, prec_side = 3, prec = prec))
@test isapprox(sol1.u[end], sol4.u[end]; rtol = 1.0e-3)
@test prec_used
sol4 = solve(
    prob,
    CVODE_BDF(;
        linear_solver = :GMRES, prec_side = 3, prec = prec,
        psetup = psetup
    )
)
@test isapprox(sol1.u[end], sol4.u[end]; rtol = 1.0e-3)
@test psetup_used

# Backwards
prob = deepcopy(prob_ode_2Dlinear)
prob2 = ODEProblem(prob.f, prob.u0, (1.0, 0.0), 1.01)
sol = solve(prob2, CVODE_BDF())
@test maximum(diff(sol.t)) < 0 # Make sure all go negative

number_test(u, p, t) = -u^2 + (p[1] + t + p[2]) * u + p[2]
u0 = 0.0;
tspan = (0.0, 10)
prob = ODEProblem(number_test, u0, tspan, (2.0, 0.01))
sol = solve(prob, CVODE_BDF())

sol = solve(prob2, CVODE_BDF(); maxiters = 1)
@test length(sol.t) == 2

using Sundials, Test, SparseArrays

# Test for Jacobian usage
function Lotka(du, u, p, t)
    du[1] = u[1] - u[1] * u[2] # REPL[7], line 3:
    du[2] = -3 * u[2] + 1 * u[1] * u[2]
    return nothing
end

jac_called = false
function Lotka_jac(J, u, p, t)
    global jac_called
    jac_called = true
    J[1, 1] = 1.0 - u[2]
    J[1, 2] = -u[1]
    J[2, 1] = 1 * u[2]
    J[2, 2] = -3 + u[1]
    return nothing
end

Lotka_f = ODEFunction(Lotka; jac = Lotka_jac)
prob = ODEProblem(Lotka_f, ones(2), (0.0, 10.0))
good_sol = solve(prob, CVODE_BDF())
testsol = solve(prob, CVODE_BDF(), saveat = 0.1, abstol = 1.0e-12, reltol = 1.0e-12)
@test jac_called == true

Lotka_f = ODEFunction(
    Lotka;
    jac = Lotka_jac,
    jac_prototype = sparse([1, 2, 1, 2], [1, 1, 2, 2], zeros(4))
)

prob = ODEProblem(Lotka_f, ones(2), (0.0, 10.0))
jac_called = false
sol9_klu = solve(prob, CVODE_BDF(; linear_solver = :KLU))
@test jac_called == true
@test Array(sol9_klu) ≈ Array(good_sol)

# Use Dense solver instead for this Jacobian test
sol9 = solve(prob, CVODE_BDF(; linear_solver = :Dense))
@test jac_called == true
@test Array(sol9) ≈ Array(good_sol)

# JacVec test removed - was dependent on SparseDiffTools which has been replaced

function f2!(res, du, u, p, t)
    res[1] = 1.01du[1]
    return
end

jac_called = false
function f2_jac!(out, du, u, p, gamma, t)
    global jac_called
    jac_called = true
    return out[1] = 1.01
end

f2_f = DAEFunction(f2!; jac = f2_jac!)

u0 = [0.0]
tspan = (0.0, 10.0)
du0 = [0.0]
dae_prob = DAEProblem(f2_f, du0, u0, tspan; differential_vars = [true])
good_sol = solve(dae_prob, IDA())
@test jac_called == true

function testjac(res, du, u, p, t)
    res[1] = du[1] - 1.5 * u[1] + 1.0 * u[1] * u[2]
    return res[2] = du[2] + 3 * u[2] - u[1] * u[2]
end

jac_called = false
function testjac_jac(J, du, u, p, gamma, t)
    global jac_called
    jac_called = true
    J[1, 1] = gamma - 1.5 + 1.0 * u[2]
    J[1, 2] = 1.0 * u[1]
    J[2, 1] = -1 * u[2]
    J[2, 2] = gamma + 3 - u[1]
    return nothing
end

testjac_f = DAEFunction(testjac; jac = testjac_jac)

prob3 = DAEProblem(
    testjac_f,
    [0.5, -2.0],
    ones(2),
    (0.0, 10.0);
    differential_vars = [true, true]
)
sol3 = solve(prob3, IDA())

@test jac_called == true
jac_called = false
prob4 = DAEProblem(testjac, [0.5, -2.0], ones(2), (0.0, 10.0))
sol4 = solve(prob4, IDA())

@test jac_called == false

@test maximum(sol3 - sol4) < 1.0e-6

function testjac(res, du, u, p, t)
    res[1] = du[1] - 1.5 * u[1] + 1.0 * u[1] * u[2]
    return res[2] = du[2] + 3 * u[2] - u[1] * u[2]
end

jac_called = false
function testjac_jac(J, du, u, p, gamma, t)
    global jac_called
    jac_called = true
    J[1, 1] = gamma - 1.5 + 1.0 * u[2]
    J[1, 2] = 1.0 * u[1]
    J[2, 1] = -1 * u[2]
    J[2, 2] = gamma + 3 - u[1]
    return nothing
end

testjac_f = DAEFunction(
    testjac;
    jac = testjac_jac,
    jac_prototype = sparse([1, 2, 1, 2], [1, 1, 2, 2], zeros(4))
)

prob5 = DAEProblem(
    testjac_f,
    [0.5, -2.0],
    ones(2),
    (0.0, 10.0);
    differential_vars = [true, true]
)
sol5 = solve(prob5, IDA())

testjac_f = DAEFunction(
    testjac;
    jac = testjac_jac,
    jac_prototype = sparse([1, 2, 1, 2], [1, 1, 2, 2], zeros(4))
)
prob6 = DAEProblem(
    testjac_f,
    [0.5, -2.0],
    ones(2),
    (0.0, 10.0);
    differential_vars = [true, true]
)
sol6 = solve(prob6, IDA(; linear_solver = :KLU))
if sol5.retcode == ReturnCode.Success && sol6.retcode == ReturnCode.Success &&
        length(sol5.u) == length(sol6.u)
    max_diff = maximum(maximum(abs.(sol5.u[i] - sol6.u[i])) for i in 1:length(sol5.u))
    @test max_diff < 1.0e-6
else
    @test_skip maximum(sol5 - sol6) < 1.0e-6
end

##################################################################
#
# Simplified interfaces that only uses Julia vectors and functions.
#
##################################################################

"""
    Insert a check that the given function call returns 0,
    throw an error otherwise. Only apply directly to function calls.
"""
macro checkflag(ex, throw_error = false, verbose = nothing)
    @assert Base.Meta.isexpr(ex, :call)
    fname = ex.args[1]
    fname_str = string(fname)
    msg_expr = :($fname_str * " failed with error code = " * string(flag))
    return quote
        flag = $(esc(ex))
        if flag < 0
            if $(esc(throw_error))
                @error($(string(fname, " failed with error code = ")), flag)
            elseif $(esc(verbose)) !== nothing
                @SciMLMessage(() -> $msg_expr, $(esc(verbose)), :instability)
            end
        end
        flag
    end
end

mutable struct UserFunctionAndData{F}
    func::F
    data::Any

    UserFunctionAndData{F}(func, data) where {F} = new{F}(func, data)
end

UserFunctionAndData(func) = func
UserFunctionAndData(func, data::Nothing) = func

# Enable accessing the struct via userfun[] syntax
Base.getindex(userfun::UserFunctionAndData) = userfun

function kinsolfun(y::N_Vector, fy::N_Vector, userfun::UserFunctionAndData)
    userfun[].func(convert(Vector, fy), convert(Vector, y), userfun[].data)
    return KIN_SUCCESS
end

function kinsolfun(y::N_Vector, fy::N_Vector, userfun)
    userfun(convert(Vector, fy), convert(Vector, y))
    return KIN_SUCCESS
end

function ___kinsol(
        f,
        y0::Vector{Float64};
        userdata::Any = nothing,
        linear_solver::Symbol = :Dense,
        jac_upper::Int = 0,
        jac_lower::Int = 0,
        abstol::Float64 = eps(Float64)^(4 // 5),
        prec_side::Int = 0,
        krylov_dim::Int = 0,
        jac_prototype = nothing,
        maxiters = 1000,
        strategy = :None,
        maxsetupcalls = 0
    )
    # f, Function to be optimized of the form f(y::Vector{Float64}, fy::Vector{Float64})
    #    where `y` is the input vector, and `fy` is the result of the function
    # y0, Vector of initial values
    # return: the solution vector
    ctx_ptr = Ref{SUNContext}(C_NULL)
    SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{SUNContext}, ctx_ptr))
    ctx = ctx_ptr[]
    mem_ptr = KINCreate(ctx)
    (mem_ptr == C_NULL) && error("Failed to allocate KINSOL solver object")
    kmem = Handle(mem_ptr)

    y = copy(y0)

    # use the user_data field to pass a function
    #   see: https://github.com/JuliaLang/julia/issues/2554
    userfun = UserFunctionAndData(f, userdata)
    function getcfun(userfun::T) where {T}
        return @cfunction(kinsolfun, Cint, (N_Vector, N_Vector, Ref{T}))
    end
    y0_nvec = NVector(y0, ctx)
    flag = @checkflag KINInit(kmem, getcfun(userfun), y0_nvec) true
    if linear_solver == :Dense
        A = Sundials.SUNDenseMatrix(length(y0), length(y0), ctx)
        LS = Sundials.SUNLinSol_Dense(y0_nvec, A, ctx)
    elseif linear_solver == :LapackDense
        A = Sundials.SUNDenseMatrix(length(y0), length(y0), ctx)
        LS = Sundials.SUNLinSol_LapackDense(y0_nvec, A, ctx)
    elseif linear_solver == :Band
        A = Sundials.SUNBandMatrix(length(y0), jac_upper, jac_lower, ctx)
        LS = Sundials.SUNLinSol_Band(y0_nvec, A, ctx)
    elseif linear_solver == :LapackBand
        A = Sundials.SUNBandMatrix(length(y0), jac_upper, jac_lower, ctx)
        LS = Sundials.SUNLinSol_LapackBand(y0_nvec, A, ctx)
    elseif linear_solver == :GMRES
        A = C_NULL
        LS = Sundials.SUNLinSol_SPGMR(y0_nvec, Cint(prec_side), Cint(krylov_dim), ctx)
    elseif linear_solver == :FGMRES
        A = C_NULL
        LS = Sundials.SUNLinSol_SPFGMR(y0_nvec, Cint(prec_side), Cint(krylov_dim), ctx)
    elseif linear_solver == :BCG
        A = C_NULL
        LS = Sundials.SUNLinSol_SPBCGS(y0_nvec, Cint(prec_side), Cint(krylov_dim), ctx)
    elseif linear_solver == :PCG
        A = C_NULL
        LS = Sundials.SUNLinSol_PCG(y0_nvec, Cint(prec_side), Cint(krylov_dim), ctx)
    elseif linear_solver == :TFQMR
        A = C_NULL
        LS = Sundials.SUNLinSol_SPTFQMR(y0_nvec, Cint(prec_side), Cint(krylov_dim), ctx)
    elseif linear_solver == :KLU
        nnz = length(SparseArrays.nonzeros(jac_prototype))
        A = Sundials.SUNSparseMatrix(length(y0), length(y0), nnz, CSC_MAT, ctx)
        LS = SUNLinSol_KLU(y0_nvec, A, ctx)
    else
        error("Unknown linear solver")
    end
    flag = @checkflag KINSetFuncNormTol(kmem, abstol) true
    flag = @checkflag KINSetLinearSolver(kmem, LS, A) true
    flag = @checkflag KINSetUserData(kmem, userfun) true
    flag = @checkflag KINSetNumMaxIters(kmem, maxiters) true
    flag = @checkflag KINSetMaxSetupCalls(kmem, maxsetupcalls) true
    ## Solve problem
    scale = ones(length(y0))
    scale_nvec = NVector(scale, ctx)
    if strategy == :None
        strategy = KIN_NONE
    elseif strategy == :LineSearch
        strategy = KIN_LINESEARCH
    else
        error("Unknown strategy")
    end
    ynv = NVector(y, ctx)
    flag = @checkflag KINSol(kmem, ynv, strategy, scale_nvec, scale_nvec) true
    y = convert(Vector, ynv)

    # Clean up context
    SUNContext_Free(ctx)

    return y, flag
end
kinsol(args...; kwargs...) = first(___kinsol(args...; kwargs...))

function cvodefun(t::Float64, y::N_Vector, yp::N_Vector, userfun::UserFunctionAndData)
    userfun.func(t, convert(Vector, y), convert(Vector, yp), userfun.data)
    return CV_SUCCESS
end

function cvodefun(t::Float64, y::N_Vector, yp::N_Vector, userfun)
    userfun(t, convert(Vector, y), convert(Vector, yp))
    return CV_SUCCESS
end

"""
`cvode(f, y0::Vector{Float64}, t::Vector{Float64}, userdata::Any=nothing;
       integrator=:BDF, reltol::Float64=1e-3, abstol::Float64=1e-6, callback=(mem,t,y)->true)`

* `f`, Function of the form
  `f(t, y::Vector{Float64}, yp::Vector{Float64})`
  where `y` is the input state vector, and `yp` is the output vector
  of time derivatives for the states `y`
* `y0`, Vector of initial values
* `t`, Vector of time values at which to record integration results
* `integrator`, the chosen integration algorithm. Default is `:BDF`
  , other option is `:Adams`
* `reltol`, Relative Tolerance to be used (default=1e-3)
* `abstol`, Absolute Tolerance to be used (default=1e-6)
* `callback`, Callback function of the form
  `callback(mem, t_k::Float64, y_k::Vector{Float64})::Bool`
  where `mem` is the integrator and `t_k`/`y_k` the time/state at timestep `k`.
  A return value of `false` exits the integrator at timestep `k` and returns the all the timesteps preceding `k`.
  (default=(mem,t_k,y_k)->true)

return: a solution matrix with time steps in `t` along rows and
        state variable `y` along columns
"""
function cvode(
        f::Function,
        y0::Vector{Float64},
        t::AbstractVector,
        userdata::Any = nothing;
        kwargs...
    )
    y = zeros(length(t), length(y0))
    n = cvode!(f, y, y0, t, userdata; kwargs...)
    return y[1:n, :]
end

function cvode!(
        f::Function,
        y::Matrix{Float64},
        y0::Vector{Float64},
        t::AbstractVector,
        userdata::Any = nothing;
        integrator = :BDF,
        reltol::Float64 = 1.0e-3,
        abstol::Float64 = 1.0e-6,
        callback = (x, y, z) -> true
    )
    ctx_ptr = Ref{SUNContext}(C_NULL)
    SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{SUNContext}, ctx_ptr))
    ctx = ctx_ptr[]
    if integrator == :BDF
        mem_ptr = CVodeCreate(CV_BDF, ctx)
    elseif integrator == :Adams
        mem_ptr = CVodeCreate(CV_ADAMS, ctx)
    else
        error("integrator must be :BDF or :Adams, got: $integrator")
    end

    (mem_ptr == C_NULL) && error("Failed to allocate CVODE solver object")
    mem = Handle(mem_ptr)

    c = 1

    userfun = UserFunctionAndData(f, userdata)
    y0nv = NVector(y0, ctx)

    function getcfun(userfun::T) where {T}
        return @cfunction(cvodefun, Cint, (realtype, N_Vector, N_Vector, Ref{T}))
    end
    flag = @checkflag CVodeInit(mem, getcfun(userfun), t[1], y0nv) true

    flag = @checkflag CVodeSetUserData(mem, userfun) true
    flag = @checkflag CVodeSStolerances(mem, reltol, abstol) true
    A = Sundials.SUNDenseMatrix(length(y0), length(y0), ctx)
    LS = Sundials.SUNLinSol_Dense(y0nv, A, ctx)
    flag = Sundials.@checkflag Sundials.CVDlsSetLinearSolver(mem, LS, A) true

    y[1, :] = y0
    ynv = NVector(copy(y0), ctx)
    tout = [0.0]
    for k in 2:length(t)
        flag = @checkflag CVode(mem, t[k], ynv, tout, CV_NORMAL) true
        if !callback(mem, t[k], ynv)
            break
        end
        y[k, :] = convert(Vector, ynv)
        c = c + 1
    end

    Sundials.SUNLinSolFree_Dense(LS)
    Sundials.SUNMatDestroy_Dense(A)
    SUNContext_Free(ctx)

    return c
end

function idasolfun(
        t::Float64,
        y::N_Vector,
        yp::N_Vector,
        r::N_Vector,
        userfun::UserFunctionAndData
    )
    userfun.func(
        t,
        convert(Vector, y),
        convert(Vector, yp),
        convert(Vector, r),
        userfun.data
    )
    return IDA_SUCCESS
end

function idasolfun(t::Float64, y::N_Vector, yp::N_Vector, r::N_Vector, userfun)
    userfun(t, convert(Vector, y), convert(Vector, yp), convert(Vector, r))
    return IDA_SUCCESS
end

"""
`idasol(f, y0::Vector{Float64}, yp0::Vector{Float64}, t::Vector{Float64}, userdata::Any=nothing;
        reltol::Float64=1e-3, abstol::Float64=1e-6, diffstates::Union{Vector{Bool},Void}=nothing)`

* `f`, Function of the form
  `f(t, y::Vector{Float64}, yp::Vector{Float64}, r::Vector{Float64})``
  where `y` and `yp` are the input state and derivative vectors,
  and `r` is the output residual vector
* `y0`, Vector of initial values
* `yp0`, Vector of initial values of the derivatives
* `reltol`, Relative Tolerance to be used (default=1e-3)
* `abstol`, Absolute Tolerance to be used (default=1e-6)
* `diffstates`, Boolean vector, true for the positions such that `r` depends on `yp[k]`

return: (y,yp) two solution matrices representing the states and state derivatives
         with time steps in `t` along rows and state variable `y` or `yp` along columns
"""
function idasol(
        f,
        y0::Vector{Float64},
        yp0::Vector{Float64},
        t::Vector{Float64},
        userdata::Any = nothing;
        reltol::Float64 = 1.0e-3,
        abstol::Float64 = 1.0e-6,
        diffstates::Union{Vector{Bool}, Nothing} = nothing
    )
    ctx_ptr = Ref{SUNContext}(C_NULL)
    SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{SUNContext}, ctx_ptr))
    ctx = ctx_ptr[]
    mem_ptr = IDACreate(ctx)
    (mem_ptr == C_NULL) && error("Failed to allocate IDA solver object")
    mem = Handle(mem_ptr)

    yres = zeros(length(t), length(y0))
    ypres = zeros(length(t), length(y0))

    userfun = UserFunctionAndData(f, userdata)

    function getcfun(userfun::T) where {T}
        return @cfunction(idasolfun, Cint, (realtype, N_Vector, N_Vector, N_Vector, Ref{T}))
    end
    y0nv = NVector(y0, ctx)
    yp0nv = NVector(yp0, ctx)
    flag = @checkflag IDAInit(mem, getcfun(userfun), t[1], y0nv, yp0nv) true
    flag = @checkflag IDASetUserData(mem, userfun) true
    flag = @checkflag IDASStolerances(mem, reltol, abstol) true

    A = Sundials.SUNDenseMatrix(length(y0), length(y0), ctx)
    LS = Sundials.SUNLinSol_Dense(y0nv, A, ctx)
    flag = Sundials.@checkflag Sundials.IDADlsSetLinearSolver(mem, LS, A) true

    rtest = zeros(length(y0))
    f(t[1], y0, yp0, rtest)
    if any(abs.(rtest) .>= reltol)
        if diffstates === nothing
            error("Must supply diffstates argument to use IDA initial value solver.")
        end
        flag = @checkflag IDASetId(mem, collect(Float64, diffstates)) true
        flag = @checkflag IDACalcIC(mem, IDA_YA_YDP_INIT, t[2]) true
    end
    yres[1, :] = y0
    ypres[1, :] = yp0
    ynv = NVector(copy(y0), ctx)
    ypnv = NVector(copy(yp0), ctx)
    tout = [0.0]
    for k in 2:length(t)
        retval = @checkflag IDASolve(mem, t[k], tout, ynv, ypnv, IDA_NORMAL) true
        yres[k, :] = convert(Vector, ynv)
        ypres[k, :] = convert(Vector, ypnv)
    end

    Sundials.SUNLinSolFree_Dense(LS)
    Sundials.SUNMatDestroy_Dense(A)
    SUNContext_Free(ctx)

    return yres, ypres
end

# Example based on https://github.com/LLNL/sundials/blob/master/examples/arkode/C_serial/ark_twowaycouple_mri.c

# Create context for tests
ctx_ptr = Ref{Sundials.SUNContext}(C_NULL)
Sundials.SUNContext_Create(C_NULL, Base.unsafe_convert(Ptr{Sundials.SUNContext}, ctx_ptr))
ctx = ctx_ptr[]
#=
/* ----------------------------------------------------------------
 * Programmer(s): David J. Gardner @ LLNL
 * ----------------------------------------------------------------
 * Based a linear example program by Rujeko Chinomona @ SMU.
 * ----------------------------------------------------------------
 * SUNDIALS Copyright Start
 * Copyright (c) 2002-2020, Lawrence Livermore National Security
 * and Southern Methodist University.
 * All rights reserved.
 *
 * See the top-level LICENSE and NOTICE files for details.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 * SUNDIALS Copyright End
 * ----------------------------------------------------------------
 * Example problem:
 *
 * This example simulates an ODE system with 3 components,
 * Y = [u,v,w], given by the equations,
 *
 *   du/dt =  100v+w
 *   dv/dt = -100u
 *   dw/dt = -w+u
 *
 * for t in the interval [0.0, 2.0] with initial conditions
 * u(0)=9001/10001, v(0)=-1e-5/10001, and w(0)=1000. In this problem
 * the slow (w) and fast (u and v) components depend on one another.
 *
 * This program solves the problem with the MRI stepper. Outputs are
 * printed at equal intervals of 0.1 and run statistics are printed
 * at the end.
 * ----------------------------------------------------------------*/
=#

using Sundials # Test

function ff(t, y_nv, ydot_nv, user_data)
    y = convert(Vector, y_nv)
    ydot = convert(Vector, ydot_nv)
    ydot[1] = 100.0 * y[2]
    ydot[2] = -100.0 * y[1]
    ydot[3] = y[1]
    return Sundials.ARK_SUCCESS
end

function fs(t, y_nv, ydot_nv, user_data)
    y = convert(Vector, y_nv)
    ydot = convert(Vector, ydot_nv)
    ydot[1] = y[3]
    ydot[2] = 0.0
    ydot[3] = -y[3]
    return Sundials.ARK_SUCCESS
end

T0 = 0.0
Tf = 2.0
dTout = 0.1
Neq = 3
Nt = ceil(Tf / dTout)
hs = 0.001
hf = 0.00002
y0 = [0.90001, -9.999, 1000.0]

# Fast Integration portion
y0_nvec = Sundials.NVector(y0, ctx)
_mem_ptr = Sundials.ARKStepCreate(ff, C_NULL, T0, y0_nvec, ctx);
inner_arkode_mem = Sundials.Handle(_mem_ptr)
Sundials.@checkflag Sundials.ARKStepSetTableNum(
    inner_arkode_mem,
    -1,
    Sundials.KNOTH_WOLKE_3_3
)
Sundials.@checkflag Sundials.ARKStepSetFixedStep(inner_arkode_mem, hf)

# Slow integrator portion
_arkode_mem_ptr = Sundials.MRIStepCreate(
    fs, T0, y0_nvec, Sundials.MRISTEP_ARKSTEP, inner_arkode_mem, ctx
)
arkode_mem = Sundials.Handle(_arkode_mem_ptr)
Sundials.@checkflag Sundials.MRIStepSetFixedStep(arkode_mem, hs)

t = [T0]
tout = T0 + dTout
res = Dict(0 => y0)
for i in 1:Nt
    y = similar(y0)
    y_nvec = Sundials.NVector(y, ctx)
    global retval = Sundials.MRIStepEvolve(arkode_mem, tout, y_nvec, t, Sundials.ARK_NORMAL)
    copyto!(y, y_nvec.v)
    global tout += dTout
    global tout = (tout > Tf) ? Tf : tout
    res[i] = y
end

for i in 1:3
    sol_1 = [-0.927671 -8.50006 904.786828]
    sol_end = [0.547358 -0.523577 135.169441]
    @test isapprox(res[1][i], sol_1[i]; atol = 1.0e-3)
    @test isapprox(res[Nt][i], sol_end[i]; atol = 1.0e-3)
end

# Clean up context
Sundials.SUNContext_Free(ctx)

using SciMLBase, Sundials, Test

function f_iip(du, u, p)
    du[1] = 2 - 2u[1]
    return du[2] = u[1] - 4u[2]
end

u0 = zeros(2)
prob_iip = NonlinearProblem{true}(f_iip, u0)
abstol = 1.0e-8

@testset "linear_solver = $(linear_solver) | globalization_strategy = $(globalization_strategy)" for linear_solver in
        (
            :Dense,
            :LapackDense, :GMRES, :FGMRES, :BCG, :PCG, :TFQMR,
        ),
        globalization_strategy in (:LineSearch, :None)

    local sol
    alg = KINSOL(; linear_solver, globalization_strategy)
    sol = solve(prob_iip, alg; abstol)

    if linear_solver == :LapackDense
        @test SciMLBase.successful_retcode(sol.retcode)
        if SciMLBase.successful_retcode(sol.retcode)
            du = zeros(2)
            f_iip(du, sol.u, nothing)
            @test maximum(abs, du) < 1.0e-6
        end
    else
        @test SciMLBase.successful_retcode(sol.retcode)
        du = zeros(2)
        f_iip(du, sol.u, nothing)
        @test maximum(abs, du) < 1.0e-6
    end
end

# OOP Tests
f_oop(u, p) = [2 - 2u[1], u[1] - 4u[2]]
u0 = zeros(2)
prob_oop = NonlinearProblem{false}(f_oop, u0)

@testset "linear_solver = $(linear_solver) | globalization_strategy = $(globalization_strategy)" for linear_solver in
        (
            :Dense,
            :LapackDense, :GMRES, :FGMRES, :BCG, :PCG, :TFQMR,
        ),
        globalization_strategy in (:LineSearch, :None)

    local sol
    alg = KINSOL(; linear_solver, globalization_strategy)
    sol = solve(prob_oop, alg; abstol)

    if linear_solver == :LapackDense
        @test SciMLBase.successful_retcode(sol.retcode)
        if SciMLBase.successful_retcode(sol.retcode)
            du = zeros(2)
            f_oop(sol.u, nothing)
            @test maximum(abs, du) < 1.0e-6
        end

        # Pure Newton Steps
        alg = KINSOL(; linear_solver, globalization_strategy, maxsetupcalls = 1)
        sol = solve(prob_oop, alg; abstol)
        @test SciMLBase.successful_retcode(sol.retcode)
        if SciMLBase.successful_retcode(sol.retcode)
            du = zeros(2)
            f_oop(sol.u, nothing)
            @test maximum(abs, du) < 1.0e-6
        end
    else
        @test SciMLBase.successful_retcode(sol.retcode)
        du = zeros(2)
        f_oop(sol.u, nothing)
        @test maximum(abs, du) < 1.0e-6

        # Pure Newton Steps
        alg = KINSOL(; linear_solver, globalization_strategy, maxsetupcalls = 1)
        sol = solve(prob_oop, alg; abstol)
        @test SciMLBase.successful_retcode(sol.retcode)
        du = zeros(2)
        f_oop(sol.u, nothing)
        @test maximum(abs, du) < 1.0e-6
    end
end

# Scalar
f_scalar(u, p) = 2 - 2u
u0 = 0.0
prob_scalar = NonlinearProblem{false}(f_scalar, u0)

@testset "linear_solver = $(linear_solver) | globalization_strategy = $(globalization_strategy)" for linear_solver in
        (
            :Dense,
            :LapackDense, :GMRES, :FGMRES, :PCG, :TFQMR,
        ),
        globalization_strategy in (:LineSearch, :None)

    local sol
    alg = KINSOL(; linear_solver, globalization_strategy)
    sol = solve(prob_scalar, alg; abstol)

    if linear_solver == :LapackDense
        @test SciMLBase.successful_retcode(sol.retcode)
        @test sol.u isa Number
        if SciMLBase.successful_retcode(sol.retcode)
            resid = f_scalar(sol.u, nothing)
            @test abs(resid) < 1.0e-6
        end
    else
        @test SciMLBase.successful_retcode(sol.retcode)
        @test sol.u isa Number
        resid = f_scalar(sol.u, nothing)
        @test abs(resid) < 1.0e-6
    end
end

# Sundials.jl

Sundials.jl provides SciML common-interface wrappers for the SUNDIALS C library,
including CVODE, ARKODE, IDA, and KINSOL algorithms.

## Installation

```julia
using Pkg
Pkg.add("Sundials")
```

## Usage

```julia
using Sundials

function lorenz!(du, u, p, t)
    du[1] = 10.0 * (u[2] - u[1])
    du[2] = u[1] * (28.0 - u[3]) - u[2]
    du[3] = u[1] * u[2] - (8 / 3) * u[3]
    return nothing
end

prob = ODEProblem(lorenz!, [1.0, 0.0, 0.0], (0.0, 100.0))
sol = solve(prob, CVODE_Adams())
```

## API

```@docs
CVODE_BDF
CVODE_Adams
ARKODE
IDA
KINSOL
SundialsODEAlgorithm
SundialsDAEAlgorithm
solve
DefaultInit
BrownFullBasicInit
ShampineCollocationInit
```
